﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System.Runtime.InteropServices;
using System;

namespace AcknexWrapper
{
    namespace Native
    {
        internal static class NativeEngFun
        {
            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ang(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sign(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar fraction(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar integer(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar random(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar randomize();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar random_seed(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar absv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sinv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cosv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar tanv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar asinv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar acosv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar atanv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar atan2v(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar expv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar logv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar log10v(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sqrtv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar powv(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar maxv(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar minv(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar fsin(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar fcos(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ftan(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar fasin(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar facos(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar fatan(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar accelerate(NativeVar* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar clamp(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cycle(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar smooth(NativeVar* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar floatv(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar floatd(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar floatr(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_add(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_rotate(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_diff(NativeVector* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_for_axis(NativeVector* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_for_matrix(NativeVector* param0, float* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_to_matrix(NativeVector* param0, float* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar vec_length(NativeVector* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar vec_dist(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar vec_cross(NativeVector* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar vec_dot(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_mul(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_normalize(NativeVector* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_accelerate(NativeVector* param0, NativeVector* param1, NativeVector* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_bounce(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_add(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_diff(NativeVector* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_inverse(NativeVector* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_lerp(NativeVector* param0, NativeVector* param1, NativeVector* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_rotate(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_rotateback(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_rotateaxis(NativeVector* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_scale(NativeVector* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_set(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_fill(NativeVector* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_sub(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_angle(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar vec_to_angle(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_bone(NativeVector* param0, NativeENTITY* param1, char* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* ang_for_bone(NativeVector* param0, NativeENTITY* param1, char* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_normal(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_vertex(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_ent(NativeVector* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_to_ent(NativeVector* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_min(NativeVector* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_max(NativeVector* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_mesh(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_to_mesh(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_uv(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_to_uv(NativeVector* param0, NativeENTITY* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_for_screen(NativeVector* param0, NativeVIEW* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vec_to_screen(NativeVector* param0, NativeVIEW* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* rel_for_screen(NativeVector* param0, NativeVIEW* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* rel_to_screen(NativeVector* param0, NativeVIEW* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* vector(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_create(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_remove(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_cpy(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_cat(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_cat_num(NativeSTRING* param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_clip(NativeSTRING* param0, NativeVar param1);

            //
            /*
             * not necessary (and not easy to implement)!
             * EXT STRING* F(str_printf)(STRING *s1,char *s2,...);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_printf(NativeSTRING* param0, char* param1, __arglist);
             
             */



            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_trunc(NativeSTRING* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_lwr(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_upr(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_cmp(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_cmpi(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_cmpni(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_len(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_chr(NativeSTRING* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_stri(NativeSTRING* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_asc(NativeSTRING* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_to_asc(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_float(NativeSTRING* param0, double param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_int(NativeSTRING* param0, int param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_num(NativeSTRING* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern double str_to_float(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern int str_to_int(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_to_num(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_cursor(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar str_width(char* param0, NativeFONT* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_entname(NativeSTRING* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_entfile(NativeSTRING* param0, NativeENTITY* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_id(NativeSTRING* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_create(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_createblack(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern void bmap_remove(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_for_entity(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_for_screen(NativeBMAP* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_for_buffer(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_for_texture(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* bmap_preload(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* bmap_purge(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_load(NativeBMAP* param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_save(NativeBMAP* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_alpha(NativeBMAP* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_cubemap(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_mipmap(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_normals(NativeBMAP* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_uv(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_to_format(NativeBMAP* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_height(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_width(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_format(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_lock(NativeBMAP* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_unlock(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_blit(NativeBMAP* param0, NativeBMAP* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_blitpart(NativeBMAP* param0, NativeBMAP* param1, NativeVector* param2, NativeVector* param3, NativeVector* param4, NativeVector* param5);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_fill(NativeBMAP* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* bmap_process(NativeBMAP* param0, NativeBMAP* param1, NativeMATERIAL* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_rendertarget(NativeBMAP* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar bmap_zbuffer(NativeBMAP* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pixel_for_bmap(NativeBMAP* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pixel_to_bmap(NativeBMAP* param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pixel_for_vec(NativeVector* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pixel_to_vec(NativeVector* param0, NativeVar* param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cd_play(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cd_pause();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cd_start();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar cd_track();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_play(char* param0, NativeBMAP* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_loop(char* param0, NativeBMAP* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_pause(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_playing(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_start(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_stop(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar media_tune(NativeVar param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSOUND* snd_create(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_remove(NativeSOUND* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_buffer(NativeSOUND* param0, void** param1, void*** param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_play(NativeSOUND* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_loop(NativeSOUND* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_playing(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_pause(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_start(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_stop(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_add(NativeVar param0, NativeVar param1, IntPtr param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_stopall(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar snd_tune(NativeVar param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_playloop(NativeENTITY* param0, NativeSOUND* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_playsound(NativeENTITY* param0, NativeSOUND* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_content(NativeVector* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_scan(NativeVector* param0, NativeVector* param1, NativeVector* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_trace(NativeVector* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_move(NativeENTITY* param0, NativeVector* param1, NativeVector* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_rotate(NativeENTITY* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_setminmax(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar c_updatehull(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar content(NativeVector* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar trace(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_move(NativeVector* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_selectgroup(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_setgravity(NativeVector* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_setcorrections(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_setcollisions(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_setautodisable(NativeVar param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_settype(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addcentralforce(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addforceglobal(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addforcelocal(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addvelcentral(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addvelglobal(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addvellocal(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addtorqueglobal(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addtorquelocal(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_getangvelocity(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_getvelocity(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_clearvelocity(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setmass(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setfriction(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setmaxspeed(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setdamping(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_enable(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setgroup(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_setelasticity(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_getbounds(NativeENTITY* param0, NativeVar param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_makelocal(NativeENTITY* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phent_addobstruction(NativeENTITY* param0, NativeVar param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_add(NativeVar param0, NativeENTITY* param1, NativeENTITY* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_remove(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_setparams1(NativeVar param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_setparams2(NativeVar param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_setmotor(NativeVar param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar phcon_getposition(NativeVar param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ph_setcontacts(NativeVector* param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeMATERIAL* mtl_create();

            [DllImport("acknex.dll")]
            internal static unsafe extern void mtl_remove(NativeMATERIAL* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar effect_cpy(NativeMATERIAL* param0, NativeMATERIAL* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar effect_load(NativeMATERIAL* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativePARTICLE* ent_decal(NativeENTITY* param0, NativeBMAP* param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_createlayer(char* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_createterrain(NativeBMAP* param0, NativeVector* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_next(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_nextlight(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_nextvertex(NativeENTITY* param0, NativeVector* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_pvs(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_for_name(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_for_file(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* ent_mesh(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* ent_getmesh(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_setmesh(NativeENTITY* param0, void* param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_buffers(NativeENTITY* param0, NativeVar param1, NativeVar param2, void** param3, void** param4, void** param5);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeCONTACT* ent_getvertex(NativeENTITY* param0, NativeCONTACT* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeCONTACT* ent_setvertex(NativeENTITY* param0, NativeCONTACT* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativePARTICLE* ent_getdecal(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_clone(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_cloneskin(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_morph(NativeENTITY* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_morphskin(NativeENTITY* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeMATERIAL* ent_mtlset(NativeENTITY* param0, NativeMATERIAL* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* ent_getskin(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeBMAP* ent_setskin(NativeENTITY* param0, NativeBMAP* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_preload(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_purge(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_reload(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_remove(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_animate(NativeENTITY* param0, char* param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_animatefrom(NativeENTITY* param0, NativeENTITY* param1, char* param2, NativeVar param3, NativeVar param4);
            
            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_blend(NativeSTRING* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_blendpose(NativeENTITY* param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* ent_bonename(NativeENTITY* param0, NativeSTRING* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonereset_all(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonereset(NativeENTITY* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonereset_branch(NativeENTITY* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonerotate(NativeENTITY* param0, char* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonerotate_parent(NativeENTITY* param0, char* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonemove(NativeENTITY* param0, char* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bonescale(NativeENTITY* param0, char* param1, NativeVector* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern int ent_bonehandle(NativeENTITY* param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern int ent_boneparent(NativeENTITY* param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_fixnormals(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_type(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_status(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_frames(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_skins(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_bones(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_vertices(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_set(NativeENTITY* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_next(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_nextnode(NativeENTITY* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_scan(NativeENTITY* param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_scanpath(NativeENTITY* param0, NativeVector* param1, NativeVector* param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_scannode(NativeENTITY* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_length(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_spline(NativeENTITY* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern char* file_cpy(char* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern char* file_rename(char* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern char* file_for_screen(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern int file_date(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern char* file_delete(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* file_save(char* param0, void* param1, int param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_open_append(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_open_game(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_open_read(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_open_write(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_close(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_length(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_find(NativeVar param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_seek(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_asc_read(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_asc_write(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_chr_read(NativeVar param0, NativeSTRING* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_str_read(NativeVar param0, NativeSTRING* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_str_readto(NativeVar param0, NativeSTRING* param1, char* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_str_write(NativeVar param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_str_writeto(NativeVar param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_var_read(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar file_var_write(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar key_for_str(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* str_for_key(NativeSTRING* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar key_pressed(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar key_set(NativeVar param0, NativeEVENT param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar level_load(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void level_mark();

            [DllImport("acknex.dll")]
            internal static unsafe extern void level_free();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar update(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar game_save(char* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar game_load(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern IntPtr sys_active(char* title);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_record(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_replay(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_exit(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_message(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_metrics(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar sys_trial(char* param0, char* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar video_set(NativeVar param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar video_switch(NativeVar param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar video_window(NativeVector* param0, NativeVector* param1, NativeVar param2, char* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativePANEL* pan_create(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_remove(NativePANEL* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setbmap(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeBMAP* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setpos(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setvar(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setbutton(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar param3, NativeVar param4, NativeBMAP* param5, NativeBMAP* param6, NativeBMAP* param7, NativeBMAP* param8, NativeEVENT param9, NativeEVENT param10, NativeEVENT param11);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setdigits(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar param3, char* param4, NativeFONT* param5, NativeVar param6, NativeVar* param7);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setneedle(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar param3, NativeBMAP* param4, NativeVar param5, NativeVar param6, NativeVar param7, NativeVar param8, NativeVar param9, NativeVar* param10);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setslider(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar param3, NativeBMAP* param4, NativeBMAP* param5, NativeVar param6, NativeVar param7, NativeVar* param8);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setwindow(NativePANEL* param0, NativeVar param1, NativeVar param2, NativeVar param3, NativeVar param4, NativeVar param5, NativeBMAP* param6, NativeVar* param7, NativeVar* param8);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar digits_set(NativePANEL* param0, NativeVar param1, NativeVar* param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar button_state(NativePANEL* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar layer_sort(void* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeTEXT* txt_create(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern void txt_remove(NativeTEXT* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_for_dir(NativeTEXT* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_sort(NativeTEXT* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_load(NativeTEXT* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_addstring(NativeTEXT* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_setinvisible(NativeTEXT* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar txt_setvisible(NativeTEXT* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* txt_str(NativeTEXT* param0, int param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeFONT* font_create(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void font_remove(NativeFONT* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVIEW* view_create(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar view_to_light(NativeVIEW* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* draw_begin();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_line(NativeVector* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_line3d(NativeVector* param0, NativeVector* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_box3d(NativeVector* param0, NativeVector* param1, NativeVector* param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_obj(IntPtr param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_point3d(NativeVector* param0, NativeVector* param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_quad(NativeBMAP* param0, NativeVector* param1, NativeVector* param2, NativeVector* param3, NativeVector* param4, NativeVector* param5, NativeVar param6, NativeVar param7);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_text(char* param0, NativeVar param1, NativeVar param2, NativeVector* param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar draw_textmode(char* param0, NativeVar param1, NativeVar param2, NativeVar param3);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_data_to(NativeENTITY* param0, void* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_data_id(NativeVar param0, void* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_skill(NativeVar* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_skill_to(NativeENTITY* param0, NativeVar* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_skill_id(NativeVar param0, NativeVar* param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_string(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_string_to(NativeENTITY* param0, NativeSTRING* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_string_id(NativeVar param0, NativeSTRING* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_var(void* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_var_to(NativeENTITY* param0, void* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar send_var_id(NativeVar param0, void* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern void session_close();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar session_connect(char* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar session_open(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar client_drop(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar client_drop_id(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ent_sendnow(NativeENTITY* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar socket_connect(char* param0, NativeVar param1, NativeVar param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar socket_receive(IntPtr param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar socket_send(IntPtr param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar beep();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar diag(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar diag_var(char* param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar diag_frame(NativeVar* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar diag_status();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar error(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar timer();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar breaks();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar port_in(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar port_out(NativeVar param0, NativeVar param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar wiimote_handle(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar exec(char* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar exec_wait(char* param0, char* param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar execute(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* var_for_name(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* ptr_first(void* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar ptr_remove(void* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* ptr_for_handle(NativeVar param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar handle(void* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* sys_malloc(long param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* sys_nxalloc(long param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern void sys_free(void* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern char* _chr(NativeSTRING* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeSTRING* _str(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVector* _vec(float param0, float param1, float param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar add_buffer(char* param0, void* param1, int param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar add_folder(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar add_resource(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar add_new();

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar add_struct(void* param0, int param1);

            [DllImport("acknex.dll")]
            internal static unsafe extern int engine_getobj(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern int engine_getfunc(char* param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar engine_debugbreakpoint(char* param0, int param1, int param2);

            [DllImport("acknex.dll")]
            internal static unsafe extern int engine_debugstep(int param0);

            [DllImport("acknex.dll")]
            internal static unsafe extern int engine_frame();

            [DllImport("acknex.dll")]
            internal static unsafe extern void engine_close();

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_identity(float* matrix);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_inverse(float* matrix1, float* matrix2);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_multiply(float* matrix1, float* matrix2);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_scale(float* matrix1, NativeVar x, NativeVar y, NativeVar z);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_set(float* matrix1, float* matrix2);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* mat_transpose(float* matrix1, float* matrix2);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar mat_effect(float* matrix);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_setnode(NativeENTITY* entity, NativeVar node, NativeVector* pos, NativeVar* skills);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_getnode(NativeENTITY* entity, NativeVar node, NativeVector* pos, NativeVar* skills);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar path_setedge(NativeENTITY* entity, NativeVar node, NativeVar edge, NativeVector* skills);

            [DllImport("acknex.dll")]
            internal static unsafe extern Var path_getedge(NativeENTITY* entity, NativeVar node, NativeVar edge, NativeVector* skills);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_create(char* filename, NativeVector* position, NativeEVENT function);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeENTITY* ent_createlocal(char* filename, NativeVector* position, NativeEVENT function);

            [DllImport("acknex.dll")]
            internal static extern unsafe IntPtr engine_open(char* commandline, int callback);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar pan_setevent(NativePANEL* panel, NativeVar type, NativeVar number, NativeEVENT function);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar effect(NativeEVENT fun, NativeVar num, NativeVector* pos, NativeVector* vel);

            [DllImport("acknex.dll")]
            internal static unsafe extern NativeVar effect_local(NativeEVENT fun, NativeVar num, NativeVector* pos, NativeVector* vel);

            [DllImport("acknex.dll")]
            internal static unsafe extern void* file_load(char* name, void* buffer, long* size);

            [DllImport("acknex.dll")]
            internal static unsafe extern float* view_to_matrix(NativeVIEW* param0, float* matrix1, float* matrix2);
        }
    }
}