﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System.Runtime.InteropServices;

namespace AcknexWrapper
{
    namespace Native
    {
        [StructLayout(LayoutKind.Sequential)]
        internal unsafe struct NativeVIEW
        {
            public NativeC_LINK link;
            public int type;
            public NativeVar layer;
            public NativeVar pos_x, pos_y;
            public int flags;
            public NativeVar size_x, size_y;
            public NativeVar x, y, z;
            public NativeVar pan, tilt, roll;
            public NativeVar offset_x, offset_y;
            public NativeVar arc;
            public NativeVar aspect;
            public NativeVar ambient;
            public int dwcolor;
            public NativeVar alpha;
            public NativeVar portal_x, portal_y, portal_z;
            public NativeVar pnormal_x, pnormal_y, pnormal_z;
            public NativeVar fog_start, fog_end;
            public NativeVar depth;
            public NativeENTITY* genius;
            public NativeVIEW* portal;
            public NativeBMAP* bmap;
            public NativeVar clip_near, clip_far;
            public NativeMATERIAL* material;
            public NativeVIEW* stage;
            public NativeVar monitor;
            public NativeVar skill_x, skill_y;
            public NativeVar lod;
            public NativeVar left, right, bottom, top;
            public NativeBMAP* target1;
            public NativeBMAP* target2;
            public NativeBMAP* target3;
            public byte* pad;  //PAD_VIEW 48
        }
    }
}