﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Collections.Specialized;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Security.Permissions;

namespace FXED.Classes.PropertySupport
{
    public interface IDynamicClass
    {
        PropertyList PublicProperties
        {
            get;
            set;
        }
    }

    [Serializable]
    public class PropertyList : NameObjectCollectionBase
    {
        public PropertyList() { }

        protected PropertyList(SerializationInfo info, StreamingContext context) : base(info, context) { }

        public void Add(Object value)
        {
            //The key for the object is taken from the object to insert
            this.BaseAdd(((DynamicProperty)value).Name, value);
        }

        public void Remove(String key)
        {
            this.BaseRemove(key);
        }

        public void Remove(int index)
        {
            this.BaseRemoveAt(index);
        }

        public void Clear()
        {
            this.BaseClear();
        }

        public DynamicProperty this[String key]
        {
            get
            {
                return (DynamicProperty)(this.BaseGet(key));
            }
            set
            {
                this.BaseSet(key, value);
            }
        }

        public DynamicProperty this[int indice]
        {
            get
            {
                return (DynamicProperty)(this.BaseGet(indice));
            }
            set
            {
                this.BaseSet(indice, value);
            }
        }

    }

    [Serializable]
    public class DynamicProperty
    {
        string name = string.Empty;
        string category = string.Empty;

        public DynamicProperty()
        {
        }

        public DynamicProperty(string pname, string pcat)
        {
            name = pname;
            category = pcat;
        }

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }

        public string Category
        {
            get
            {
                return category;
            }
            set
            {
                category = value;
            }
        }
    }
}
