﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FXED.CustomControls
{
    public partial class MatrixEditor : UserControl
    {
        Classes.Objects.Matrix mat;

        string temp_value_11 = "0.0", temp_value_12 = "0.0", temp_value_13 = "0.0", temp_value_14 = "0.0";
        string temp_value_21 = "0.0", temp_value_22 = "0.0", temp_value_23 = "0.0", temp_value_24 = "0.0";
        string temp_value_31 = "0.0", temp_value_32 = "0.0", temp_value_33 = "0.0", temp_value_34 = "0.0";
        string temp_value_41 = "0.0", temp_value_42 = "0.0", temp_value_43 = "0.0", temp_value_44 = "0.0";

        public MatrixEditor(Classes.Objects.Matrix mat)
        {
            this.mat = mat;

            InitializeComponent();
            txt_11.Text = temp_value_11 = mat.GridValues[0]; txt_12.Text = temp_value_12 = mat.GridValues[1]; txt_13.Text = temp_value_13 = mat.GridValues[2]; txt_14.Text = temp_value_14 = mat.GridValues[3];
            txt_21.Text = temp_value_21 = mat.GridValues[4]; txt_22.Text = temp_value_22 = mat.GridValues[5]; txt_23.Text = temp_value_23 = mat.GridValues[6]; txt_24.Text = temp_value_24 = mat.GridValues[7];
            txt_31.Text = temp_value_31 = mat.GridValues[8]; txt_32.Text = temp_value_32 = mat.GridValues[9]; txt_33.Text = temp_value_33 = mat.GridValues[10]; txt_34.Text = temp_value_34 = mat.GridValues[11];
            txt_41.Text = temp_value_41 = mat.GridValues[12]; txt_42.Text = temp_value_42 = mat.GridValues[13]; txt_43.Text = temp_value_43 = mat.GridValues[14]; txt_44.Text = temp_value_44 = mat.GridValues[15];
            EnableCells();
        }

        public void InitTempValues()
        {
            temp_value_11 = txt_11.Text; temp_value_12 = txt_12.Text; temp_value_13 = txt_13.Text; temp_value_14 = txt_14.Text;
            temp_value_21 = txt_21.Text; temp_value_22 = txt_22.Text; temp_value_23 = txt_23.Text; temp_value_24 = txt_24.Text;
            temp_value_31 = txt_31.Text; temp_value_32 = txt_32.Text; temp_value_33 = txt_33.Text; temp_value_34 = txt_34.Text;
            temp_value_41 = txt_41.Text; temp_value_42 = txt_42.Text; temp_value_43 = txt_43.Text; temp_value_44 = txt_44.Text;
        }

        public void EnableCells()
        {
            string strip = string.Empty;

            for (int i = Controls.Count-1; i >= 0; i--)
            {
                strip = Controls[i].Name.Replace("txt_", string.Empty);
                if (Convert.ToInt32(strip[0].ToString()) <= Convert.ToInt32(mat.Rows) && Convert.ToInt32(strip[1].ToString()) <= Convert.ToInt32(mat.Columns))
                {
                    Controls[i].Enabled = true;
                }
            }
        }

        private void TextBoxLeave(object sender, EventArgs e)
        {
            TextBox tb = sender as TextBox;
            if (Classes.Functions.CheckCastIsValid(mat.DataType.ToString(),tb.Text.Replace(",", "")))
            {
                switch (tb.Name)
                {
                    case "txt_11": temp_value_11 = tb.Text; break;
                    case "txt_12": temp_value_12 = tb.Text; break;
                    case "txt_13": temp_value_13 = tb.Text; break;
                    case "txt_14": temp_value_14 = tb.Text; break;

                    case "txt_21": temp_value_21 = tb.Text; break;
                    case "txt_22": temp_value_22 = tb.Text; break;
                    case "txt_23": temp_value_23 = tb.Text; break;
                    case "txt_24": temp_value_24 = tb.Text; break;

                    case "txt_31": temp_value_31 = tb.Text; break;
                    case "txt_32": temp_value_32 = tb.Text; break;
                    case "txt_33": temp_value_33 = tb.Text; break;
                    case "txt_34": temp_value_34 = tb.Text; break;

                    case "txt_41": temp_value_41 = tb.Text; break;
                    case "txt_42": temp_value_42 = tb.Text; break;
                    case "txt_43": temp_value_43 = tb.Text; break;
                    case "txt_44": temp_value_44 = tb.Text; break;
                }
                return;
            }
            switch (tb.Name)
            {
                case "txt_11": tb.Text = temp_value_11; break;
                case "txt_12": tb.Text = temp_value_12; break;
                case "txt_13": tb.Text = temp_value_13; break;
                case "txt_14": tb.Text = temp_value_14; break;

                case "txt_21": tb.Text = temp_value_21; break;
                case "txt_22": tb.Text = temp_value_22; break;
                case "txt_23": tb.Text = temp_value_23; break;
                case "txt_24": tb.Text = temp_value_24; break;

                case "txt_31": tb.Text = temp_value_31; break;
                case "txt_32": tb.Text = temp_value_32; break;
                case "txt_33": tb.Text = temp_value_33; break;
                case "txt_34": tb.Text = temp_value_34; break;

                case "txt_41": tb.Text = temp_value_41; break;
                case "txt_42": tb.Text = temp_value_42; break;
                case "txt_43": tb.Text = temp_value_43; break;
                case "txt_44": tb.Text = temp_value_44; break;
            }
        }

        private void TextBoxKeyPress(object sender, KeyPressEventArgs e)
        {
            switch (e.KeyChar)
            {
                case (char)(int)Keys.Escape:
                    TextBoxLeave(sender,EventArgs.Empty);
                    break;

                case (char)(int)Keys.Enter:
                    TextBoxLeave(sender, EventArgs.Empty);
                    break;
            }
        }
    }
}
