﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System.Runtime.InteropServices;
using System;
using AcknexWrapper.Native;

namespace AcknexWrapper
{
    public static class EngFun
    {
        /// <summary>
        /// ang - see Gamestudio manual
        /// </summary>
        public static Var ang(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.ang(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sign - see Gamestudio manual
        /// </summary>
        public static Var sign(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.sign(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// fraction - see Gamestudio manual
        /// </summary>
        public static Var fraction(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.fraction(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// integer - see Gamestudio manual
        /// </summary>
        public static Var integer(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.integer(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// random - see Gamestudio manual
        /// </summary>
        public static Var random(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.random(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// randomize - see Gamestudio manual
        /// </summary>
        public static Var randomize()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.randomize();
                return returnParam;
            }
        }


        /// <summary>
        /// random_seed - see Gamestudio manual
        /// </summary>
        public static Var random_seed(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.random_seed(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// absv - see Gamestudio manual
        /// </summary>
        public static Var absv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.absv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sinv - see Gamestudio manual
        /// </summary>
        public static Var sinv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.sinv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// cosv - see Gamestudio manual
        /// </summary>
        public static Var cosv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.cosv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// tanv - see Gamestudio manual
        /// </summary>
        public static Var tanv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.tanv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// asinv - see Gamestudio manual
        /// </summary>
        public static Var asinv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.asinv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// acosv - see Gamestudio manual
        /// </summary>
        public static Var acosv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.acosv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// atanv - see Gamestudio manual
        /// </summary>
        public static Var atanv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.atanv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// atan2v - see Gamestudio manual
        /// </summary>
        public static Var atan2v(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.atan2v(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// expv - see Gamestudio manual
        /// </summary>
        public static Var expv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.expv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// logv - see Gamestudio manual
        /// </summary>
        public static Var logv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.logv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// log10v - see Gamestudio manual
        /// </summary>
        public static Var log10v(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.log10v(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sqrtv - see Gamestudio manual
        /// </summary>
        public static Var sqrtv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.sqrtv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// powv - see Gamestudio manual
        /// </summary>
        public static Var powv(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.powv(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// maxv - see Gamestudio manual
        /// </summary>
        public static Var maxv(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.maxv(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// minv - see Gamestudio manual
        /// </summary>
        public static Var minv(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.minv(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// fsin - see Gamestudio manual
        /// </summary>
        public static Var fsin(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.fsin(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// fcos - see Gamestudio manual
        /// </summary>
        public static Var fcos(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.fcos(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ftan - see Gamestudio manual
        /// </summary>
        public static Var ftan(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.ftan(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// fasin - see Gamestudio manual
        /// </summary>
        public static Var fasin(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.fasin(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// facos - see Gamestudio manual
        /// </summary>
        public static Var facos(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.facos(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// fatan - see Gamestudio manual
        /// </summary>
        public static Var fatan(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.fatan(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// accelerate - see Gamestudio manual
        /// </summary>
        public static Var accelerate(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.accelerate(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// clamp - see Gamestudio manual
        /// </summary>
        public static Var clamp(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.clamp(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// cycle - see Gamestudio manual
        /// </summary>
        public static Var cycle(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.cycle(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// smooth - see Gamestudio manual
        /// </summary>
        public static Var smooth(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.smooth(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// floatv - see Gamestudio manual
        /// </summary>
        public static Var floatv(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.floatv(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// floatd - see Gamestudio manual
        /// </summary>
        public static Var floatd(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.floatd(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// floatr - see Gamestudio manual
        /// </summary>
        public static Var floatr(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.floatr(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ang_add - see Gamestudio manual
        /// </summary>
        public static Angle ang_add(Angle param0, Angle param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParamTemp = (Vector)(*NativeEngFun.ang_add(tempParam0, tempParam1));
                Angle returnParam = new Angle(0, 0, 0);
                returnParam.getValueFrom(returnParamTemp);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ang_rotate - see Gamestudio manual
        /// </summary>
        public static Angle ang_rotate(Angle param0, Angle param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParamTemp = (Vector)(*NativeEngFun.ang_rotate(tempParam0, tempParam1));
                Angle returnParam = new Angle(0, 0, 0);
                returnParam.getValueFrom(returnParamTemp);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ang_diff - see Gamestudio manual
        /// </summary>
        public static Angle ang_diff(Angle param0, Angle param1, Angle param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Vector returnParamTemp = (Vector)(*NativeEngFun.ang_diff(tempParam0, tempParam1, tempParam2));
                Angle returnParam = new Angle(0, 0, 0);
                returnParam.getValueFrom(returnParamTemp);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ang_diff - see Gamestudio manual
        /// </summary>
        public static Angle ang_for_axis(Angle param0, Vector param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParamTemp = (Vector)(*NativeEngFun.ang_for_axis(tempParam0, tempParam1, tempParam2));
                Angle returnParam = new Angle(0, 0, 0);
                returnParam.getValueFrom(returnParamTemp);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_length - see Gamestudio manual
        /// </summary>
        public static Var vec_length(Vector param0)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                Var returnParam = (Var)NativeEngFun.vec_length(tempParam0);
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_dist - see Gamestudio manual
        /// </summary>
        public static Var vec_dist(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.vec_dist(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_cross - see Gamestudio manual
        /// </summary>
        public static Var vec_cross(Vector param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.vec_cross(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_dot - see Gamestudio manual
        /// </summary>
        public static Var vec_dot(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.vec_dot(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_mul - see Gamestudio manual
        /// </summary>
        public static Vector vec_mul(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_mul(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_normalize - see Gamestudio manual
        /// </summary>
        public static Vector vec_normalize(Vector param0, Var param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_normalize(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_accelerate - see Gamestudio manual
        /// </summary>
        public static Vector vec_accelerate(Vector param0, Vector param1, Vector param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_accelerate(tempParam0, tempParam1, tempParam2, tempParam3));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_bounce - see Gamestudio manual
        /// </summary>
        public static Vector vec_bounce(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_bounce(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_add - see Gamestudio manual
        /// </summary>
        public static Vector vec_add(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_add(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_diff - see Gamestudio manual
        /// </summary>
        public static Vector vec_diff(Vector param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.vec_diff(tempParam0, tempParam1, tempParam2);
                if (param0 != null)
                {
                    param0.getValueFrom((Vector)(*tempParam0));
                }
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (Vector)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// vec_inverse - see Gamestudio manual
        /// </summary>
        public static Vector vec_inverse(Vector param0)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_inverse(tempParam0));
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_lerp - see Gamestudio manual
        /// </summary>
        public static Vector vec_lerp(Vector param0, Vector param1, Vector param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_lerp(tempParam0, tempParam1, tempParam2, tempParam3));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_rotate - see Gamestudio manual
        /// </summary>
        public static Vector vec_rotate(Vector param0, Angle param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_rotate(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_rotateback - see Gamestudio manual
        /// </summary>
        public static Vector vec_rotateback(Vector param0, Angle param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_rotateback(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_rotateaxis - see Gamestudio manual
        /// </summary>
        public static Vector vec_rotateaxis(Vector param0, Vector param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_rotateaxis(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_scale - see Gamestudio manual
        /// </summary>
        public static Vector vec_scale(Vector param0, Var param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_scale(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_set - see Gamestudio manual
        /// </summary>
        public static Vector vec_set(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_set(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_fill - see Gamestudio manual
        /// </summary>
        public static Vector vec_fill(Vector param0, Var param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_fill(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_sub - see Gamestudio manual
        /// </summary>
        public static Vector vec_sub(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_sub(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_angle - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_angle(Vector param0, Angle param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_angle(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_to_angle - see Gamestudio manual
        /// </summary>
        public static Var vec_to_angle(Angle param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.vec_to_angle(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_bone - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_bone(Vector param0, ENTITY param1, String param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                char* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (char*)(void*)Marshal.StringToHGlobalAnsi(param2);
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_bone(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2 = Marshal.PtrToStringAnsi((IntPtr)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ang_for_bone - see Gamestudio manual
        /// </summary>
        public static Angle ang_for_bone(Angle param0, ENTITY param1, String param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                char* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (char*)(void*)Marshal.StringToHGlobalAnsi(param2);
                }
                Vector returnParamTemp = (Vector)(*NativeEngFun.ang_for_bone(tempParam0, tempParam1, tempParam2));
                Angle returnParam = new Angle(0, 0, 0);
                returnParam.getValueFrom(returnParamTemp);
                param0.getValueFrom((Vector)(*tempParam0));
                param2 = Marshal.PtrToStringAnsi((IntPtr)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_normal - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_normal(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_normal(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_vertex - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_vertex(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_vertex(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_ent - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_ent(Vector param0, ENTITY param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_ent(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_to_ent - see Gamestudio manual
        /// </summary>
        public static Vector vec_to_ent(Vector param0, ENTITY param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_to_ent(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_min - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_min(Vector param0, ENTITY param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_min(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_max - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_max(Vector param0, ENTITY param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_max(tempParam0, tempParam1));
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_mesh - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_mesh(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_mesh(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_to_mesh - see Gamestudio manual
        /// </summary>
        public static Vector vec_to_mesh(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_to_mesh(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_uv - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_uv(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_for_uv(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_to_uv - see Gamestudio manual
        /// </summary>
        public static Vector vec_to_uv(Vector param0, ENTITY param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vec_to_uv(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// vec_for_screen - see Gamestudio manual
        /// </summary>
        public static Vector vec_for_screen(Vector param0, VIEW param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVIEW* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVIEW*)(IntPtr)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.vec_for_screen(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (Vector)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// vec_to_screen - see Gamestudio manual
        /// </summary>
        public static Vector vec_to_screen(Vector param0, VIEW param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVIEW* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVIEW*)(IntPtr)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.vec_to_screen(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (Vector)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// rel_for_screen - see Gamestudio manual
        /// </summary>
        public static Vector rel_for_screen(Vector param0, VIEW param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVIEW* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVIEW*)(IntPtr)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.rel_for_screen(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (Vector)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// rel_to_screen - see Gamestudio manual
        /// </summary>
        public static Vector rel_to_screen(Vector param0, VIEW param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVIEW* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVIEW*)(IntPtr)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.rel_to_screen(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (Vector)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// vector - see Gamestudio manual
        /// </summary>
        public static Vector vector(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Vector returnParam = (Vector)(*NativeEngFun.vector(tempParam0, tempParam1, tempParam2));
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// str_create - see Gamestudio manual
        /// </summary>
        public static STRING str_create(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_create(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_remove - see Gamestudio manual
        /// </summary>
        public static Var str_remove(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.str_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cpy - see Gamestudio manual
        /// </summary>
        public static STRING str_cpy(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_cpy(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cat - see Gamestudio manual
        /// </summary>
        public static STRING str_cat(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_cat(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cat_num - see Gamestudio manual
        /// </summary>
        public static STRING str_cat_num(STRING param0, String param1, Var param2)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_cat_num(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// str_clip - see Gamestudio manual
        /// </summary>
        public static STRING str_clip(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_clip(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }

        //XXXXX
//str_printf(NativeSTRING* param0, char* param1, __arglist);

        /*s
        /// <summary>
        /// str_cpy - see Gamestudio manual
        /// </summary>
        public static STRING str_printf(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                object xoxo2 = new object[] { (long)153, (long)55 };
                long[] xoxo = new long[] { 143, 44 };
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_printf(tempParam0, tempParam1, __arglist(15, 101));
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }
        */

        /// <summary>
        /// str_trunc - see Gamestudio manual
        /// </summary>
        public static STRING str_trunc(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_trunc(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_lwr - see Gamestudio manual
        /// </summary>
        public static STRING str_lwr(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_lwr(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_upr - see Gamestudio manual
        /// </summary>
        public static STRING str_upr(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_upr(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cmp - see Gamestudio manual
        /// </summary>
        public static Var str_cmp(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.str_cmp(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cmpi - see Gamestudio manual
        /// </summary>
        public static Var str_cmpi(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.str_cmpi(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cmpni - see Gamestudio manual
        /// </summary>
        public static Var str_cmpni(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.str_cmpni(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_len - see Gamestudio manual
        /// </summary>
        public static Var str_len(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.str_len(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }

        /// <summary>
        /// str_chr - see Gamestudio manual
        /// </summary>
        public static Var str_chr(STRING param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.str_chr(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// str_stri - see Gamestudio manual
        /// </summary>
        public static Var str_stri(STRING param0, String param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.str_stri(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_asc - see Gamestudio manual
        /// </summary>
        public static STRING str_for_asc(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_asc(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_to_asc - see Gamestudio manual
        /// </summary>
        public static Var str_to_asc(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.str_to_asc(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_float - see Gamestudio manual
        /// </summary>
        public static STRING str_for_float(STRING param0, double param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                double tempParam1 = param1;
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_float(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_int - see Gamestudio manual
        /// </summary>
        public static STRING str_for_int(STRING param0, int param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                int tempParam1 = param1;
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_int(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_num - see Gamestudio manual
        /// </summary>
        public static STRING str_for_num(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_num(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_to_float - see Gamestudio manual
        /// </summary>
        public static double str_to_float(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                double returnParam = NativeEngFun.str_to_float(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_to_int - see Gamestudio manual
        /// </summary>
        public static int str_to_int(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                int returnParam = NativeEngFun.str_to_int(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_to_num - see Gamestudio manual
        /// </summary>
        public static Var str_to_num(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.str_to_num(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_cursor - see Gamestudio manual
        /// </summary>
        public static Var str_cursor(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.str_cursor(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_width - see Gamestudio manual
        /// </summary>
        public static Var str_width(String param0, FONT param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeFONT* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeFONT*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeFONT*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.str_width(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_entname - see Gamestudio manual
        /// </summary>
        public static STRING str_for_entname(STRING param0, ENTITY param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_entname(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_entfile - see Gamestudio manual
        /// </summary>
        public static STRING str_for_entfile(STRING param0, ENTITY param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_entfile(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_id - see Gamestudio manual
        /// </summary>
        public static STRING str_for_id(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_id(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_create - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_create(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.bmap_create(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (BMAP)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// bmap_createblack - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_createblack(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_createblack(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_remove - see Gamestudio manual
        /// </summary>
        public static void bmap_remove(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeEngFun.bmap_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
            }
        }


        /// <summary>
        /// bmap_for_entity - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_for_entity(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_for_entity(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_for_screen - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_for_screen(BMAP param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_for_screen(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_for_buffer - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_for_buffer(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_for_buffer(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_for_texture - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_for_texture(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_for_texture(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_preload - see Gamestudio manual
        /// </summary>
        public static IntPtr bmap_preload(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.bmap_preload(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_purge - see Gamestudio manual
        /// </summary>
        public static IntPtr bmap_purge(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.bmap_purge(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_load - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_load(BMAP param0, String param1, Var param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_load(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_save - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_save(BMAP param0, String param1)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_save(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_alpha - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_alpha(BMAP param0, Var param1)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_alpha(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_cubemap - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_cubemap(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_cubemap(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_mipmap - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_mipmap(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_mipmap(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_normals - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_normals(BMAP param0, Var param1)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_normals(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_uv - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_uv(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_uv(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_to_format - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_to_format(BMAP param0, Var param1)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_to_format(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_height - see Gamestudio manual
        /// </summary>
        public static Var bmap_height(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.bmap_height(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_width - see Gamestudio manual
        /// </summary>
        public static Var bmap_width(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.bmap_width(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_format - see Gamestudio manual
        /// </summary>
        public static Var bmap_format(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.bmap_format(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_lock - see Gamestudio manual
        /// </summary>
        public static Var bmap_lock(BMAP param0, Var param1)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.bmap_lock(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_unlock - see Gamestudio manual
        /// </summary>
        public static Var bmap_unlock(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.bmap_unlock(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_blit - see Gamestudio manual
        /// </summary>
        public static Var bmap_blit(BMAP param0, BMAP param1, Vector param2, Vector param3)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    tempParam3 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.bmap_blit(tempParam0, tempParam1, tempParam2, tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_blitpart - see Gamestudio manual
        /// </summary>
        public static Var bmap_blitpart(BMAP param0, BMAP param1, Vector param2, Vector param3, Vector param4, Vector param5)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    tempParam3 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                NativeVector* tempParam4;
                if (param4 == null)
                {
                    tempParam4 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam4 = (NativeVector)param4;
                    tempParam4 = &ForTempParam4;
                }
                NativeVector* tempParam5;
                if (param5 == null)
                {
                    tempParam5 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam5 = (NativeVector)param5;
                    tempParam5 = &ForTempParam5;
                }
                Var returnParam = (Var)NativeEngFun.bmap_blitpart(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_fill - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_fill(BMAP param0, Color param1, Var param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_fill(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_process - see Gamestudio manual
        /// </summary>
        public static BMAP bmap_process(BMAP param0, BMAP param1, MATERIAL param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeMATERIAL* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeMATERIAL*)(IntPtr)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.bmap_process(tempParam0, tempParam1, tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_rendertarget - see Gamestudio manual
        /// </summary>
        public static Var bmap_rendertarget(BMAP param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.bmap_rendertarget(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// bmap_zbuffer - see Gamestudio manual
        /// </summary>
        public static Var bmap_zbuffer(BMAP param0)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.bmap_zbuffer(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// pixel_for_bmap - see Gamestudio manual
        /// </summary>
        public static Var pixel_for_bmap(BMAP param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.pixel_for_bmap(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// pixel_to_bmap - see Gamestudio manual
        /// </summary>
        public static Var pixel_to_bmap(BMAP param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.pixel_to_bmap(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// pixel_for_vec - see Gamestudio manual
        /// </summary>
        public static Var pixel_for_vec(Color param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.pixel_for_vec(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// pixel_to_vec - see Gamestudio manual
        /// </summary>
        public static Var pixel_to_vec(Color param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeVar*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeVar*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.pixel_to_vec(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// cd_play - see Gamestudio manual
        /// </summary>
        public static Var cd_play(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.cd_play(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// cd_pause - see Gamestudio manual
        /// </summary>
        public static Var cd_pause()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.cd_pause();
                return returnParam;
            }
        }


        /// <summary>
        /// cd_start - see Gamestudio manual
        /// </summary>
        public static Var cd_start()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.cd_start();
                return returnParam;
            }
        }


        /// <summary>
        /// cd_track - see Gamestudio manual
        /// </summary>
        public static Var cd_track()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.cd_track();
                return returnParam;
            }
        }


        /// <summary>
        /// media_play - see Gamestudio manual
        /// </summary>
        public static Var media_play(String param0, BMAP param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.media_play(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// media_loop - see Gamestudio manual
        /// </summary>
        public static Var media_loop(String param0, BMAP param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.media_loop(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// media_pause - see Gamestudio manual
        /// </summary>
        public static Var media_pause(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.media_pause(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// media_playing - see Gamestudio manual
        /// </summary>
        public static Var media_playing(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.media_playing(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// media_start - see Gamestudio manual
        /// </summary>
        public static Var media_start(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.media_start(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// media_stop - see Gamestudio manual
        /// </summary>
        public static Var media_stop(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.media_stop(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// media_tune - see Gamestudio manual
        /// </summary>
        public static Var media_tune(Var param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.media_tune(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_create - see Gamestudio manual
        /// </summary>
        public static SOUND snd_create(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.snd_create(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (SOUND)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// snd_remove - see Gamestudio manual
        /// </summary>
        public static Var snd_remove(SOUND param0)
        {
            unsafe
            {
                NativeSOUND* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSOUND*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_buffer - see Gamestudio manual
        /// </summary>
        public static Var snd_buffer(SOUND param0, IntPtr param1, IntPtr param2)
        {
            unsafe
            {
                NativeSOUND* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSOUND*)(IntPtr)param0;
                }
                void** tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (void**)param1;
                }
                void*** tempParam2;
                if (param2 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (void***)param2;
                }
                Var returnParam = (Var)NativeEngFun.snd_buffer(tempParam0, tempParam1, tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_play - see Gamestudio manual
        /// </summary>
        public static Var snd_play(SOUND param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeSOUND* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSOUND*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.snd_play(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_loop - see Gamestudio manual
        /// </summary>
        public static Var snd_loop(SOUND param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeSOUND* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSOUND*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.snd_loop(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_playing - see Gamestudio manual
        /// </summary>
        public static Var snd_playing(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_playing(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_pause - see Gamestudio manual
        /// </summary>
        public static Var snd_pause(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_pause(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_start - see Gamestudio manual
        /// </summary>
        public static Var snd_start(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_start(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_stop - see Gamestudio manual
        /// </summary>
        public static Var snd_stop(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_stop(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }

        /// <summary>
        /// snd_add - see Gamestudio manual
        /// </summary>
        public static Var snd_add(Var param0, Var param1, IntPtr param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                if (param2 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.snd_add(tempParam0, tempParam1, param2, tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_stopall - see Gamestudio manual
        /// </summary>
        public static Var snd_stopall(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.snd_stopall(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// snd_tune - see Gamestudio manual
        /// </summary>
        public static Var snd_tune(Var param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.snd_tune(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_playloop - see Gamestudio manual
        /// </summary>
        public static Var ent_playloop(ENTITY param0, SOUND param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeSOUND* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeSOUND*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.ent_playloop(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_playsound - see Gamestudio manual
        /// </summary>
        public static Var ent_playsound(ENTITY param0, SOUND param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeSOUND* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeSOUND*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.ent_playsound(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// c_content - see Gamestudio manual
        /// </summary>
        public static Var c_content(Vector param0, Var param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.c_content(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// c_scan - see Gamestudio manual
        /// </summary>
        public static Var c_scan(Vector param0, Angle param1, Vector param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.c_scan(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// c_trace - see Gamestudio manual
        /// </summary>
        public static Var c_trace(Vector param0, Vector param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.c_trace(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// c_move - see Gamestudio manual
        /// </summary>
        public static Var c_move(ENTITY param0, Vector param1, Vector param2, Var param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.c_move(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// c_rotate - see Gamestudio manual
        /// </summary>
        public static Var c_rotate(ENTITY param0, Angle param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.c_rotate(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// c_setminmax - see Gamestudio manual
        /// </summary>
        public static Var c_setminmax(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.c_setminmax(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// c_updatehull - see Gamestudio manual
        /// </summary>
        public static Var c_updatehull(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.c_updatehull(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// content - see Gamestudio manual
        /// </summary>
        public static Var content(Vector param0)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                Var returnParam = (Var)NativeEngFun.content(tempParam0);
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// trace - see Gamestudio manual
        /// </summary>
        public static Var trace(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.trace(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_move - see Gamestudio manual
        /// </summary>
        public static Var ent_move(Vector param0, Vector param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.ent_move(tempParam0, tempParam1);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ph_selectgroup - see Gamestudio manual
        /// </summary>
        public static Var ph_selectgroup(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.ph_selectgroup(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ph_setgravity - see Gamestudio manual
        /// </summary>
        public static Var ph_setgravity(Vector param0)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                Var returnParam = (Var)NativeEngFun.ph_setgravity(tempParam0);
                param0.getValueFrom((Vector)(*tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// ph_setcorrections - see Gamestudio manual
        /// </summary>
        public static Var ph_setcorrections(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.ph_setcorrections(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ph_setcollisions - see Gamestudio manual
        /// </summary>
        public static Var ph_setcollisions(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.ph_setcollisions(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ph_setautodisable - see Gamestudio manual
        /// </summary>
        public static Var ph_setautodisable(Var param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.ph_setautodisable(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_settype - see Gamestudio manual
        /// </summary>
        public static Var phent_settype(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.phent_settype(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addcentralforce - see Gamestudio manual
        /// </summary>
        public static Var phent_addcentralforce(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phent_addcentralforce(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addforceglobal - see Gamestudio manual
        /// </summary>
        public static Var phent_addforceglobal(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_addforceglobal(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addforcelocal - see Gamestudio manual
        /// </summary>
        public static Var phent_addforcelocal(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_addforcelocal(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addvelcentral - see Gamestudio manual
        /// </summary>
        public static Var phent_addvelcentral(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phent_addvelcentral(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addvelglobal - see Gamestudio manual
        /// </summary>
        public static Var phent_addvelglobal(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_addvelglobal(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addvellocal - see Gamestudio manual
        /// </summary>
        public static Var phent_addvellocal(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_addvellocal(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addtorqueglobal - see Gamestudio manual
        /// </summary>
        public static Var phent_addtorqueglobal(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phent_addtorqueglobal(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addtorquelocal - see Gamestudio manual
        /// </summary>
        public static Var phent_addtorquelocal(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phent_addtorquelocal(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_getangvelocity - see Gamestudio manual
        /// </summary>
        public static Var phent_getangvelocity(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phent_getangvelocity(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_getvelocity - see Gamestudio manual
        /// </summary>
        public static Var phent_getvelocity(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_getvelocity(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_clearvelocity - see Gamestudio manual
        /// </summary>
        public static Var phent_clearvelocity(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.phent_clearvelocity(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setmass - see Gamestudio manual
        /// </summary>
        public static Var phent_setmass(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.phent_setmass(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setfriction - see Gamestudio manual
        /// </summary>
        public static Var phent_setfriction(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.phent_setfriction(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setmaxspeed - see Gamestudio manual
        /// </summary>
        public static Var phent_setmaxspeed(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.phent_setmaxspeed(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setdamping - see Gamestudio manual
        /// </summary>
        public static Var phent_setdamping(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.phent_setdamping(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_enable - see Gamestudio manual
        /// </summary>
        public static Var phent_enable(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.phent_enable(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setgroup - see Gamestudio manual
        /// </summary>
        public static Var phent_setgroup(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.phent_setgroup(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_setelasticity - see Gamestudio manual
        /// </summary>
        public static Var phent_setelasticity(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.phent_setelasticity(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// phent_getbounds - see Gamestudio manual
        /// </summary>
        public static Var phent_getbounds(ENTITY param0, Var param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_getbounds(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_makelocal - see Gamestudio manual
        /// </summary>
        public static Var phent_makelocal(ENTITY param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_makelocal(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phent_addobstruction - see Gamestudio manual
        /// </summary>
        public static Var phent_addobstruction(ENTITY param0, Var param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.phent_addobstruction(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_add - see Gamestudio manual
        /// </summary>
        public static Var phcon_add(Var param0, ENTITY param1, ENTITY param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                NativeENTITY* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam2 = (NativeENTITY*)(IntPtr)param2;
                }
                Var returnParam = (Var)NativeEngFun.phcon_add(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_remove - see Gamestudio manual
        /// </summary>
        public static Var phcon_remove(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.phcon_remove(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_setparams1 - see Gamestudio manual
        /// </summary>
        public static Var phcon_setparams1(Var param0, Vector param1, Vector param2, Vector param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.phcon_setparams1(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_setparams2 - see Gamestudio manual
        /// </summary>
        public static Var phcon_setparams2(Var param0, Vector param1, Vector param2, Vector param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.phcon_setparams2(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_setmotor - see Gamestudio manual
        /// </summary>
        public static Var phcon_setmotor(Var param0, Vector param1, Vector param2, Vector param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.phcon_setmotor(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// phcon_getposition - see Gamestudio manual
        /// </summary>
        public static Var phcon_getposition(Var param0, Vector param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.phcon_getposition(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ph_setcontacts - see Gamestudio manual
        /// </summary>
        public static Var ph_setcontacts(Vector param0, Vector param1, Vector param2, Vector param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.ph_setcontacts(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// mtl_create - see Gamestudio manual
        /// </summary>
        public static MATERIAL mtl_create()
        {
            unsafe
            {
                MATERIAL returnParam = (MATERIAL)(IntPtr)NativeEngFun.mtl_create();
                return returnParam;
            }
        }


        /// <summary>
        /// mtl_remove - see Gamestudio manual
        /// </summary>
        public static void mtl_remove(MATERIAL param0)
        {
            unsafe
            {
                NativeMATERIAL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeMATERIAL*)(IntPtr)param0;
                }
                NativeEngFun.mtl_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
            }
        }


        /// <summary>
        /// effect_cpy - see Gamestudio manual
        /// </summary>
        public static Var effect_cpy(MATERIAL param0, MATERIAL param1)
        {
            unsafe
            {
                NativeMATERIAL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeMATERIAL*)(IntPtr)param0;
                }
                NativeMATERIAL* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeMATERIAL*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.effect_cpy(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// effect_load - see Gamestudio manual
        /// </summary>
        public static Var effect_load(MATERIAL param0, String param1)
        {
            unsafe
            {
                NativeMATERIAL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeMATERIAL*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.effect_load(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_decal - see Gamestudio manual
        /// </summary>
        public static PARTICLE ent_decal(ENTITY param0, BMAP param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                PARTICLE returnParam = (PARTICLE)(IntPtr)NativeEngFun.ent_decal(tempParam0, tempParam1, tempParam2, tempParam3);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_createlayer - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_createlayer(String param0, Var param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                ENTITY returnParam = (ENTITY)(IntPtr)NativeEngFun.ent_createlayer(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_createterrain - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_createterrain(BMAP param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                ENTITY returnParam = (ENTITY)(IntPtr)NativeEngFun.ent_createterrain(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_next - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_next(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_next(tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (ENTITY)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_nextlight - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_nextlight(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_nextlight(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (ENTITY)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_nextvertex - see Gamestudio manual
        /// </summary>
        public static Var ent_nextvertex(ENTITY param0, Vector param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                Var returnParam = (Var)NativeEngFun.ent_nextvertex(tempParam0, tempParam1);
                param1.getValueFrom((Vector)(*tempParam1));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_pvs - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_pvs(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_pvs(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (ENTITY)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_for_name - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_for_name(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_for_name(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (ENTITY)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_for_file - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_for_file(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_for_file(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (ENTITY)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_mesh - see Gamestudio manual
        /// </summary>
        public static IntPtr ent_mesh(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.ent_mesh(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_getmesh - see Gamestudio manual
        /// </summary>
        public static IntPtr ent_getmesh(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.ent_getmesh(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_setmesh - see Gamestudio manual
        /// </summary>
        public static Var ent_setmesh(ENTITY param0, IntPtr param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    tempParam1 = (void*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.ent_setmesh(tempParam0, tempParam1, tempParam2, tempParam3);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_buffers - see Gamestudio manual
        /// </summary>
        public static Var ent_buffers(ENTITY param0, Var param1, Var param2, IntPtr param3, IntPtr param4, IntPtr param5)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                void** tempParam3;
                if (param3 == IntPtr.Zero)
                {
                    tempParam3 = (void**)IntPtr.Zero;
                }
                else
                {
                    tempParam3 = (void**)param3;
                }
                void** tempParam4;
                if (param4 == IntPtr.Zero)
                {
                    tempParam4 = (void**)IntPtr.Zero;
                }
                else
                {
                    tempParam4 = (void**)param4;
                }
                void** tempParam5;
                if (param5 == IntPtr.Zero)
                {
                    tempParam5 = (void**)IntPtr.Zero;
                }
                else
                {
                    tempParam5 = (void**)param5;
                }
                Var returnParam = (Var)NativeEngFun.ent_buffers(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_getvertex - see Gamestudio manual
        /// </summary>
        public static CONTACT ent_getvertex(ENTITY param0, CONTACT param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeCONTACT* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = null;
                }
                else
                {
                    tempParam1 = (NativeCONTACT*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_getvertex(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (CONTACT)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_setvertex - see Gamestudio manual
        /// </summary>
        public static CONTACT ent_setvertex(ENTITY param0, CONTACT param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeCONTACT* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeCONTACT*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_setvertex(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (CONTACT)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_getdecal - see Gamestudio manual
        /// </summary>
        public static PARTICLE ent_getdecal(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                return (PARTICLE)(IntPtr)NativeEngFun.ent_getdecal(tempParam0, tempParam1, tempParam2);
            }
        }


        /// <summary>
        /// ent_clone - see Gamestudio manual
        /// </summary>
        public static Var ent_clone(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_clone(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_cloneskin - see Gamestudio manual
        /// </summary>
        public static Var ent_cloneskin(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_cloneskin(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_morph - see Gamestudio manual
        /// </summary>
        public static Var ent_morph(ENTITY param0, String param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.ent_morph(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_morphskin - see Gamestudio manual
        /// </summary>
        public static Var ent_morphskin(ENTITY param0, String param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.ent_morphskin(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_mtlset - see Gamestudio manual
        /// </summary>
        public static MATERIAL ent_mtlset(ENTITY param0, MATERIAL param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeMATERIAL* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeMATERIAL*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.ent_mtlset(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (MATERIAL)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// ent_getskin - see Gamestudio manual
        /// </summary>
        public static BMAP ent_getskin(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.ent_getskin(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_setskin - see Gamestudio manual
        /// </summary>
        public static BMAP ent_setskin(ENTITY param0, BMAP param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeBMAP* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeBMAP*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                BMAP returnParam = (BMAP)(IntPtr)NativeEngFun.ent_setskin(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_preload - see Gamestudio manual
        /// </summary>
        public static Var ent_preload(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_preload(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_purge - see Gamestudio manual
        /// </summary>
        public static Var ent_purge(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_purge(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_reload - see Gamestudio manual
        /// </summary>
        public static Var ent_reload(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_reload(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_remove - see Gamestudio manual
        /// </summary>
        public static Var ent_remove(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
                return returnParam;
            }
        }

        /// <summary>
        /// ent_animatefrom - see Gamestudio manual
        /// </summary>
        public static Var ent_animatefrom(ENTITY param0, ENTITY param1, String param2, Var param3, Var param4)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeENTITY* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeENTITY*)(IntPtr)param1;
                }
                char* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam2 = (char*)(void*)Marshal.StringToHGlobalAnsi(param2);
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                NativeVar tempParam4;
                if (param4 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam4 = (NativeVar)param4;
                }
                Var returnParam = (Var)NativeEngFun.ent_animatefrom(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4);
                param3.getValueFrom((Var)tempParam3);
                param4.getValueFrom((Var)tempParam4);
                return returnParam;
            }
        }

        /// <summary>
        /// ent_animate - see Gamestudio manual
        /// </summary>
        public static Var ent_animate(ENTITY param0, String param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.ent_animate(tempParam0, tempParam1, tempParam2, tempParam3);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_blend - see Gamestudio manual
        /// </summary>
        public static Var ent_blend(STRING param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.ent_blend(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_blendpose - see Gamestudio manual
        /// </summary>
        public static Var ent_blendpose(ENTITY param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.ent_blendpose(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonename - see Gamestudio manual
        /// </summary>
        public static STRING ent_bonename(ENTITY param0, STRING param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.ent_bonename(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonereset_all - see Gamestudio manual
        /// </summary>
        public static Var ent_bonereset_all(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_bonereset_all(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonereset - see Gamestudio manual
        /// </summary>
        public static Var ent_bonereset(ENTITY param0, String param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.ent_bonereset(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonereset_branch - see Gamestudio manual
        /// </summary>
        public static Var ent_bonereset_branch(ENTITY param0, String param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.ent_bonereset_branch(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonerotate - see Gamestudio manual
        /// </summary>
        public static Var ent_bonerotate(ENTITY param0, String param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.ent_bonerotate(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonerotate_parent - see Gamestudio manual
        /// </summary>
        public static Var ent_bonerotate_parent(ENTITY param0, String param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.ent_bonerotate_parent(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonemove - see Gamestudio manual
        /// </summary>
        public static Var ent_bonemove(ENTITY param0, String param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.ent_bonemove(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bonescale - see Gamestudio manual
        /// </summary>
        public static Var ent_bonescale(ENTITY param0, String param1, Vector param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                Var returnParam = (Var)NativeEngFun.ent_bonescale(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Vector)(*tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// ent_boneparent - see Gamestudio manual
        /// </summary>
        public static int ent_bonehandle(ENTITY param0, String param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                int returnParam = NativeEngFun.ent_bonehandle(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_boneparent - see Gamestudio manual
        /// </summary>
        public static int ent_boneparent(ENTITY param0, String param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                int returnParam = NativeEngFun.ent_boneparent(tempParam0, tempParam1, tempParam2);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_fixnormals - see Gamestudio manual
        /// </summary>
        public static Var ent_fixnormals(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.ent_fixnormals(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_type - see Gamestudio manual
        /// </summary>
        public static Var ent_type(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_type(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_status - see Gamestudio manual
        /// </summary>
        public static Var ent_status(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.ent_status(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_frames - see Gamestudio manual
        /// </summary>
        public static Var ent_frames(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_frames(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_skins - see Gamestudio manual
        /// </summary>
        public static Var ent_skins(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_skins(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_bones - see Gamestudio manual
        /// </summary>
        public static Var ent_bones(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_bones(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_vertices - see Gamestudio manual
        /// </summary>
        public static Var ent_vertices(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_vertices(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// path_set - see Gamestudio manual
        /// </summary>
        public static Var path_set(ENTITY param0, String param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.path_set(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// path_next - see Gamestudio manual
        /// </summary>
        public static Var path_next(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.path_next(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// path_nextnode - see Gamestudio manual
        /// </summary>
        public static Var path_nextnode(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.path_nextnode(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// path_scan - see Gamestudio manual
        /// </summary>
        public static Var path_scan(ENTITY param0, Vector param1, Angle param2, Vector param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.path_scan(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// path_scanpath - see Gamestudio manual
        /// </summary>
        public static Var path_scanpath(ENTITY param0, Vector param1, Angle param2, Vector param3)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.path_scanpath(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// path_scannode - see Gamestudio manual
        /// </summary>
        public static Var path_scannode(ENTITY param0, Var param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.path_scannode(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// path_length - see Gamestudio manual
        /// </summary>
        public static Var path_length(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.path_length(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// path_spline - see Gamestudio manual
        /// </summary>
        public static Var path_spline(ENTITY param0, Vector param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.path_spline(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// file_cpy - see Gamestudio manual
        /// </summary>
        public static String file_cpy(String param0, String param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                String returnParam = Marshal.PtrToStringAnsi((IntPtr)NativeEngFun.file_cpy(tempParam0, tempParam1));
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// file_rename - see Gamestudio manual
        /// </summary>
        public static String file_rename(String param0, String param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                String returnParam = Marshal.PtrToStringAnsi((IntPtr)NativeEngFun.file_rename(tempParam0, tempParam1));
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// file_for_screen - see Gamestudio manual
        /// </summary>
        public static String file_for_screen(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                String returnParam = Marshal.PtrToStringAnsi((IntPtr)NativeEngFun.file_for_screen(tempParam0, tempParam1));
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// file_date - see Gamestudio manual
        /// </summary>
        public static int file_date(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                int returnParam = (Var)NativeEngFun.file_date(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_delete - see Gamestudio manual
        /// </summary>
        public static String file_delete(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                String returnParam = Marshal.PtrToStringAnsi((IntPtr)NativeEngFun.file_delete(tempParam0));
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_save - see Gamestudio manual
        /// </summary>
        public static IntPtr file_save(String param0, IntPtr param1, int param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                int tempParam2 = param2;
                IntPtr returnParam = (IntPtr)NativeEngFun.file_save(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_open_append - see Gamestudio manual
        /// </summary>
        public static Var file_open_append(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.file_open_append(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_open_game - see Gamestudio manual
        /// </summary>
        public static Var file_open_game(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.file_open_game(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_open_read - see Gamestudio manual
        /// </summary>
        public static Var file_open_read(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.file_open_read(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_open_write - see Gamestudio manual
        /// </summary>
        public static Var file_open_write(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.file_open_write(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_close - see Gamestudio manual
        /// </summary>
        public static Var file_close(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.file_close(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_length - see Gamestudio manual
        /// </summary>
        public static Var file_length(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.file_length(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_find - see Gamestudio manual
        /// </summary>
        public static Var file_find(Var param0, String param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.file_find(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// file_seek - see Gamestudio manual
        /// </summary>
        public static Var file_seek(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.file_seek(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// file_asc_read - see Gamestudio manual
        /// </summary>
        public static Var file_asc_read(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.file_asc_read(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_asc_write - see Gamestudio manual
        /// </summary>
        public static Var file_asc_write(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.file_asc_write(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// file_chr_read - see Gamestudio manual
        /// </summary>
        public static Var file_chr_read(Var param0, STRING param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.file_chr_read(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_str_read - see Gamestudio manual
        /// </summary>
        public static Var file_str_read(Var param0, STRING param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.file_str_read(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_str_readto - see Gamestudio manual
        /// </summary>
        public static Var file_str_readto(Var param0, STRING param1, String param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeSTRING*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                char* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam2 = (char*)(void*)Marshal.StringToHGlobalAnsi(param2);
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.file_str_readto(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// file_str_write - see Gamestudio manual
        /// </summary>
        public static Var file_str_write(Var param0, String param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.file_str_write(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }
        

        /// <summary>
        /// file_str_write - see Gamestudio manual
        /// </summary>
        public static Var file_str_writeto(Var param0, String param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.file_str_writeto(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// file_var_read - see Gamestudio manual
        /// </summary>
        public static Var file_var_read(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.file_var_read(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// file_var_write - see Gamestudio manual
        /// </summary>
        public static Var file_var_write(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.file_var_write(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// key_for_str - see Gamestudio manual
        /// </summary>
        public static Var key_for_str(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.key_for_str(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// str_for_key - see Gamestudio manual
        /// </summary>
        public static STRING str_for_key(STRING param0, Var param1)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.str_for_key(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// key_pressed - see Gamestudio manual
        /// </summary>
        public static Var key_pressed(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.key_pressed(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// key_set - see Gamestudio manual
        /// </summary>
        public static Var key_set(Var param0, EventVoid param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeEVENT tempParam1;
                Scheduler.EventVoidReference TempEventVoidReferencetempParam1 = null;
                if (param1 == null)
                    tempParam1.mPtr = null;
                else
                {
                    TempEventVoidReferencetempParam1 = new Scheduler.EventVoidReference(param1, (IntPtr)param0);
                    tempParam1.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)TempEventVoidReferencetempParam1.NativeEventVoidFunc);
                }
                Var returnParam = (Var)NativeEngFun.key_set(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// level_load - see Gamestudio manual
        /// </summary>
        public static Var level_load(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.level_load(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// level_mark - see Gamestudio manual
        /// </summary>
        public static void level_mark()
        {
            unsafe
            {
                NativeEngFun.level_mark();
            }
        }


        /// <summary>
        /// level_free - see Gamestudio manual
        /// </summary>
        public static void level_free()
        {
            unsafe
            {
                NativeEngFun.level_free();
            }
        }


        /// <summary>
        /// update - see Gamestudio manual
        /// </summary>
        public static Var update(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.update(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// game_save - see Gamestudio manual
        /// </summary>
        public static Var game_save(String param0, Var param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.game_save(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// game_load - see Gamestudio manual
        /// </summary>
        public static Var game_load(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.game_load(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }

        
        /// <summary>
        /// sys_active - see Gamestudio manual
        /// </summary>
        public static IntPtr sys_active(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char *)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                return NativeEngFun.sys_active(tempParam0);
            }
        }


        /// <summary>
        /// sys_record - see Gamestudio manual
        /// </summary>
        public static Var sys_record(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.sys_record(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_replay - see Gamestudio manual
        /// </summary>
        public static Var sys_replay(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.sys_replay(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_exit - see Gamestudio manual
        /// </summary>
        public static Var sys_exit(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.sys_exit(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_message - see Gamestudio manual
        /// </summary>
        public static Var sys_message(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.sys_message(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_metrics - see Gamestudio manual
        /// </summary>
        public static Var sys_metrics(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.sys_metrics(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_trial - see Gamestudio manual
        /// </summary>
        public static Var sys_trial(String param0, String param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.sys_trial(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// video_set - see Gamestudio manual
        /// </summary>
        public static Var video_set(Var param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.video_set(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// video_switch - see Gamestudio manual
        /// </summary>
        public static Var video_switch(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.video_switch(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// video_window - see Gamestudio manual
        /// </summary>
        public static Var video_window(Vector param0, Vector param1, Var param2, String param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                char* tempParam3;
                if (param3 == null)
                {
                    tempParam3 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam3 = (char*)(void*)Marshal.StringToHGlobalAnsi(param3);
                }
                Var returnParam = (Var)NativeEngFun.video_window(tempParam0, tempParam1, tempParam2, tempParam3);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_create - see Gamestudio manual
        /// </summary>
        public static PANEL pan_create(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.pan_create(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (PANEL)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// pan_remove - see Gamestudio manual
        /// </summary>
        public static Var pan_remove(PANEL param0)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.pan_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setbmap - see Gamestudio manual
        /// </summary>
        public static Var pan_setbmap(PANEL param0, Var param1, Var param2, BMAP param3)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeBMAP* tempParam3;
                if (param3 == null)
                {
                    tempParam3 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam3 = (NativeBMAP*)(IntPtr)param3;
                }
                Var returnParam = (Var)NativeEngFun.pan_setbmap(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setpos - see Gamestudio manual
        /// </summary>
        public static Var pan_setpos(PANEL param0, Var param1, Var param2, Vector param3)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.pan_setpos(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setvar - see Gamestudio manual
        /// </summary>
        public static Var pan_setvar(PANEL param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar*)(IntPtr)param3;
                }
                Var returnParam = (Var)NativeEngFun.pan_setvar(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setdigits - see Gamestudio manual
        /// </summary>
        public static Var pan_setdigits(PANEL param0, Var param1, Var param2, Var param3, String param4, FONT param5, Var param6, Var param7)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                char* tempParam4;
                if (param4 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam4 = (char*)(void*)Marshal.StringToHGlobalAnsi(param4);
                }
                NativeFONT* tempParam5;
                if (param5 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam5 = (NativeFONT*)(IntPtr)param5;
                }
                NativeVar tempParam6;
                if (param6 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam6 = (NativeVar)param6;
                }
                NativeVar* tempParam7;
                if (param7 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam7 = (NativeVar*)(IntPtr)param7;
                }
                Var returnParam = (Var)NativeEngFun.pan_setdigits(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                param4 = Marshal.PtrToStringAnsi((IntPtr)tempParam4);
                param6.getValueFrom((Var)tempParam6);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setneedle - see Gamestudio manual
        /// </summary>
        public static Var pan_setneedle(PANEL param0, Var param1, Var param2, Var param3, BMAP param4, Var param5, Var param6, Var param7, Var param8, Var param9, Var param10)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                NativeBMAP* tempParam4;
                if (param4 == null)
                {
                    tempParam4 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam4 = (NativeBMAP*)(IntPtr)param4;
                }
                NativeVar tempParam5;
                if (param5 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam5 = (NativeVar)param5;
                }
                NativeVar tempParam6;
                if (param6 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam6 = (NativeVar)param6;
                }
                NativeVar tempParam7;
                if (param7 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam7 = (NativeVar)param7;
                }
                NativeVar tempParam8;
                if (param8 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam8 = (NativeVar)param8;
                }
                NativeVar tempParam9;
                if (param9 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam9 = (NativeVar)param9;
                }
                NativeVar* tempParam10;
                if (param10 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam10 = (NativeVar*)(IntPtr)param10;
                }
                Var returnParam = (Var)NativeEngFun.pan_setneedle(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7, tempParam8, tempParam9, tempParam10);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                param5.getValueFrom((Var)tempParam5);
                param6.getValueFrom((Var)tempParam6);
                param7.getValueFrom((Var)tempParam7);
                param8.getValueFrom((Var)tempParam8);
                param9.getValueFrom((Var)tempParam9);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setslider - see Gamestudio manual
        /// </summary>
        public static Var pan_setslider(PANEL param0, Var param1, Var param2, Var param3, BMAP param4, BMAP param5, Var param6, Var param7, Var param8)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                NativeBMAP* tempParam4;
                if (param4 == null)
                {
                    tempParam4 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam4 = (NativeBMAP*)(IntPtr)param4;
                }
                NativeBMAP* tempParam5;
                if (param5 == null)
                {
                    tempParam5 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam5 = (NativeBMAP*)(IntPtr)param5;
                }
                NativeVar tempParam6;
                if (param6 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam6 = (NativeVar)param6;
                }
                NativeVar tempParam7;
                if (param7 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam7 = (NativeVar)param7;
                }
                NativeVar* tempParam8;
                if (param8 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam8 = (NativeVar*)(IntPtr)param8;
                }
                Var returnParam = (Var)NativeEngFun.pan_setslider(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7, tempParam8);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                param6.getValueFrom((Var)tempParam6);
                param7.getValueFrom((Var)tempParam7);
                return returnParam;
            }
        }


        /// <summary>
        /// pan_setwindow - see Gamestudio manual
        /// </summary>
        public static Var pan_setwindow(PANEL param0, Var param1, Var param2, Var param3, Var param4, Var param5, BMAP param6, Var param7, Var param8)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                NativeVar tempParam4;
                if (param4 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam4 = (NativeVar)param4;
                }
                NativeVar tempParam5;
                if (param5 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam5 = (NativeVar)param5;
                }
                NativeBMAP* tempParam6;
                if (param6 == null)
                {
                    tempParam6 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam6 = (NativeBMAP*)(IntPtr)param6;
                }
                NativeVar* tempParam7;
                if (param7 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam7 = (NativeVar*)(IntPtr)param7;
                }
                NativeVar* tempParam8;
                if (param8 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam8 = (NativeVar*)(IntPtr)param8;
                }
                Var returnParam = (Var)NativeEngFun.pan_setwindow(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7, tempParam8);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                param4.getValueFrom((Var)tempParam4);
                param5.getValueFrom((Var)tempParam5);
                return returnParam;
            }
        }


        /// <summary>
        /// digits_set - see Gamestudio manual
        /// </summary>
        public static Var digits_set(PANEL param0, Var param1, Var param2)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar*)(IntPtr)param2;
                }
                Var returnParam = (Var)NativeEngFun.digits_set(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// button_state - see Gamestudio manual
        /// </summary>
        public static Var button_state(PANEL param0, Var param1, Var param2)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.button_state(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// layer_sort - see Gamestudio manual
        /// </summary>
        public static Var layer_sort(IntPtr param0, Var param1)
        {
            unsafe
            {
                void* tempParam0;
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (void*)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.layer_sort(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_create - see Gamestudio manual
        /// </summary>
        public static TEXT txt_create(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.txt_create(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (TEXT)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// txt_remove - see Gamestudio manual
        /// </summary>
        public static void txt_remove(TEXT param0)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                NativeEngFun.txt_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
            }
        }


        /// <summary>
        /// txt_for_dir - see Gamestudio manual
        /// </summary>
        public static Var txt_for_dir(TEXT param0, String param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.txt_for_dir(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_sort - see Gamestudio manual
        /// </summary>
        public static Var txt_sort(TEXT param0)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.txt_sort(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_load - see Gamestudio manual
        /// </summary>
        public static Var txt_load(TEXT param0, String param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.txt_load(tempParam0, tempParam1);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_addstring - see Gamestudio manual
        /// </summary>
        public static Var txt_addstring(TEXT param0, String param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.txt_addstring(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_setinvisible - see Gamestudio manual
        /// </summary>
        public static Var txt_setinvisible(TEXT param0, Var param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.txt_setinvisible(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_setvisible - see Gamestudio manual
        /// </summary>
        public static Var txt_setvisible(TEXT param0, Var param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.txt_setvisible(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// txt_str - see Gamestudio manual
        /// </summary>
        public static STRING txt_str(TEXT param0, int param1)
        {
            unsafe
            {
                NativeTEXT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeTEXT*)(IntPtr)param0;
                }
                int tempParam1 = param1;
                STRING returnParam = (STRING)(IntPtr)NativeEngFun.txt_str(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// font_create - see Gamestudio manual
        /// </summary>
        public static FONT font_create(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.font_create(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return null;
                }
                else
                {
                    return (FONT)returnIntPtr;
                }
            }
        }


        /// <summary>
        /// font_remove - see Gamestudio manual
        /// </summary>
        public static void font_remove(FONT param0)
        {
            unsafe
            {
                NativeFONT* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeFONT*)(IntPtr)param0;
                }
                NativeEngFun.font_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
            }
        }


        /// <summary>
        /// view_create - see Gamestudio manual
        /// </summary>
        public static VIEW view_create(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                VIEW returnParam = (VIEW)(IntPtr)NativeEngFun.view_create(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// view_to_light - see Gamestudio manual
        /// </summary>
        public static Var view_to_light(VIEW param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVIEW* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeVIEW*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeVIEW*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.view_to_light(tempParam0, tempParam1, tempParam2);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_begin - see Gamestudio manual
        /// </summary>
        public static IntPtr draw_begin()
        {
            unsafe
            {
                IntPtr returnParam = (IntPtr)NativeEngFun.draw_begin();
                return returnParam;
            }
        }


        /// <summary>
        /// draw_line - see Gamestudio manual
        /// </summary>
        public static Var draw_line(Vector param0, Color param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.draw_line(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_line3d - see Gamestudio manual
        /// </summary>
        public static Var draw_line3d(Vector param0, Color param1, Var param2)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.draw_line3d(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Vector)(*tempParam0));
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_box3d - see Gamestudio manual
        /// </summary>
        public static Var draw_box3d(Vector param0, Vector param1, Color param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.draw_box3d(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Vector)(*tempParam2));
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_obj - see Gamestudio manual
        /// </summary>
        public static Var draw_obj(IntPtr param0)
        {
            unsafe
            {
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                Var returnParam = (Var)NativeEngFun.draw_obj(param0);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_obj - see Gamestudio manual
        /// </summary>
        public static Var draw_obj(TEXT param0)
        {
            return draw_obj((IntPtr)param0);
        }


        /// <summary>
        /// draw_obj - see Gamestudio manual
        /// </summary>
        public static Var draw_obj(PANEL param0)
        {
            return draw_obj((IntPtr)param0);
        }


        /// <summary>
        /// draw_obj - see Gamestudio manual
        /// </summary>
        public static Var draw_obj(ENTITY param0)
        {
            return draw_obj((IntPtr)param0);
        }


        /// <summary>
        /// draw_point3d - see Gamestudio manual
        /// </summary>
        public static Var draw_point3d(Vector param0, Color param1, Var param2, Var param3)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam0 = (NativeVector)param0;
                    tempParam0 = &ForTempParam0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.draw_point3d(tempParam0, tempParam1, tempParam2, tempParam3);
                param0.getValueFrom((Vector)(*tempParam0));
                param1.getValueFrom((Vector)(*tempParam1));
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_quad - see Gamestudio manual
        /// </summary>
        public static Var draw_quad(BMAP param0, Vector param1, Vector param2, Vector param3, Vector param4, Color param5, Var param6, Var param7)
        {
            unsafe
            {
                NativeBMAP* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeBMAP*)(IntPtr)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    tempParam2 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    tempParam3 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                NativeVector* tempParam4;
                if (param4 == null)
                {
                    tempParam4 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam4 = (NativeVector)param4;
                    tempParam4 = &ForTempParam4;
                }
                NativeVector* tempParam5;
                if (param5 == null)
                {
                    tempParam5 = (NativeVector*)IntPtr.Zero;
                }
                else
                {
                    NativeVector ForTempParam5 = (NativeVector)param5;
                    tempParam5 = &ForTempParam5;
                }
                NativeVar tempParam6;
                if (param6 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam6 = (NativeVar)param6;
                }
                NativeVar tempParam7;
                if (param7 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam7 = (NativeVar)param7;
                }
                Var returnParam = (Var)NativeEngFun.draw_quad(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7);
                param1.getValueFrom((Vector)(*tempParam1));
                param6.getValueFrom((Var)tempParam6);
                param7.getValueFrom((Var)tempParam7);
                return returnParam;
            }
        }


        /// <summary>
        /// draw_text - see Gamestudio manual
        /// </summary>
        public static Var draw_text(String param0, Var param1, Var param2, Color param3)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVector* tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam3 = (NativeVector)param3;
                    tempParam3 = &ForTempParam3;
                }
                Var returnParam = (Var)NativeEngFun.draw_text(tempParam0, tempParam1, tempParam2, tempParam3);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Vector)(*tempParam3));
                return returnParam;
            }
        }


        /// <summary>
        /// draw_textmode - see Gamestudio manual
        /// </summary>
        public static Var draw_textmode(String param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                Var returnParam = (Var)NativeEngFun.draw_textmode(tempParam0, tempParam1, tempParam2, tempParam3);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                return returnParam;
            }
        }


        /// <summary>
        /// send_data_to - see Gamestudio manual
        /// </summary>
        public static Var send_data_to(ENTITY param0, IntPtr param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.send_data_to(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// send_data_id - see Gamestudio manual
        /// </summary>
        public static Var send_data_id(Var param0, IntPtr param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.send_data_id(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// send_skill - see Gamestudio manual
        /// </summary>
        public static Var send_skill(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.send_skill(tempParam0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// send_skill_to - see Gamestudio manual
        /// </summary>
        public static Var send_skill_to(ENTITY param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeVar* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.send_skill_to(tempParam0, tempParam1, tempParam2);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// send_skill_id - see Gamestudio manual
        /// </summary>
        public static Var send_skill_id(Var param0, Var param1, Var param2)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar*)(IntPtr)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.send_skill_id(tempParam0, tempParam1, tempParam2);
                param0.getValueFrom((Var)tempParam0);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }


        /// <summary>
        /// send_string - see Gamestudio manual
        /// </summary>
        public static Var send_string(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.send_string(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// send_string_to - see Gamestudio manual
        /// </summary>
        public static Var send_string_to(ENTITY param0, STRING param1)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (NativeENTITY*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.send_string_to(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// send_string_id - see Gamestudio manual
        /// </summary>
        public static Var send_string_id(Var param0, STRING param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeSTRING* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeSTRING*)(IntPtr)param1;
                }
                Var returnParam = (Var)NativeEngFun.send_string_id(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// session_close - see Gamestudio manual
        /// </summary>
        public static void session_close()
        {
            unsafe
            {
                NativeEngFun.session_close();
            }
        }


        /// <summary>
        /// session_connect - see Gamestudio manual
        /// </summary>
        public static Var session_connect(String param0, String param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    tempParam1 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.session_connect(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// session_open - see Gamestudio manual
        /// </summary>
        public static Var session_open(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.session_open(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// client_drop - see Gamestudio manual
        /// </summary>
        public static Var client_drop(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.client_drop(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// client_drop_id - see Gamestudio manual
        /// </summary>
        public static Var client_drop_id(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.client_drop_id(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_sendnow - see Gamestudio manual
        /// </summary>
        public static Var ent_sendnow(ENTITY param0)
        {
            unsafe
            {
                NativeENTITY* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeENTITY*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.ent_sendnow(tempParam0);
                return returnParam;
            }
        }

        /// <summary>
        /// socket_connect - see Gamestudio manual
        /// </summary>
        public static Var socket_connect(String param0, Var param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                Var returnParam = (Var)NativeEngFun.socket_connect(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                return returnParam;
            }
        }

        /// <summary>
        /// socket_receive - see Gamestudio manual
        /// </summary>
        public static Var socket_receive(IntPtr param0, Var param1, Var param2)
        {
            unsafe
            {
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.socket_receive(param0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }

        /// <summary>
        /// socket_send - see Gamestudio manual
        /// </summary>
        public static Var socket_send(IntPtr param0, Var param1, Var param2)
        {
            unsafe
            {
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.socket_send(param0, tempParam1);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }

        /// <summary>
        /// beep - see Gamestudio manual
        /// </summary>
        public static Var beep()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.beep();
                return returnParam;
            }
        }


        /// <summary>
        /// diag - see Gamestudio manual
        /// </summary>
        public static Var diag(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.diag(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// diag_var - see Gamestudio manual
        /// </summary>
        public static Var diag_var(String param0, Var param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.diag_var(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// diag_frame - see Gamestudio manual
        /// </summary>
        public static Var diag_frame(Var param0)
        {
            unsafe
            {
                NativeVar* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar*)(IntPtr)param0;
                }
                Var returnParam = (Var)NativeEngFun.diag_frame(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// diag_status - see Gamestudio manual
        /// </summary>
        public static Var diag_status()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.diag_status();
                return returnParam;
            }
        }


        /// <summary>
        /// error - see Gamestudio manual
        /// </summary>
        public static Var error(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.error(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// timer - see Gamestudio manual
        /// </summary>
        public static Var timer()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.timer();
                return returnParam;
            }
        }


        /// <summary>
        /// breaks - see Gamestudio manual
        /// </summary>
        public static Var breaks()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.breaks();
                return returnParam;
            }
        }


        /// <summary>
        /// port_in - see Gamestudio manual
        /// </summary>
        public static Var port_in(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.port_in(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// port_out - see Gamestudio manual
        /// </summary>
        public static Var port_out(Var param0, Var param1)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                Var returnParam = (Var)NativeEngFun.port_out(tempParam0, tempParam1);
                param0.getValueFrom((Var)tempParam0);
                param1.getValueFrom((Var)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// wiimote_handle - see Gamestudio manual
        /// </summary>
        public static Var wiimote_handle(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                Var returnParam = (Var)NativeEngFun.wiimote_handle(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// exec - see Gamestudio manual
        /// </summary>
        public static Var exec(String param0, String param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.exec(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// exec_wait - see Gamestudio manual
        /// </summary>
        public static Var exec_wait(String param0, String param1)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                char* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (char*)(void*)Marshal.StringToHGlobalAnsi(param1);
                }
                Var returnParam = (Var)NativeEngFun.exec_wait(tempParam0, tempParam1);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                param1 = Marshal.PtrToStringAnsi((IntPtr)tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// execute - see Gamestudio manual
        /// </summary>
        public static Var execute(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.execute(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// var_for_name - see Gamestudio manual
        /// </summary>
        public static IntPtr var_for_name(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.var_for_name(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ptr_first - see Gamestudio manual
        /// </summary>
        public static IntPtr ptr_first(IntPtr param0)
        {
            unsafe
            {
                void* tempParam0;
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (void*)param0;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.ptr_first(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// ptr_remove - see Gamestudio manual
        /// </summary>
        public static Var ptr_remove(IntPtr param0)
        {
            unsafe
            {
                void* tempParam0;
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (void*)param0;
                }
                Var returnParam = (Var)NativeEngFun.ptr_remove(tempParam0);
                Scheduler.RemoveFromKeepReferenceList((IntPtr)param0);
                return returnParam;
            }
        }

        /// <summary>
        /// ptr_remove for ENTITY
        /// </summary>
        public static Var ptr_remove(ENTITY param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for STRING
        /// </summary>
        public static Var ptr_remove(STRING param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for BMAP
        /// </summary>
        public static Var ptr_remove(BMAP param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for VIEW
        /// </summary>
        public static Var ptr_remove(VIEW param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for PANEL
        /// </summary>
        public static Var ptr_remove(PANEL param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for TEXT
        /// </summary>
        public static Var ptr_remove(TEXT param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for FONT
        /// </summary>
        public static Var ptr_remove(FONT param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for SOUND
        /// </summary>
        public static Var ptr_remove(SOUND param0)
        {
            return ptr_remove((IntPtr)param0);
        }

        /// <summary>
        /// ptr_remove for MATERIAL
        /// </summary>
        public static Var ptr_remove(MATERIAL param0)
        {
            return ptr_remove((IntPtr)param0);
        }


        /// <summary>
        /// ptr_for_handle - see Gamestudio manual
        /// </summary>
        public static IntPtr ptr_for_handle(Var param0)
        {
            unsafe
            {
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                IntPtr returnParam = (IntPtr)NativeEngFun.ptr_for_handle(tempParam0);
                param0.getValueFrom((Var)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// handle - see Gamestudio manual
        /// </summary>
        public static Var handle(IntPtr param0)
        {
            unsafe
            {
                void* tempParam0;
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (void*)param0;
                }
                Var returnParam = (Var)NativeEngFun.handle(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// sys_malloc - see Gamestudio manual
        /// </summary>
        public static IntPtr sys_malloc(int param0)
        {
            unsafe
            {
                return (IntPtr)NativeEngFun.sys_malloc(param0);
            }
        }


        /// <summary>
        /// sys_nxalloc - see Gamestudio manual
        /// </summary>
        public static IntPtr sys_nxalloc(int param0)
        {
            unsafe
            {
                return (IntPtr)NativeEngFun.sys_nxalloc(param0);
            }
        }


        /// <summary>
        /// sys_free - see Gamestudio manual
        /// </summary>
        public static void sys_free(IntPtr param0)
        {
            unsafe
            {
                NativeEngFun.sys_free((void*)param0);
            }
        }


        /// <summary>
        /// _chr - see Gamestudio manual
        /// </summary>
        public static String _chr(STRING param0)
        {
            unsafe
            {
                NativeSTRING* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeSTRING*)(IntPtr)param0;
                }
                String returnParam = Marshal.PtrToStringAnsi((IntPtr)NativeEngFun._chr(tempParam0));
                return returnParam;
            }
        }


        /// <summary>
        /// _str - see Gamestudio manual
        /// </summary>
        public static STRING _str(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                STRING returnParam = (STRING)(IntPtr)NativeEngFun._str(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// _vec - see Gamestudio manual
        /// </summary>
        public static Vector _vec(float param0, float param1, float param2)
        {
            unsafe
            {
                float tempParam0 = param0;
                float tempParam1 = param1;
                float tempParam2 = param2;
                Vector returnParam = (Vector)(*NativeEngFun._vec(tempParam0, tempParam1, tempParam2));
                return returnParam;
            }
        }


        /// <summary>
        /// add_buffer - see Gamestudio manual
        /// </summary>
        public static Var add_buffer(String param0, IntPtr param1, int param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    tempParam1 = (void*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                int tempParam2 = param2;
                Var returnParam = (Var)NativeEngFun.add_buffer(tempParam0, tempParam1, tempParam2);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// add_folder - see Gamestudio manual
        /// </summary>
        public static Var add_folder(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.add_folder(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// add_resource - see Gamestudio manual
        /// </summary>
        public static Var add_resource(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                Var returnParam = (Var)NativeEngFun.add_resource(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// add_new - see Gamestudio manual
        /// </summary>
        public static Var add_new()
        {
            unsafe
            {
                Var returnParam = (Var)NativeEngFun.add_new();
                return returnParam;
            }
        }


        /// <summary>
        /// add_struct - see Gamestudio manual
        /// </summary>
        public static Var add_struct(IntPtr param0, int param1)
        {
            unsafe
            {
                void* tempParam0;
                if (param0 == IntPtr.Zero)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (void*)param0;
                }
                int tempParam1 = param1;
                Var returnParam = (Var)NativeEngFun.add_struct(tempParam0, tempParam1);
                return returnParam;
            }
        }


        /// <summary>
        /// engine_getobj - see Gamestudio manual
        /// </summary>
        public static int engine_getobj(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                int returnParam = NativeEngFun.engine_getobj(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// engine_getfunc - see Gamestudio manual
        /// </summary>
        public static int engine_getfunc(String param0)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                int returnParam = NativeEngFun.engine_getfunc(tempParam0);
                param0 = Marshal.PtrToStringAnsi((IntPtr)tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// engine_debugstep - see Gamestudio manual
        /// </summary>
        public static int engine_debugstep(int param0)
        {
            unsafe
            {
                int tempParam0 = param0;
                int returnParam = NativeEngFun.engine_debugstep(tempParam0);
                return returnParam;
            }
        }


        /// <summary>
        /// engine_frame - see Gamestudio manual
        /// </summary>
        public static int engine_frame()
        {
            unsafe
            {
                int returnParam = NativeEngFun.engine_frame();
                return returnParam;
            }
        }


        /// <summary>
        /// engine_close - see Gamestudio manual
        /// </summary>
        public static void engine_close()
        {
            unsafe
            {
                if (Scheduler.SchedulerEnabled == false)
                {
                    EngVar.ResetReferences();   //set all EngVar references to null
                    NativeEngFun.engine_close();
                }

                Scheduler.EngineClosed = true;
            }
        }


        /// <summary>
        /// additional flags for c_scan (other flags for c_scan are in c_FLAGS
        /// </summary>
        public enum c_scan_FLAGS : int
        {
            SCAN_ENTS = 0 << 14,
            SCAN_PATHS = 2 << 14,
            SCAN_NODES = 3 << 14,
            SCAN_POS = 4 << 14,
            SCAN_LIGHTS = 5 << 14,
            SCAN_LIMIT = 1 << 18,
            SCAN_FLAG2 = 1 << 20
        }

        /// <summary>
        /// flags for ent_animate
        /// </summary>
        public enum ent_anim_FLAGS : int
        {
            ANM_CYCLE = 1 << 0,
            ANM_ADD = 1 << 1,
            ANM_SKIP = 1 << 2
        }


        /// <summary>
        /// The following mode flags can be combined: 
        /// </summary>
        public enum c_FLAGS : int
        {
            IGNORE_ME = 1 << 0,
            IGNORE_YOU = 1 << 1,
            IGNORE_FLAG2 = 1 << 21,
            IGNORE_PASSABLE = 1 << 2,
            IGNORE_PASSENTS = 1 << 3,
            IGNORE_WORLD = 1 << 8,
            IGNORE_MAPS = 1 << 7,
            IGNORE_MODELS = 1 << 4,
            IGNORE_SPRITES = 1 << 5,
            IGNORE_PUSH = 1 << 9,
            IGNORE_CONTENT = 1 << 6,
            USE_POLYGON = 1 << 19,
            USE_BOX = 1 << 13,
            USE_AABB = 1 << 17,
            GLIDE = 1 << 18,
            ACTIVATE_SHOOT = 1 << 10,
            ACTIVATE_SONAR = 1 << 11,
            SCAN_TEXTURE = 1 << 16
        }

        /// <summary>
        /// network flags
        /// </summary>
        public enum send_Flags : int
        {
            SEND_VEC = 1,
            SEND_ALL = 2,
            SEND_RATE = 4,
            SEND_UNRELIABLE = 8
        }

        /// <summary>
        /// view_to_matrix - see Gamestudio manual
        /// </summary>
        public static MATRIX view_to_matrix(VIEW param0, MATRIX param1, MATRIX param2)
        {
            unsafe
            {
                NativeVIEW* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVIEW*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float *)(IntPtr)param1;
                }
                float* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (float *)(IntPtr)param2;
                }
                return (MATRIX)(IntPtr)NativeEngFun.view_to_matrix(tempParam0, tempParam1, tempParam2);
            }
        }

        /// <summary>
        /// mat_identity - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_identity(MATRIX param0)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_identity(tempParam0);
            }
        }

 
        /// <summary>
        /// mat_inverse - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_inverse(MATRIX param0, MATRIX param1)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_inverse(tempParam0, tempParam1);
            }
        }


        /// <summary>
        /// mat_multiply - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_multiply(MATRIX param0, MATRIX param1)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_multiply(tempParam0, tempParam1);
            }
        }


        /// <summary>
        /// mat_scale - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_scale(MATRIX param0, Var param1, Var param2, Var param3)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_scale(tempParam0, tempParam1, tempParam2, tempParam3);
            }
        }


        /// <summary>
        /// mat_set - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_set(MATRIX param0, MATRIX param1)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_set(tempParam0, tempParam1);
            }
        }


        /// <summary>
        /// mat_transpose - see Gamestudio manual
        /// </summary>
        public static MATRIX mat_transpose(MATRIX param0, MATRIX param1)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.mat_transpose(tempParam0, tempParam1);
            }
        }


        /// <summary>
        /// mat_effect - see Gamestudio manual
        /// </summary>
        public static Var mat_effect(MATRIX param0)
        {
            unsafe
            {
                float* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (float*)(IntPtr)param0;
                }
                return (Var)NativeEngFun.mat_effect(tempParam0);
            }
        }


        /// <summary>
        /// ang_to_matrix - see Gamestudio manual
        /// </summary>
        public static MATRIX ang_to_matrix(Angle param0, MATRIX param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVector*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.ang_to_matrix(tempParam0, tempParam1);
            }
        }


        /// <summary>
        /// ang_for_matrix - see Gamestudio manual
        /// </summary>
        public static MATRIX ang_for_matrix(Angle param0, MATRIX param1)
        {
            unsafe
            {
                NativeVector* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVector*)(IntPtr)param0;
                }
                float* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (float*)(IntPtr)param1;
                }
                return (MATRIX)(IntPtr)NativeEngFun.ang_for_matrix(tempParam0, tempParam1);
            }
        }

        #region path_ -> Attention beta stage

        /// <summary>
        /// path_setnode - see Gamestudio manual
        /// </summary>
        public static Var path_setnode(ENTITY entity, Var node, Vector pos, Var[] skills)
        {
            unsafe
            {
                NativeVar[] temporarySkills = new NativeVar[6];
                NativeVar* tempSkills = (NativeVar*)Marshal.AllocHGlobal(Marshal.SizeOf(temporarySkills));   //nullable
                if (skills != null)
                {
                    temporarySkills[0] = (NativeVar)skills[0];
                    temporarySkills[1] = (NativeVar)skills[1];
                    temporarySkills[2] = (NativeVar)skills[2];
                    temporarySkills[3] = (NativeVar)skills[3];
                    temporarySkills[4] = (NativeVar)skills[4];
                    temporarySkills[5] = (NativeVar)skills[5];
                    Marshal.StructureToPtr(temporarySkills, (IntPtr)tempSkills, false);
                }
                NativeVector* tempPos = (NativeVector*)IntPtr.Zero; //nullable
                if (pos != null)
                {
                    NativeVector temporaryPos = (NativeVector)pos;
                    tempPos = &temporaryPos;
                }
                return (Var)NativeEngFun.path_setnode((NativeENTITY*)(IntPtr)entity, (NativeVar)node, tempPos, tempSkills);
            }
        }


        /// <summary>
        /// path_getnode - see Gamestudio manual
        /// </summary>
        public static Var path_getnode(ENTITY entity, Var node, ref Vector pos, ref Var[] skills)
        {
            unsafe
            {
                NativeVar[] tempSkills = new NativeVar[6];
                NativeVar* pointerToTempSkills = (NativeVar*)Marshal.AllocHGlobal(Marshal.SizeOf(tempSkills));
                Marshal.StructureToPtr(tempSkills, (IntPtr)pointerToTempSkills, false);
                NativeVector tempPos = new NativeVector();
                Var returnVar = (Var)NativeEngFun.path_getnode((NativeENTITY*)(IntPtr)entity, (NativeVar)node, &tempPos, pointerToTempSkills);
                if (skills != null)
                {
                    NativeVar[] SkillsReceived = (NativeVar[])Marshal.PtrToStructure((IntPtr)pointerToTempSkills, typeof(NativeVar[]));
                    skills[0] = (Var)SkillsReceived[0];
                    skills[1] = (Var)SkillsReceived[1];
                    skills[2] = (Var)SkillsReceived[2];
                    skills[3] = (Var)SkillsReceived[3];
                    skills[4] = (Var)SkillsReceived[4];
                    skills[5] = (Var)SkillsReceived[5];
                }
                if (pos != null)
                {
                    pos.getValueFrom((Vector)tempPos);
                }
                return returnVar;
            }
        }


        /// <summary>
        /// path_setedge - see Gamestudio manual
        /// </summary>
        public static Var path_setedge(ENTITY entity, Var node, Var edge, Var[] skills)
        {
            unsafe
            {
                NativeVector tempSkills = (NativeVector)new Vector(skills[0], skills[1], skills[2]);
                return (Var)NativeEngFun.path_setedge((NativeENTITY*)(IntPtr)entity, (NativeVar)node, (NativeVar)edge, &tempSkills);
            }
        }


        /// <summary>
        /// path_gededge - see Gamestudio manual
        /// </summary>
        public static Var path_getedge(ENTITY entity, Var node, Var edge, ref Var[] skills)
        {
            unsafe
            {
                NativeVector tempSkills = new NativeVector();
                Var returnVar = (Var)NativeEngFun.path_getedge((NativeENTITY*)(IntPtr)entity, (NativeVar)node, (NativeVar)edge, &tempSkills);
                skills[0] = (Var)tempSkills.x;
                skills[1] = (Var)tempSkills.y;
                skills[2] = (Var)tempSkills.z;
                return returnVar;
            }
        }
        #endregion

        /// <summary>
        /// ent_create - see Gamestudio manual
        /// </summary>
        public static ENTITY ent_create(String param0, Vector param1, EventIntPtr function)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeEVENT tempFunction;
                Scheduler.EventIntPtrReference TempEventIntPtrReference = null;
                if (function == null)
                    tempFunction.mPtr = null;
                else
                {
                    TempEventIntPtrReference = new Scheduler.EventIntPtrReference(function, IntPtr.Zero);
                    tempFunction.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventIntPtr)TempEventIntPtrReference.NativeEventIntPtrFunc);
                }
                NativeENTITY* tempEntity = NativeEngFun.ent_create(tempParam0, tempParam1, tempFunction);
                if (TempEventIntPtrReference != null)
                {
                    TempEventIntPtrReference.EngObjIntPtr = (IntPtr)tempEntity;
                }
                return (ENTITY)(IntPtr)tempEntity;
            }
        }


        /// <summary>
        /// ent_create - see Gamestudio manual
        /// </summary>
        public static IntPtr ent_createlocal(String param0, Vector param1, EventIntPtr function)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeEVENT tempFunction;
                Scheduler.EventIntPtrReference TempEventVoidReference = null;
                if (function == null)
                    tempFunction.mPtr = null;
                else
                {
                    TempEventVoidReference = new Scheduler.EventIntPtrReference(function, IntPtr.Zero);
                    tempFunction.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventIntPtr)TempEventVoidReference.NativeEventIntPtrFunc);
                }
                NativeENTITY* tempEntity = NativeEngFun.ent_createlocal(tempParam0, tempParam1, tempFunction);
                if (TempEventVoidReference != null)
                {
                    TempEventVoidReference.EngObjIntPtr = (IntPtr)tempEntity;
                }
                return (IntPtr)tempEntity;
            }
        }


        /// <summary>
        /// engine_open - see Gamestudio manual
        /// </summary>
        public static void engine_open(String commandline)
        {
            unsafe
            {
                char* tempString = (char*)(void*)Marshal.StringToHGlobalAnsi(commandline);
                EngVar.EngineVarPtr = NativeEngFun.engine_open(tempString, 0);
                Scheduler.EngineClosed = false;
            }
        }
        

        /// <summary>
        /// pan_setevent - see Gamestudio manual
        /// </summary>
        public static Var pan_setevent(PANEL param0, Var param1, Var param2, EventVoid function) {

            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeEVENT tempFunction;
                Scheduler.EventVoidReference TempEventVoidReference = null;
                if (function == null)
                    tempFunction.mPtr = null;
                else
                {
                    TempEventVoidReference = new Scheduler.EventVoidReference(function, (IntPtr)param0);
                    tempFunction.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)TempEventVoidReference.NativeEventVoidFunc);
                }
                return (Var)NativeEngFun.pan_setevent(tempParam0, tempParam1, tempParam2, tempFunction);
            }
        }


        /// <summary>
        /// pan_setbutton - see Gamestudio manual
        /// </summary>
        public static Var pan_setbutton(PANEL param0, Var param1, Var param2, Var param3, Var param4, BMAP param5, BMAP param6, BMAP param7, BMAP param8, EventVoid param9, EventVoid param10, EventVoid param11)
        {
            unsafe
            {
                NativePANEL* tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativePANEL*)(IntPtr)param0;
                }
                NativeVar tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam1 = (NativeVar)param1;
                }
                NativeVar tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (NativeVar)param2;
                }
                NativeVar tempParam3;
                if (param3 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam3 = (NativeVar)param3;
                }
                NativeVar tempParam4;
                if (param4 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam4 = (NativeVar)param4;
                }
                NativeBMAP* tempParam5;
                if (param5 == null)
                {
                    tempParam5 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam5 = (NativeBMAP*)(IntPtr)param5;
                }
                NativeBMAP* tempParam6;
                if (param6 == null)
                {
                    tempParam6 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam6 = (NativeBMAP*)(IntPtr)param6;
                }
                NativeBMAP* tempParam7;
                if (param7 == null)
                {
                    tempParam7 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam7 = (NativeBMAP*)(IntPtr)param7;
                }
                NativeBMAP* tempParam8;
                if (param8 == null)
                {
                    tempParam8 = (NativeBMAP*)IntPtr.Zero;
                }
                else
                {
                    tempParam8 = (NativeBMAP*)(IntPtr)param8;
                }
                NativeEVENT tempParam9;
                Scheduler.EventVoidReference TempEventVoidReferencetempParam9 = null;
                if (param9 == null)
                    tempParam9.mPtr = null;
                else
                {
                    TempEventVoidReferencetempParam9 = new Scheduler.EventVoidReference(param9, (IntPtr)param0);
                    tempParam9.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)TempEventVoidReferencetempParam9.NativeEventVoidFunc);
                }
                NativeEVENT tempParam10;
                Scheduler.EventVoidReference TempEventVoidReferencetempParam10 = null;
                if (param10 == null)
                    tempParam10.mPtr = null;
                else
                {
                    TempEventVoidReferencetempParam10 = new Scheduler.EventVoidReference(param10, (IntPtr)param0);
                    tempParam10.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)TempEventVoidReferencetempParam10.NativeEventVoidFunc);
                }
                NativeEVENT tempParam11;
                Scheduler.EventVoidReference TempEventVoidReferencetempParam11 = null;
                if (param11 == null)
                    tempParam11.mPtr = null;
                else
                {
                    TempEventVoidReferencetempParam11 = new Scheduler.EventVoidReference(param11, (IntPtr)param0);
                    tempParam11.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)TempEventVoidReferencetempParam11.NativeEventVoidFunc);
                }
                Var returnParam = (Var)NativeEngFun.pan_setbutton(tempParam0, tempParam1, tempParam2, tempParam3, tempParam4, tempParam5, tempParam6, tempParam7, tempParam8, tempParam9, tempParam10, tempParam11);
                param1.getValueFrom((Var)tempParam1);
                param2.getValueFrom((Var)tempParam2);
                param3.getValueFrom((Var)tempParam3);
                param4.getValueFrom((Var)tempParam4);
                return returnParam;
            }
        }


        /// <summary>
        /// ent_create - see Gamestudio manual
        /// </summary>
        public static Var effect(EventPARTICLE function, Var param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeEVENT tempFunction;
                Scheduler.EventParticleReference TempParticleReference = null;
                if (function == null)
                    tempFunction.mPtr = null;
                else
                {
                    TempParticleReference = new Scheduler.EventParticleReference(function);
                    tempFunction.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventPARTICLE)TempParticleReference.NativeEventParticleFunc);
                }
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                return (Var)NativeEngFun.effect(tempFunction, tempParam0, tempParam1, tempParam2);
            }
        }


        /// <summary>
        /// ent_create - see Gamestudio manual
        /// </summary>
        public static Var effect_local(EventPARTICLE function, Var param0, Vector param1, Vector param2)
        {
            unsafe
            {
                NativeEVENT tempFunction;
                Scheduler.EventParticleReference TempParticleReference = null;
                if (function == null)
                    tempFunction.mPtr = null;
                else
                {
                    TempParticleReference = new Scheduler.EventParticleReference(function);
                    tempFunction.mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventPARTICLE)TempParticleReference.NativeEventParticleFunc);
                }
                NativeVar tempParam0;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam0 = (NativeVar)param0;
                }
                NativeVector* tempParam1;
                if (param1 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam1 = (NativeVector)param1;
                    tempParam1 = &ForTempParam1;
                }
                NativeVector* tempParam2;
                if (param2 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    NativeVector ForTempParam2 = (NativeVector)param2;
                    tempParam2 = &ForTempParam2;
                }
                return (Var)NativeEngFun.effect_local(tempFunction, tempParam0, tempParam1, tempParam2);
            }
        }

        /// <summary>
        /// file_load - see Gamestudio manual ATTENTION ! : you have to set the value of param2 with .setRealInt(x) !!
        /// </summary>
        public static IntPtr file_load(String param0, IntPtr param1, Var param2)
        {
            unsafe
            {
                char* tempParam0;
                if (param0 == null)
                {
                    tempParam0 = (char*)IntPtr.Zero;
                }
                else
                {
                    tempParam0 = (char*)(void*)Marshal.StringToHGlobalAnsi(param0);
                }
                void* tempParam1;
                if (param1 == IntPtr.Zero)
                {
                    tempParam1 = (void*)IntPtr.Zero;
                }
                else
                {
                    tempParam1 = (void*)param1;
                }
                long* tempParam2;
                if (param0 == null)
                {
                    throw new ArgumentNullException("parameter");
                }
                else
                {
                    tempParam2 = (long*)(IntPtr)param2;
                }
                IntPtr returnIntPtr = (IntPtr)NativeEngFun.file_load(tempParam0, tempParam1, tempParam2);
                if (returnIntPtr == IntPtr.Zero)
                {
                    return IntPtr.Zero;
                }
                else
                {
                    return returnIntPtr;
                }
            }
        }
    }
}