﻿/*
 * project : AcknexWrapper 1.0.2 for V7.82.3
 * created by : Matthias Auer
 * contact : mail@matthias-auer.net
 * homepage : http://acknexwrapper.matthias-auer.net/
 * date : 05.04.10
 */

using System;
using System.Runtime.InteropServices;
using AcknexWrapper.Native;

namespace AcknexWrapper {
    public static class EngVar
    {
        /// <summary>
        /// This IntPtr points to the NativeENGINE_VARS struct whose pointer is passed by engine_open - change under NO CIRCUMSTANCES !
        /// </summary>
        internal static IntPtr EngineVarPtr;

        /// <summary>
        /// reset all EngVar
        /// </summary>
        internal static void ResetReferences()
        {
            ambient_color_ = null;
            bounce_ = null;
            cdaudio_vol_ = null;
            clip_factor_ = null;
            clip_particles_ = null;
            clip_size_ = null;
            cloud_speed_ = null;
            compatibility_ = null;
            connection_ = null;
            d3d_alphadepth_ = null;
            d3d_alpharef_ = null;
            d3d_anisotropy_ = null;
            d3d_antialias_ = null;
            d3d_automaterial_ = null;
            d3d_autotransparency_ = null;
            d3d_caps_ = null;
            d3d_texlimit_ = null;
            d3d_entsort_ = null;
            d3d_fogcolor1_ = null;
            d3d_fogcolor2_ = null;
            d3d_fogcolor3_ = null;
            d3d_fogcolor4_ = null;
            d3d_lightres_ = null;
            d3d_lines_ = null;
            d3d_lockable_ = null;
            effect_lod_ = null;
            d3d_lodfactor_ = null;
            d3d_mipmapping_ = null;
            d3d_mode_ = null;
            d3d_monochrome_ = null;
            d3d_near_models_ = null;
            d3d_near_sprites_ = null;
            d3d_nobsp_ = null;
            d3d_noents_ = null;
            d3d_notex_ = null;
            d3d_novis_ = null;
            d3d_optimize_ = null;
            d3d_pointlightfalloff_ = null;
            d3d_shaderversion_ = null;
            d3d_shadowdepth_ = null;
            d3d_skydepth_ = null;
            d3d_spotlightcone_ = null;
            d3d_spotlightfalloff_ = null;
            d3d_texbmaps_ = null;
            d3d_texdepth_ = null;
            d3d_texfree_ = null;
            d3d_texlimit_ = null;
            d3d_texmax_ = null;
            d3d_texmemory_ = null;
            d3d_texskins_ = null;
            d3d_texsmaps_ = null;
            d3d_texsurfs_ = null;
            d3d_textotal_ = null;
            d3d_triplebuffer_ = null;
            d3d_instancing_ = null;
            debug_external_ = null;
            debug_mode_ = null;
            decal_clip_ = null;
            detail_size_ = null;
            diag_mode_ = null;
            disable_z_glide_ = null;
            doppler_factor_ = null;
            dplay_bandwidth_ = null;
            dplay_bps_ = null;
            dplay_bpspeak_ = null;
            dplay_bpsreliable_ = null;
            dplay_bpsunreliable_ = null;
            dplay_compression_ = null;
            dplay_diag_ = null;
            dplay_dropped_ = null;
            dplay_encrypt_ = null;
            dplay_entrate_ = null;
            dplay_entupdate_ = null;
            dplay_id_ = null;
            dplay_latency_ = null;
            dplay_localfunction_ = null;
            dplay_maxclients_ = null;
            dplay_packetsize_ = null;
            dplay_pingrate_ = null;
            dplay_port_ = null;
            dplay_smooth_ = null;
            dplay_status_ = null;
            dplay_timeout_ = null;
            dplay_unreliable_ = null;
            edition_ = null;
            enable_joystick_ = null;
            enable_mouse_ = null;
            enable_polycollision_ = null;
            event_type_ = null;
            floor_range_ = null;
            fog_color_ = null;
            fps_lock_ = null;
            fps_max_ = null;
            fps_min_ = null;
            freeze_mode_ = null;
            hitvertex_ = null;
            hull_fatmax_ = null;
            hull_fatmin_ = null;
            hull_narrowmax_ = null;
            hull_narrowmin_ = null;
            in_passable_ = null;
            in_solid_ = null;
            inkey_active_ = null;
            joy_1_ = null;
            joy_10_ = null;
            joy_11_ = null;
            joy_12_ = null;
            joy_2_ = null;
            joy_3_ = null;
            joy_4_ = null;
            joy_5_ = null;
            joy_6_ = null;
            joy_7_ = null;
            joy_8_ = null;
            joy_9_ = null;
            joy_buttons_ = null;
            joy_force_ = null;
            joy_hat_ = null;
            joy_raw_ = null;
            joy_rot_ = null;
            joy_sense_ = null;
            joy2_1_ = null;
            joy2_10_ = null;
            joy2_11_ = null;
            joy2_12_ = null;
            joy2_2_ = null;
            joy2_3_ = null;
            joy2_4_ = null;
            joy2_5_ = null;
            joy2_6_ = null;
            joy2_7_ = null;
            joy2_8_ = null;
            joy2_9_ = null;
            joy2_buttons_ = null;
            joy2_hat_ = null;
            joy2_raw_ = null;
            joy2_rot_ = null;
            key_0_ = null;
            key_1_ = null;
            key_2_ = null;
            key_3_ = null;
            key_4_ = null;
            key_5_ = null;
            key_6_ = null;
            key_7_ = null;
            key_8_ = null;
            key_9_ = null;
            key_a_ = null;
            key_ae_ = null;
            key_alt_ = null;
            key_any_ = null;
            key_apos_ = null;
            key_b_ = null;
            key_bksl_ = null;
            key_bksp_ = null;
            key_brackl_ = null;
            key_brackr_ = null;
            key_c_ = null;
            key_cal_ = null;
            key_caps_ = null;
            key_car_ = null;
            key_comma_ = null;
            key_ctrl_ = null;
            key_cud_ = null;
            key_cul_ = null;
            key_cur_ = null;
            key_cuu_ = null;
            key_d_ = null;
            key_del_ = null;
            key_e_ = null;
            key_end_ = null;
            key_enter_ = null;
            key_equals_ = null;
            key_esc_ = null;
            key_f_ = null;
            key_f1_ = null;
            key_f10_ = null;
            key_f11_ = null;
            key_f12_ = null;
            key_f2_ = null;
            key_f3_ = null;
            key_f4_ = null;
            key_f5_ = null;
            key_f6_ = null;
            key_f7_ = null;
            key_f8_ = null;
            key_f9_ = null;
            key_force_ = null;
            key_g_ = null;
            key_grave_ = null;
            key_h_ = null;
            key_home_ = null;
            key_i_ = null;
            key_ins_ = null;
            key_j_ = null;
            key_k_ = null;
            key_l_ = null;
            key_lastpressed_ = null;
            key_m_ = null;
            key_minusc_ = null;
            key_n_ = null;
            key_o_ = null;
            key_oe_ = null;
            key_p_ = null;
            key_pause_ = null;
            key_period_ = null;
            key_pgdn_ = null;
            key_pgup_ = null;
            key_plus_ = null;
            key_q_ = null;
            key_r_ = null;
            key_s_ = null;
            key_scrlk_ = null;
            key_semic_ = null;
            key_sense_ = null;
            key_shift_ = null;
            key_shiftl_ = null;
            key_shiftr_ = null;
            key_slash_ = null;
            key_space_ = null;
            key_sz_ = null;
            key_t_ = null;
            key_tab_ = null;
            key_u_ = null;
            key_ue_ = null;
            key_v_ = null;
            key_w_ = null;
            key_x_ = null;
            key_y_ = null;
            key_z_ = null;
            last_error_ = null;
            last_skill_ = null;
            logo_ = null;
            map_subents_ = null;
            master_vol_ = null;
            max_bones_ = null;
            max_entities_ = null;
            max_lights_ = null;
            max_loops_ = null;
            max_nexus_ = null;
            max_particles_ = null;
            max_ph_entities_ = null;
            media_handle_ = null;
            media_layer_ = null;
            mickey_ = null;
            midi_vol_ = null;
            mip_flat_ = null;
            mip_levels_ = null;
            mip_shaded_ = null;
            mip_sprites_ = null;
            mouse_calm_ = null;
            mouse_cursor_ = null;
            mouse_dir3d_ = null;
            mouse_force_ = null;
            mouse_left_ = null;
            mouse_middle_ = null;
            mouse_mode_ = null;
            mouse_moving_ = null;
            mouse_pointer_ = null;
            mouse_pos_ = null;
            mouse_pos3d_ = null;
            mouse_range_ = null;
            mouse_right_ = null;
            mouse_sense_ = null;
            mouse_spot_ = null;
            mouse_sync_ = null;
            mouse_time_ = null;
            mouse_valid_ = null;
            move_friction_ = null;
            move_min_z_ = null;
            move_mode_ = null;
            move_pushback_ = null;
            move_restrict_ = null;
            mtl_mode_ = null;
            nexus_ = null;
            num_actions_ = null;
            num_clients_ = null;
            num_entities_ = null;
            num_joysticks_ = null;
            num_lights_ = null;
            num_mediastreams_ = null;
            num_particles_ = null;
            num_sounds_ = null;
            num_visentpolys_ = null;
            num_visents_ = null;
            num_vismappolys_ = null;
            num_vistriangles_ = null;
            
            /* on_ don't need to be reset as they will automatically reset when the user adds a new on_ event */

            particle_mode_ = null;
            patch_ = null;
            ph_check_distance_ = null;
            ph_fps_max_lock_ = null;
            ph_iterations_ = null;
            ph_max_contacts_ = null;
            ph_num_bodies_ = null;
            ph_num_collisions_ = null;
            ph_num_contacts_ = null;
            pos_resolution_ = null;
            preload_mode_ = null;
            proc_mode_ = null;
            recbuf_size_ = null;
            record_mode_ = null;
            render_entitiesKeepReference = null;
            render_skyKeepReference = null;
            render_solidKeepReference = null;
            render_worldKeepReference = null;
            result_ = null;
            run_mode_ = null;
            screen_color_ = null;
            screen_size_ = null;
            shadow_lod_ = null;
            shadow_meshsize_ = null;
            shadow_mode_ = null;
            shadow_offset_ = null;
            shadow_range_ = null;
            shadow_stencil_ = null;
            shadow_threshold_ = null;
            shift_sense_ = null;
            sky_blend_ = null;
            sky_clip_ = null;
            sky_color_ = null;
            sky_curve_ = null;
            sky_speed_ = null;
            sound_vol_ = null;
            sun_angle_ = null;
            sun_color_ = null;
            sun_light_ = null;
            sun_pos_ = null;
            sys_day_ = null;
            sys_dow_ = null;
            sys_doy_ = null;
            sys_hours_ = null;
            sys_memory_ = null;
            sys_winversion_ = null;
            sys_minutes_ = null;
            sys_month_ = null;
            sys_seconds_ = null;
            sys_year_ = null;
            target_ = null;
            terrain_cell_size_ = null;
            terrain_chunk_ = null;
            terrain_lod_ = null;
            tex_color_ = null;
            tex_cycles_ = null;
            tex_flag1_ = null;
            tex_flag2_ = null;
            tex_flag3_ = null;
            tex_flag4_ = null;
            tex_flag5_ = null;
            tex_flag6_ = null;
            tex_flag7_ = null;
            tex_flag8_ = null;
            tex_fog_ = null;
            tex_light_ = null;
            tex_share_ = null;
            text_outline_ = null;
            time_actions_ = null;
            time_client_ = null;
            time_draw_ = null;
            time_effects_ = null;
            time_entities_ = null;
            time_factor_ = null;
            time_frame_ = null;
            time_idle_ = null;
            time_level_ = null;
            time_panels_ = null;
            time_pfuncs_ = null;
            time_physics_ = null;
            time_portals_ = null;
            time_render_ = null;
            time_scope_ = null;
            time_server_ = null;
            time_sky_ = null;
            time_smooth_ = null;
            time_step_ = null;
            time_total_ = null;
            time_update_ = null;
            total_frames_ = null;
            total_secs_ = null;
            total_ticks_ = null;
            touch_state_ = null;
            trace_floor_ = null;
            trace_hit_ = null;
            trace_mode_ = null;
            tree_range_ = null;
            turb_range_ = null;
            turb_speed_ = null;
            version_ = null;
            vglide_ = null;
            video_alpha_ = null;
            video_aspect_ = null;
            video_depth_ = null;
            video_gamma_ = null;
            video_mode_ = null;
            video_screen_ = null;
            warn_level_ = null;
            window_focus_ = null;
            window_pos_ = null;
        }

        /// <summary>
        /// version - see Gamestudio manual
        /// </summary>
        private static Var version_ = null;
        public static Var version
        {
            get
            {
                unsafe
                {
                    if (version_ == null)
                    {
                        version_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).version;
                    }
                }
                return version_;
            }
        }

        /// <summary>
        /// edition - see Gamestudio manual
        /// </summary>
        private static Var edition_ = null;
        public static Var edition
        {
            get
            {
                unsafe
                {
                    if (edition_ == null)
                    {
                        edition_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).edition;
                    }
                }
                return edition_;
            }
        }

        /// <summary>
        /// compatibility - see Gamestudio manual
        /// </summary>
        private static Var compatibility_ = null;
        public static Var compatibility
        {
            get
            {
                unsafe
                {
                    if (compatibility_ == null)
                    {
                        compatibility_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).compatibility;
                    }
                }
                return compatibility_;
            }
        }

        /// <summary>
        /// logo - see Gamestudio manual
        /// </summary>
        private static Var logo_ = null;
        public static Var logo
        {
            get
            {
                unsafe
                {
                    if (logo_ == null)
                    {
                        logo_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).logo;
                    }
                }
                return logo_;
            }
        }

        /// <summary>
        /// nexus - see Gamestudio manual
        /// </summary>
        private static Var nexus_ = null;
        public static Var nexus
        {
            get
            {
                unsafe
                {
                    if (nexus_ == null)
                    {
                        nexus_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).nexus;
                    }
                }
                return nexus_;
            }
        }

        /// <summary>
        /// event_type - see Gamestudio manual
        /// </summary>
        private static Var event_type_ = null;
        public static Var event_type
        {
            get
            {
                unsafe
                {
                    if (event_type_ == null)
                    {
                        event_type_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).event_type;
                    }
                }
                return event_type_;
            }
        }

        /// <summary>
        /// warn_level - see Gamestudio manual
        /// </summary>
        private static Var warn_level_ = null;
        public static Var warn_level
        {
            get
            {
                unsafe
                {
                    if (warn_level_ == null)
                    {
                        warn_level_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).warn_level;
                    }
                }
                return warn_level_;
            }
        }

        /// <summary>
        /// max_loops - see Gamestudio manual
        /// </summary>
        private static Var max_loops_ = null;
        public static Var max_loops
        {
            get
            {
                unsafe
                {
                    if (max_loops_ == null)
                    {
                        max_loops_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_loops;
                    }
                }
                return max_loops_;
            }
        }

        /// <summary>
        /// freeze_mode - see Gamestudio manual
        /// </summary>
        private static Var freeze_mode_ = null;
        public static Var freeze_mode
        {
            get
            {
                unsafe
                {
                    if (freeze_mode_ == null)
                    {
                        freeze_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).freeze_mode;
                    }
                }
                return freeze_mode_;
            }
        }

        /// <summary>
        /// debug_mode - see Gamestudio manual
        /// </summary>
        private static Var debug_mode_ = null;
        public static Var debug_mode
        {
            get
            {
                unsafe
                {
                    if (debug_mode_ == null)
                    {
                        debug_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).debug_mode;
                    }
                }
                return debug_mode_;
            }
        }

        /// <summary>
        /// debug_external - see Gamestudio manual
        /// </summary>
        private static Var debug_external_ = null;
        public static Var debug_external
        {
            get
            {
                unsafe
                {
                    if (debug_external_ == null)
                    {
                        debug_external_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).debug_external;
                    }
                }
                return debug_external_;
            }
        }

        /// <summary>
        /// mtl_mode - see Gamestudio manual
        /// </summary>
        private static Var mtl_mode_ = null;
        public static Var mtl_mode
        {
            get
            {
                unsafe
                {
                    if (mtl_mode_ == null)
                    {
                        mtl_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mtl_mode;
                    }
                }
                return mtl_mode_;
            }
        }

        /// <summary>
        /// last_error - see Gamestudio manual
        /// </summary>
        private static Var last_error_ = null;
        public static Var last_error
        {
            get
            {
                unsafe
                {
                    if (last_error_ == null)
                    {
                        last_error_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).last_error;
                    }
                }
                return last_error_;
            }
        }

        /// <summary>
        /// proc_mode - see Gamestudio manual
        /// </summary>
        private static Var proc_mode_ = null;
        public static Var proc_mode
        {
            get
            {
                unsafe
                {
                    if (proc_mode_ == null)
                    {
                        proc_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).proc_mode;
                    }
                }
                return proc_mode_;
            }
        }

        /// <summary>
        /// run_mode - see Gamestudio manual
        /// </summary>
        private static Var run_mode_ = null;
        public static Var run_mode
        {
            get
            {
                unsafe
                {
                    if (run_mode_ == null)
                    {
                        run_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).run_mode;
                    }
                }
                return run_mode_;
            }
        }

        /// <summary>
        /// patch - see Gamestudio manual
        /// </summary>
        private static Var patch_ = null;
        public static Var patch
        {
            get
            {
                unsafe
                {
                    if (patch_ == null)
                    {
                        patch_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).patch;
                    }
                }
                return patch_;
            }
        }

        /// <summary>
        /// result - see Gamestudio manual
        /// </summary>
        private static Var result_ = null;
        public static Var result
        {
            get
            {
                unsafe
                {
                    if (result_ == null)
                    {
                        result_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).result;
                    }
                }
                return result_;
            }
        }

        /// <summary>
        /// max_nexus - see Gamestudio manual
        /// </summary>
        private static Var max_nexus_ = null;
        public static Var max_nexus
        {
            get
            {
                unsafe
                {
                    if (max_nexus_ == null)
                    {
                        max_nexus_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_nexus;
                    }
                }
                return max_nexus_;
            }
        }

        /// <summary>
        /// diag_mode - see Gamestudio manual
        /// </summary>
        private static Var diag_mode_ = null;
        public static Var diag_mode
        {
            get
            {
                unsafe
                {
                    if (diag_mode_ == null)
                    {
                        diag_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).diag_mode;
                    }
                }
                return diag_mode_;
            }
        }

        /// <summary>
        /// record_mode - see Gamestudio manual
        /// </summary>
        private static Var record_mode_ = null;
        public static Var record_mode
        {
            get
            {
                unsafe
                {
                    if (record_mode_ == null)
                    {
                        record_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).record_mode;
                    }
                }
                return record_mode_;
            }
        }

        /// <summary>
        /// time_step - see Gamestudio manual
        /// </summary>
        private static Var time_step_ = null;
        public static Var time_step
        {
            get
            {
                unsafe
                {
                    if (time_step_ == null)
                    {
                        time_step_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_step;
                    }
                }
                return time_step_;
            }
        }

        /// <summary>
        /// time_factor - see Gamestudio manual
        /// </summary>
        private static Var time_factor_ = null;
        public static Var time_factor
        {
            get
            {
                unsafe
                {
                    if (time_factor_ == null)
                    {
                        time_factor_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_factor;
                    }
                }
                return time_factor_;
            }
        }

        /// <summary>
        /// time_smooth - see Gamestudio manual
        /// </summary>
        private static Var time_smooth_ = null;
        public static Var time_smooth
        {
            get
            {
                unsafe
                {
                    if (time_smooth_ == null)
                    {
                        time_smooth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_smooth;
                    }
                }
                return time_smooth_;
            }
        }

        /// <summary>
        /// time_frame - see Gamestudio manual
        /// </summary>
        private static Var time_frame_ = null;
        public static Var time_frame
        {
            get
            {
                unsafe
                {
                    if (time_frame_ == null)
                    {
                        time_frame_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_frame;
                    }
                }
                return time_frame_;
            }
        }

        /// <summary>
        /// total_ticks - see Gamestudio manual
        /// </summary>
        private static Var total_ticks_ = null;
        public static Var total_ticks
        {
            get
            {
                unsafe
                {
                    if (total_ticks_ == null)
                    {
                        total_ticks_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).total_ticks;
                    }
                }
                return total_ticks_;
            }
        }

        /// <summary>
        /// total_secs - see Gamestudio manual
        /// </summary>
        private static Var total_secs_ = null;
        public static Var total_secs
        {
            get
            {
                unsafe
                {
                    if (total_secs_ == null)
                    {
                        total_secs_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).total_secs;
                    }
                }
                return total_secs_;
            }
        }

        /// <summary>
        /// total_frames - see Gamestudio manual
        /// </summary>
        private static Var total_frames_ = null;
        public static Var total_frames
        {
            get
            {
                unsafe
                {
                    if (total_frames_ == null)
                    {
                        total_frames_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).total_frames;
                    }
                }
                return total_frames_;
            }
        }

        /// <summary>
        /// fps_max - see Gamestudio manual
        /// </summary>
        private static Var fps_max_ = null;
        public static Var fps_max
        {
            get
            {
                unsafe
                {
                    if (fps_max_ == null)
                    {
                        fps_max_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).fps_max;
                    }
                }
                return fps_max_;
            }
        }

        /// <summary>
        /// fps_min - see Gamestudio manual
        /// </summary>
        private static Var fps_min_ = null;
        public static Var fps_min
        {
            get
            {
                unsafe
                {
                    if (fps_min_ == null)
                    {
                        fps_min_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).fps_min;
                    }
                }
                return fps_min_;
            }
        }

        /// <summary>
        /// fps_lock - see Gamestudio manual
        /// </summary>
        private static Var fps_lock_ = null;
        public static Var fps_lock
        {
            get
            {
                unsafe
                {
                    if (fps_lock_ == null)
                    {
                        fps_lock_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).fps_lock;
                    }
                }
                return fps_lock_;
            }
        }

        /// <summary>
        /// time_actions - see Gamestudio manual
        /// </summary>
        private static Var time_actions_ = null;
        public static Var time_actions
        {
            get
            {
                unsafe
                {
                    if (time_actions_ == null)
                    {
                        time_actions_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_actions;
                    }
                }
                return time_actions_;
            }
        }

        /// <summary>
        /// time_render - see Gamestudio manual
        /// </summary>
        private static Var time_render_ = null;
        public static Var time_render
        {
            get
            {
                unsafe
                {
                    if (time_render_ == null)
                    {
                        time_render_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_render;
                    }
                }
                return time_render_;
            }
        }

        /// <summary>
        /// time_level - see Gamestudio manual
        /// </summary>
        private static Var time_level_ = null;
        public static Var time_level
        {
            get
            {
                unsafe
                {
                    if (time_level_ == null)
                    {
                        time_level_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_level;
                    }
                }
                return time_level_;
            }
        }

        /// <summary>
        /// time_entities - see Gamestudio manual
        /// </summary>
        private static Var time_entities_ = null;
        public static Var time_entities
        {
            get
            {
                unsafe
                {
                    if (time_entities_ == null)
                    {
                        time_entities_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_entities;
                    }
                }
                return time_entities_;
            }
        }

        /// <summary>
        /// time_effects - see Gamestudio manual
        /// </summary>
        private static Var time_effects_ = null;
        public static Var time_effects
        {
            get
            {
                unsafe
                {
                    if (time_effects_ == null)
                    {
                        time_effects_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_effects;
                    }
                }
                return time_effects_;
            }
        }

        /// <summary>
        /// time_pfuncs - see Gamestudio manual
        /// </summary>
        private static Var time_pfuncs_ = null;
        public static Var time_pfuncs
        {
            get
            {
                unsafe
                {
                    if (time_pfuncs_ == null)
                    {
                        time_pfuncs_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_pfuncs;
                    }
                }
                return time_pfuncs_;
            }
        }

        /// <summary>
        /// time_portals - see Gamestudio manual
        /// </summary>
        private static Var time_portals_ = null;
        public static Var time_portals
        {
            get
            {
                unsafe
                {
                    if (time_portals_ == null)
                    {
                        time_portals_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_portals;
                    }
                }
                return time_portals_;
            }
        }

        /// <summary>
        /// time_sky - see Gamestudio manual
        /// </summary>
        private static Var time_sky_ = null;
        public static Var time_sky
        {
            get
            {
                unsafe
                {
                    if (time_sky_ == null)
                    {
                        time_sky_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_sky;
                    }
                }
                return time_sky_;
            }
        }

        /// <summary>
        /// time_client - see Gamestudio manual
        /// </summary>
        private static Var time_client_ = null;
        public static Var time_client
        {
            get
            {
                unsafe
                {
                    if (time_client_ == null)
                    {
                        time_client_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_client;
                    }
                }
                return time_client_;
            }
        }

        /// <summary>
        /// time_server - see Gamestudio manual
        /// </summary>
        private static Var time_server_ = null;
        public static Var time_server
        {
            get
            {
                unsafe
                {
                    if (time_server_ == null)
                    {
                        time_server_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_server;
                    }
                }
                return time_server_;
            }
        }

        /// <summary>
        /// time_panels - see Gamestudio manual
        /// </summary>
        private static Var time_panels_ = null;
        public static Var time_panels
        {
            get
            {
                unsafe
                {
                    if (time_panels_ == null)
                    {
                        time_panels_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_panels;
                    }
                }
                return time_panels_;
            }
        }

        /// <summary>
        /// time_update - see Gamestudio manual
        /// </summary>
        private static Var time_update_ = null;
        public static Var time_update
        {
            get
            {
                unsafe
                {
                    if (time_update_ == null)
                    {
                        time_update_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_update;
                    }
                }
                return time_update_;
            }
        }

        /// <summary>
        /// time_physics - see Gamestudio manual
        /// </summary>
        private static Var time_physics_ = null;
        public static Var time_physics
        {
            get
            {
                unsafe
                {
                    if (time_physics_ == null)
                    {
                        time_physics_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_physics;
                    }
                }
                return time_physics_;
            }
        }

        /// <summary>
        /// time_total - see Gamestudio manual
        /// </summary>
        private static Var time_total_ = null;
        public static Var time_total
        {
            get
            {
                unsafe
                {
                    if (time_total_ == null)
                    {
                        time_total_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_total;
                    }
                }
                return time_total_;
            }
        }

        /// <summary>
        /// time_idle - see Gamestudio manual
        /// </summary>
        private static Var time_idle_ = null;
        public static Var time_idle
        {
            get
            {
                unsafe
                {
                    if (time_idle_ == null)
                    {
                        time_idle_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_idle;
                    }
                }
                return time_idle_;
            }
        }

        /// <summary>
        /// time_draw - see Gamestudio manual
        /// </summary>
        private static Var time_draw_ = null;
        public static Var time_draw
        {
            get
            {
                unsafe
                {
                    if (time_draw_ == null)
                    {
                        time_draw_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_draw;
                    }
                }
                return time_draw_;
            }
        }

        /// <summary>
        /// time_scope - see Gamestudio manual
        /// </summary>
        private static Var time_scope_ = null;
        public static Var time_scope
        {
            get
            {
                unsafe
                {
                    if (time_scope_ == null)
                    {
                        time_scope_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).time_scope;
                    }
                }
                return time_scope_;
            }
        }

        /// <summary>
        /// sys_seconds - see Gamestudio manual
        /// </summary>
        private static Var sys_seconds_ = null;
        public static Var sys_seconds
        {
            get
            {
                unsafe
                {
                    if (sys_seconds_ == null)
                    {
                        sys_seconds_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_seconds;
                    }
                }
                return sys_seconds_;
            }
        }

        /// <summary>
        /// sys_minutes - see Gamestudio manual
        /// </summary>
        private static Var sys_minutes_ = null;
        public static Var sys_minutes
        {
            get
            {
                unsafe
                {
                    if (sys_minutes_ == null)
                    {
                        sys_minutes_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_minutes;
                    }
                }
                return sys_minutes_;
            }
        }

        /// <summary>
        /// sys_hours - see Gamestudio manual
        /// </summary>
        private static Var sys_hours_ = null;
        public static Var sys_hours
        {
            get
            {
                unsafe
                {
                    if (sys_hours_ == null)
                    {
                        sys_hours_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_hours;
                    }
                }
                return sys_hours_;
            }
        }

        /// <summary>
        /// sys_day - see Gamestudio manual
        /// </summary>
        private static Var sys_day_ = null;
        public static Var sys_day
        {
            get
            {
                unsafe
                {
                    if (sys_day_ == null)
                    {
                        sys_day_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_day;
                    }
                }
                return sys_day_;
            }
        }

        /// <summary>
        /// sys_month - see Gamestudio manual
        /// </summary>
        private static Var sys_month_ = null;
        public static Var sys_month
        {
            get
            {
                unsafe
                {
                    if (sys_month_ == null)
                    {
                        sys_month_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_month;
                    }
                }
                return sys_month_;
            }
        }

        /// <summary>
        /// sys_year - see Gamestudio manual
        /// </summary>
        private static Var sys_year_ = null;
        public static Var sys_year
        {
            get
            {
                unsafe
                {
                    if (sys_year_ == null)
                    {
                        sys_year_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_year;
                    }
                }
                return sys_year_;
            }
        }

        /// <summary>
        /// sys_dow - see Gamestudio manual
        /// </summary>
        private static Var sys_dow_ = null;
        public static Var sys_dow
        {
            get
            {
                unsafe
                {
                    if (sys_dow_ == null)
                    {
                        sys_dow_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_dow;
                    }
                }
                return sys_dow_;
            }
        }

        /// <summary>
        /// sys_doy - see Gamestudio manual
        /// </summary>
        private static Var sys_doy_ = null;
        public static Var sys_doy
        {
            get
            {
                unsafe
                {
                    if (sys_doy_ == null)
                    {
                        sys_doy_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_doy;
                    }
                }
                return sys_doy_;
            }
        }

        /// <summary>
        /// sys_memory - see Gamestudio manual
        /// </summary>
        private static Var sys_memory_ = null;
        public static Var sys_memory
        {
            get
            {
                unsafe
                {
                    if (sys_memory_ == null)
                    {
                        sys_memory_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_memory;
                    }
                }
                return sys_memory_;
            }
        }

        /// <summary>
        /// sys_winversion - see Gamestudio manual
        /// </summary>
        private static Var sys_winversion_ = null;
        public static Var sys_winversion
        {
            get
            {
                unsafe
                {
                    if (sys_winversion_ == null)
                    {
                        sys_winversion_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sys_winversion;
                    }
                }
                return sys_winversion_;
            }
        }

        /// <summary>
        /// enable_joystick - see Gamestudio manual
        /// </summary>
        private static Var enable_joystick_ = null;
        public static Var enable_joystick
        {
            get
            {
                unsafe
                {
                    if (enable_joystick_ == null)
                    {
                        enable_joystick_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).enable_joystick;
                    }
                }
                return enable_joystick_;
            }
        }

        /// <summary>
        /// num_joysticks - see Gamestudio manual
        /// </summary>
        private static Var num_joysticks_ = null;
        public static Var num_joysticks
        {
            get
            {
                unsafe
                {
                    if (num_joysticks_ == null)
                    {
                        num_joysticks_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_joysticks;
                    }
                }
                return num_joysticks_;
            }
        }

        /// <summary>
        /// joy_sense - see Gamestudio manual
        /// </summary>
        private static Var joy_sense_ = null;
        public static Var joy_sense
        {
            get
            {
                unsafe
                {
                    if (joy_sense_ == null)
                    {
                        joy_sense_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_sense;
                    }
                }
                return joy_sense_;
            }
        }


        /// <summary>
        /// joy_force - see Gamestudio manual
        /// </summary>
        private static Vector joy_force_ = null;
        public static Vector joy_force
        {
            get
            {
                unsafe
                {
                    if (joy_force_ == null)
                    {
                        joy_force_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_force;
                    }
                }
                return joy_force_;
            }
        }


        /// <summary>
        /// joy_raw - see Gamestudio manual
        /// </summary>
        private static Vector joy_raw_ = null;
        public static Vector joy_raw
        {
            get
            {
                unsafe
                {
                    if (joy_raw_ == null)
                    {
                        joy_raw_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_raw;
                    }
                }
                return joy_raw_;
            }
        }


        /// <summary>
        /// joy_rot - see Gamestudio manual
        /// </summary>
        private static Vector joy_rot_ = null;
        public static Vector joy_rot
        {
            get
            {
                unsafe
                {
                    if (joy_rot_ == null)
                    {
                        joy_rot_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_rot;
                    }
                }
                return joy_rot_;
            }
        }

        /// <summary>
        /// joy_hat - see Gamestudio manual
        /// </summary>
        private static Var joy_hat_ = null;
        public static Var joy_hat
        {
            get
            {
                unsafe
                {
                    if (joy_hat_ == null)
                    {
                        joy_hat_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_hat;
                    }
                }
                return joy_hat_;
            }
        }


        /// <summary>
        /// joy2_raw - see Gamestudio manual
        /// </summary>
        private static Vector joy2_raw_ = null;
        public static Vector joy2_raw
        {
            get
            {
                unsafe
                {
                    if (joy2_raw_ == null)
                    {
                        joy2_raw_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_raw;
                    }
                }
                return joy2_raw_;
            }
        }


        /// <summary>
        /// joy2_rot - see Gamestudio manual
        /// </summary>
        private static Vector joy2_rot_ = null;
        public static Vector joy2_rot
        {
            get
            {
                unsafe
                {
                    if (joy2_rot_ == null)
                    {
                        joy2_rot_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_rot;
                    }
                }
                return joy2_rot_;
            }
        }

        /// <summary>
        /// joy2_hat - see Gamestudio manual
        /// </summary>
        private static Var joy2_hat_ = null;
        public static Var joy2_hat
        {
            get
            {
                unsafe
                {
                    if (joy2_hat_ == null)
                    {
                        joy2_hat_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_hat;
                    }
                }
                return joy2_hat_;
            }
        }

        /// <summary>
        /// joy_buttons - see Gamestudio manual
        /// </summary>
        private static Var joy_buttons_ = null;
        public static Var joy_buttons
        {
            get
            {
                unsafe
                {
                    if (joy_buttons_ == null)
                    {
                        joy_buttons_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_buttons;
                    }
                }
                return joy_buttons_;
            }
        }

        /// <summary>
        /// joy2_buttons - see Gamestudio manual
        /// </summary>
        private static Var joy2_buttons_ = null;
        public static Var joy2_buttons
        {
            get
            {
                unsafe
                {
                    if (joy2_buttons_ == null)
                    {
                        joy2_buttons_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_buttons;
                    }
                }
                return joy2_buttons_;
            }
        }

        /// <summary>
        /// enable_mouse - see Gamestudio manual
        /// </summary>
        private static Var enable_mouse_ = null;
        public static Var enable_mouse
        {
            get
            {
                unsafe
                {
                    if (enable_mouse_ == null)
                    {
                        enable_mouse_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).enable_mouse;
                    }
                }
                return enable_mouse_;
            }
        }

        /// <summary>
        /// mouse_mode - see Gamestudio manual
        /// </summary>
        private static Var mouse_mode_ = null;
        public static Var mouse_mode
        {
            get
            {
                unsafe
                {
                    if (mouse_mode_ == null)
                    {
                        mouse_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_mode;
                    }
                }
                return mouse_mode_;
            }
        }

        /// <summary>
        /// mouse_sense - see Gamestudio manual
        /// </summary>
        private static Var mouse_sense_ = null;
        public static Var mouse_sense
        {
            get
            {
                unsafe
                {
                    if (mouse_sense_ == null)
                    {
                        mouse_sense_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_sense;
                    }
                }
                return mouse_sense_;
            }
        }


        /// <summary>
        /// mouse_force - see Gamestudio manual
        /// </summary>
        private static Vector mouse_force_ = null;
        public static Vector mouse_force
        {
            get
            {
                unsafe
                {
                    if (mouse_force_ == null)
                    {
                        mouse_force_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_force;
                    }
                }
                return mouse_force_;
            }
        }


        /// <summary>
        /// mouse_pos - see Gamestudio manual
        /// </summary>
        private static Vector mouse_pos_ = null;
        public static Vector mouse_pos
        {
            get
            {
                unsafe
                {
                    if (mouse_pos_ == null)
                    {
                        mouse_pos_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_pos;
                    }
                }
                return mouse_pos_;
            }
        }


        /// <summary>
        /// mouse_spot - see Gamestudio manual
        /// </summary>
        private static Vector mouse_spot_ = null;
        public static Vector mouse_spot
        {
            get
            {
                unsafe
                {
                    if (mouse_spot_ == null)
                    {
                        mouse_spot_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_spot;
                    }
                }
                return mouse_spot_;
            }
        }

        /// <summary>
        /// mouse_pointer - see Gamestudio manual
        /// </summary>
        private static Var mouse_pointer_ = null;
        public static Var mouse_pointer
        {
            get
            {
                unsafe
                {
                    if (mouse_pointer_ == null)
                    {
                        mouse_pointer_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_pointer;
                    }
                }
                return mouse_pointer_;
            }
        }

        /// <summary>
        /// mouse_range - see Gamestudio manual
        /// </summary>
        private static Var mouse_range_ = null;
        public static Var mouse_range
        {
            get
            {
                unsafe
                {
                    if (mouse_range_ == null)
                    {
                        mouse_range_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_range;
                    }
                }
                return mouse_range_;
            }
        }

        /// <summary>
        /// mouse_time - see Gamestudio manual
        /// </summary>
        private static Var mouse_time_ = null;
        public static Var mouse_time
        {
            get
            {
                unsafe
                {
                    if (mouse_time_ == null)
                    {
                        mouse_time_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_time;
                    }
                }
                return mouse_time_;
            }
        }

        /// <summary>
        /// mouse_moving - see Gamestudio manual
        /// </summary>
        private static Var mouse_moving_ = null;
        public static Var mouse_moving
        {
            get
            {
                unsafe
                {
                    if (mouse_moving_ == null)
                    {
                        mouse_moving_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_moving;
                    }
                }
                return mouse_moving_;
            }
        }

        /// <summary>
        /// mouse_calm - see Gamestudio manual
        /// </summary>
        private static Var mouse_calm_ = null;
        public static Var mouse_calm
        {
            get
            {
                unsafe
                {
                    if (mouse_calm_ == null)
                    {
                        mouse_calm_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_calm;
                    }
                }
                return mouse_calm_;
            }
        }

        /// <summary>
        /// mouse_sync - see Gamestudio manual
        /// </summary>
        private static Var mouse_sync_ = null;
        public static Var mouse_sync
        {
            get
            {
                unsafe
                {
                    if (mouse_sync_ == null)
                    {
                        mouse_sync_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_sync;
                    }
                }
                return mouse_sync_;
            }
        }

        /// <summary>
        /// mouse_valid - see Gamestudio manual
        /// </summary>
        private static Var mouse_valid_ = null;
        public static Var mouse_valid
        {
            get
            {
                unsafe
                {
                    if (mouse_valid_ == null)
                    {
                        mouse_valid_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_valid;
                    }
                }
                return mouse_valid_;
            }
        }

        /// <summary>
        /// touch_state - see Gamestudio manual
        /// </summary>
        private static Var touch_state_ = null;
        public static Var touch_state
        {
            get
            {
                unsafe
                {
                    if (touch_state_ == null)
                    {
                        touch_state_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).touch_state;
                    }
                }
                return touch_state_;
            }
        }


        /// <summary>
        /// mickey - see Gamestudio manual
        /// </summary>
        private static Vector mickey_ = null;
        public static Vector mickey
        {
            get
            {
                unsafe
                {
                    if (mickey_ == null)
                    {
                        mickey_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mickey;
                    }
                }
                return mickey_;
            }
        }


        /// <summary>
        /// mouse_cursor - see Gamestudio manual
        /// </summary>
        private static Vector mouse_cursor_ = null;
        public static Vector mouse_cursor
        {
            get
            {
                unsafe
                {
                    if (mouse_cursor_ == null)
                    {
                        mouse_cursor_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_cursor;
                    }
                }
                return mouse_cursor_;
            }
        }


        /// <summary>
        /// mouse_pos3d - see Gamestudio manual
        /// </summary>
        private static Vector mouse_pos3d_ = null;
        public static Vector mouse_pos3d
        {
            get
            {
                unsafe
                {
                    if (mouse_pos3d_ == null)
                    {
                        mouse_pos3d_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_pos3d;
                    }
                }
                return mouse_pos3d_;
            }
        }


        /// <summary>
        /// mouse_dir3d - see Gamestudio manual
        /// </summary>
        private static Vector mouse_dir3d_ = null;
        public static Vector mouse_dir3d
        {
            get
            {
                unsafe
                {
                    if (mouse_dir3d_ == null)
                    {
                        mouse_dir3d_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_dir3d;
                    }
                }
                return mouse_dir3d_;
            }
        }

        /// <summary>
        /// enable_key - see Gamestudio manual
        /// </summary>
        private static Var enable_key_ = null;
        public static Var enable_key
        {
            get
            {
                unsafe
                {
                    if (enable_key_ == null)
                    {
                        enable_key_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).enable_key;
                    }
                }
                return enable_key_;
            }
        }

        /// <summary>
        /// key_sense - see Gamestudio manual
        /// </summary>
        private static Var key_sense_ = null;
        public static Var key_sense
        {
            get
            {
                unsafe
                {
                    if (key_sense_ == null)
                    {
                        key_sense_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_sense;
                    }
                }
                return key_sense_;
            }
        }


        /// <summary>
        /// key_force - see Gamestudio manual
        /// </summary>
        private static Vector key_force_ = null;
        public static Vector key_force
        {
            get
            {
                unsafe
                {
                    if (key_force_ == null)
                    {
                        key_force_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_force;
                    }
                }
                return key_force_;
            }
        }

        /// <summary>
        /// shift_sense - see Gamestudio manual
        /// </summary>
        private static Var shift_sense_ = null;
        public static Var shift_sense
        {
            get
            {
                unsafe
                {
                    if (shift_sense_ == null)
                    {
                        shift_sense_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shift_sense;
                    }
                }
                return shift_sense_;
            }
        }

        /// <summary>
        /// key_shift - see Gamestudio manual
        /// </summary>
        private static Var key_shift_ = null;
        public static Var key_shift
        {
            get
            {
                unsafe
                {
                    if (key_shift_ == null)
                    {
                        key_shift_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_shift;
                    }
                }
                return key_shift_;
            }
        }

        /// <summary>
        /// key_any - see Gamestudio manual
        /// </summary>
        private static Var key_any_ = null;
        public static Var key_any
        {
            get
            {
                unsafe
                {
                    if (key_any_ == null)
                    {
                        key_any_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_any;
                    }
                }
                return key_any_;
            }
        }

        /// <summary>
        /// key_lastpressed - see Gamestudio manual
        /// </summary>
        private static Var key_lastpressed_ = null;
        public static Var key_lastpressed
        {
            get
            {
                unsafe
                {
                    if (key_lastpressed_ == null)
                    {
                        key_lastpressed_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_lastpressed;
                    }
                }
                return key_lastpressed_;
            }
        }

        /// <summary>
        /// inkey_active - see Gamestudio manual
        /// </summary>
        private static Var inkey_active_ = null;
        public static Var inkey_active
        {
            get
            {
                unsafe
                {
                    if (inkey_active_ == null)
                    {
                        inkey_active_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).inkey_active;
                    }
                }
                return inkey_active_;
            }
        }

        /// <summary>
        /// text_outline - see Gamestudio manual
        /// </summary>
        private static Var text_outline_ = null;
        public static Var text_outline
        {
            get
            {
                unsafe
                {
                    if (text_outline_ == null)
                    {
                        text_outline_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).text_outline;
                    }
                }
                return text_outline_;
            }
        }

        /// <summary>
        /// decal_clip - see Gamestudio manual
        /// </summary>
        private static Var decal_clip_ = null;
        public static Var decal_clip
        {
            get
            {
                unsafe
                {
                    if (decal_clip_ == null)
                    {
                        decal_clip_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).decal_clip;
                    }
                }
                return decal_clip_;
            }
        }

        /// <summary>
        /// video_aspect - see Gamestudio manual
        /// </summary>
        private static Var video_aspect_ = null;
        public static Var video_aspect
        {
            get
            {
                unsafe
                {
                    if (video_aspect_ == null)
                    {
                        video_aspect_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_aspect;
                    }
                }
                return video_aspect_;
            }
        }

        /// <summary>
        /// video_mode - see Gamestudio manual
        /// </summary>
        private static Var video_mode_ = null;
        public static Var video_mode
        {
            get
            {
                unsafe
                {
                    if (video_mode_ == null)
                    {
                        video_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_mode;
                    }
                }
                return video_mode_;
            }
        }

        /// <summary>
        /// video_depth - see Gamestudio manual
        /// </summary>
        private static Var video_depth_ = null;
        public static Var video_depth
        {
            get
            {
                unsafe
                {
                    if (video_depth_ == null)
                    {
                        video_depth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_depth;
                    }
                }
                return video_depth_;
            }
        }

        /// <summary>
        /// video_screen - see Gamestudio manual
        /// </summary>
        private static Var video_screen_ = null;
        public static Var video_screen
        {
            get
            {
                unsafe
                {
                    if (video_screen_ == null)
                    {
                        video_screen_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_screen;
                    }
                }
                return video_screen_;
            }
        }


        /// <summary>
        /// screen_size - see Gamestudio manual
        /// </summary>
        private static Vector screen_size_ = null;
        public static Vector screen_size
        {
            get
            {
                unsafe
                {
                    if (screen_size_ == null)
                    {
                        screen_size_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).screen_size;
                    }
                }
                return screen_size_;
            }
        }


        /// <summary>
        /// screen_color - see Gamestudio manual
        /// </summary>
        private static Color screen_color_ = null;
        public static Color screen_color
        {
            get
            {
                unsafe
                {
                    if (screen_color_ == null)
                    {
                        screen_color_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).screen_color;
                    }
                }
                return screen_color_;
            }
        }

        /// <summary>
        /// window_focus - see Gamestudio manual
        /// </summary>
        private static Var window_focus_ = null;
        public static Var window_focus
        {
            get
            {
                unsafe
                {
                    if (window_focus_ == null)
                    {
                        window_focus_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).window_focus;
                    }
                }
                return window_focus_;
            }
        }

        /// <summary>
        /// video_gamma - see Gamestudio manual
        /// </summary>
        private static Var video_gamma_ = null;
        public static Var video_gamma
        {
            get
            {
                unsafe
                {
                    if (video_gamma_ == null)
                    {
                        video_gamma_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_gamma;
                    }
                }
                return video_gamma_;
            }
        }


        /// <summary>
        /// window_pos - see Gamestudio manual
        /// </summary>
        private static Vector window_pos_ = null;
        public static Vector window_pos
        {
            get
            {
                unsafe
                {
                    if (window_pos_ == null)
                    {
                        window_pos_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).window_pos;
                    }
                }
                return window_pos_;
            }
        }

        /// <summary>
        /// d3d_antialias - see Gamestudio manual
        /// </summary>
        private static Var d3d_antialias_ = null;
        public static Var d3d_antialias
        {
            get
            {
                unsafe
                {
                    if (d3d_antialias_ == null)
                    {
                        d3d_antialias_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_antialias;
                    }
                }
                return d3d_antialias_;
            }
        }

        /// <summary>
        /// mip_levels - see Gamestudio manual
        /// </summary>
        private static Var mip_levels_ = null;
        public static Var mip_levels
        {
            get
            {
                unsafe
                {
                    if (mip_levels_ == null)
                    {
                        mip_levels_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mip_levels;
                    }
                }
                return mip_levels_;
            }
        }


        /// <summary>
        /// ambient_color - see Gamestudio manual
        /// </summary>
        private static Color ambient_color_ = null;
        public static Color ambient_color
        {
            get
            {
                unsafe
                {
                    if (ambient_color_ == null)
                    {
                        ambient_color_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ambient_color;
                    }
                }
                return ambient_color_;
            }
        }

        /// <summary>
        /// d3d_caps - see Gamestudio manual
        /// </summary>
        private static Var d3d_caps_ = null;
        public static Var d3d_caps
        {
            get
            {
                unsafe
                {
                    if (d3d_caps_ == null)
                    {
                        d3d_caps_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_caps;
                    }
                }
                return d3d_caps_;
            }
        }

        /// <summary>
        /// d3d_optimize - see Gamestudio manual
        /// </summary>
        private static Var d3d_optimize_ = null;
        public static Var d3d_optimize
        {
            get
            {
                unsafe
                {
                    if (d3d_optimize_ == null)
                    {
                        d3d_optimize_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_optimize;
                    }
                }
                return d3d_optimize_;
            }
        }

        /// <summary>
        /// d3d_mode - see Gamestudio manual
        /// </summary>
        private static Var d3d_mode_ = null;
        public static Var d3d_mode
        {
            get
            {
                unsafe
                {
                    if (d3d_mode_ == null)
                    {
                        d3d_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_mode;
                    }
                }
                return d3d_mode_;
            }
        }

        /// <summary>
        /// d3d_nobsp - see Gamestudio manual
        /// </summary>
        private static Var d3d_nobsp_ = null;
        public static Var d3d_nobsp
        {
            get
            {
                unsafe
                {
                    if (d3d_nobsp_ == null)
                    {
                        d3d_nobsp_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_nobsp;
                    }
                }
                return d3d_nobsp_;
            }
        }

        /// <summary>
        /// d3d_noents - see Gamestudio manual
        /// </summary>
        private static Var d3d_noents_ = null;
        public static Var d3d_noents
        {
            get
            {
                unsafe
                {
                    if (d3d_noents_ == null)
                    {
                        d3d_noents_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_noents;
                    }
                }
                return d3d_noents_;
            }
        }

        /// <summary>
        /// d3d_novis - see Gamestudio manual
        /// </summary>
        private static Var d3d_novis_ = null;
        public static Var d3d_novis
        {
            get
            {
                unsafe
                {
                    if (d3d_novis_ == null)
                    {
                        d3d_novis_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_novis;
                    }
                }
                return d3d_novis_;
            }
        }

        /// <summary>
        /// d3d_notex - see Gamestudio manual
        /// </summary>
        private static Var d3d_notex_ = null;
        public static Var d3d_notex
        {
            get
            {
                unsafe
                {
                    if (d3d_notex_ == null)
                    {
                        d3d_notex_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_notex;
                    }
                }
                return d3d_notex_;
            }
        }

        /// <summary>
        /// d3d_flags - see Gamestudio manual
        /// </summary>
        private static Var d3d_flags_ = null;
        public static Var d3d_flags
        {
            get
            {
                unsafe
                {
                    if (d3d_flags_ == null)
                    {
                        d3d_flags_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_flags;
                    }
                }
                return d3d_flags_;
            }
        }

        /// <summary>
        /// d3d_lightres - see Gamestudio manual
        /// </summary>
        private static Var d3d_lightres_ = null;
        public static Var d3d_lightres
        {
            get
            {
                unsafe
                {
                    if (d3d_lightres_ == null)
                    {
                        d3d_lightres_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_lightres;
                    }
                }
                return d3d_lightres_;
            }
        }

        /// <summary>
        /// d3d_monochrome - see Gamestudio manual
        /// </summary>
        private static Var d3d_monochrome_ = null;
        public static Var d3d_monochrome
        {
            get
            {
                unsafe
                {
                    if (d3d_monochrome_ == null)
                    {
                        d3d_monochrome_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_monochrome;
                    }
                }
                return d3d_monochrome_;
            }
        }

        /// <summary>
        /// d3d_lines - see Gamestudio manual
        /// </summary>
        private static Var d3d_lines_ = null;
        public static Var d3d_lines
        {
            get
            {
                unsafe
                {
                    if (d3d_lines_ == null)
                    {
                        d3d_lines_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_lines;
                    }
                }
                return d3d_lines_;
            }
        }

        /// <summary>
        /// d3d_anisotropy - see Gamestudio manual
        /// </summary>
        private static Var d3d_anisotropy_ = null;
        public static Var d3d_anisotropy
        {
            get
            {
                unsafe
                {
                    if (d3d_anisotropy_ == null)
                    {
                        d3d_anisotropy_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_anisotropy;
                    }
                }
                return d3d_anisotropy_;
            }
        }

        /// <summary>
        /// d3d_instancing - see Gamestudio manual
        /// </summary>
        private static Var d3d_instancing_ = null;
        public static Var d3d_instancing
        {
            get
            {
                unsafe
                {
                    if (d3d_instancing_ == null)
                    {
                        d3d_instancing_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_instancing;
                    }
                }
                return d3d_instancing_;
            }
        }

        /// <summary>
        /// d3d_lockable - see Gamestudio manual
        /// </summary>
        private static Var d3d_lockable_ = null;
        public static Var d3d_lockable
        {
            get
            {
                unsafe
                {
                    if (d3d_lockable_ == null)
                    {
                        d3d_lockable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_lockable;
                    }
                }
                return d3d_lockable_;
            }
        }

        /// <summary>
        /// effect_lod - see Gamestudio manual
        /// </summary>
        private static Var effect_lod_ = null;
        public static Var effect_lod
        {
            get
            {
                unsafe
                {
                    if (effect_lod_ == null)
                    {
                        effect_lod_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).effect_lod;
                    }
                }
                return effect_lod_;
            }
        }

        /// <summary>
        /// d3d_autotransparency - see Gamestudio manual
        /// </summary>
        private static Var d3d_autotransparency_ = null;
        public static Var d3d_autotransparency
        {
            get
            {
                unsafe
                {
                    if (d3d_autotransparency_ == null)
                    {
                        d3d_autotransparency_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_autotransparency;
                    }
                }
                return d3d_autotransparency_;
            }
        }

        /// <summary>
        /// d3d_automaterial - see Gamestudio manual
        /// </summary>
        private static Var d3d_automaterial_ = null;
        public static Var d3d_automaterial
        {
            get
            {
                unsafe
                {
                    if (d3d_automaterial_ == null)
                    {
                        d3d_automaterial_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_automaterial;
                    }
                }
                return d3d_automaterial_;
            }
        }

        /// <summary>
        /// d3d_shaderversion - see Gamestudio manual
        /// </summary>
        private static Var d3d_shaderversion_ = null;
        public static Var d3d_shaderversion
        {
            get
            {
                unsafe
                {
                    if (d3d_shaderversion_ == null)
                    {
                        d3d_shaderversion_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_shaderversion;
                    }
                }
                return d3d_shaderversion_;
            }
        }

        /// <summary>
        /// shadow_offset - see Gamestudio manual
        /// </summary>
        private static Var shadow_offset_ = null;
        public static Var shadow_offset
        {
            get
            {
                unsafe
                {
                    if (shadow_offset_ == null)
                    {
                        shadow_offset_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_offset;
                    }
                }
                return shadow_offset_;
            }
        }

        /// <summary>
        /// shadow_threshold - see Gamestudio manual
        /// </summary>
        private static Var shadow_threshold_ = null;
        public static Var shadow_threshold
        {
            get
            {
                unsafe
                {
                    if (shadow_threshold_ == null)
                    {
                        shadow_threshold_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_threshold;
                    }
                }
                return shadow_threshold_;
            }
        }

        /// <summary>
        /// shadow_range - see Gamestudio manual
        /// </summary>
        private static Var shadow_range_ = null;
        public static Var shadow_range
        {
            get
            {
                unsafe
                {
                    if (shadow_range_ == null)
                    {
                        shadow_range_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_range;
                    }
                }
                return shadow_range_;
            }
        }

        /// <summary>
        /// shadow_stencil - see Gamestudio manual
        /// </summary>
        private static Var shadow_stencil_ = null;
        public static Var shadow_stencil
        {
            get
            {
                unsafe
                {
                    if (shadow_stencil_ == null)
                    {
                        shadow_stencil_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_stencil;
                    }
                }
                return shadow_stencil_;
            }
        }

        /// <summary>
        /// d3d_shadowdepth - see Gamestudio manual
        /// </summary>
        private static Var d3d_shadowdepth_ = null;
        public static Var d3d_shadowdepth
        {
            get
            {
                unsafe
                {
                    if (d3d_shadowdepth_ == null)
                    {
                        d3d_shadowdepth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_shadowdepth;
                    }
                }
                return d3d_shadowdepth_;
            }
        }

        /// <summary>
        /// d3d_alphadepth - see Gamestudio manual
        /// </summary>
        private static Var d3d_alphadepth_ = null;
        public static Var d3d_alphadepth
        {
            get
            {
                unsafe
                {
                    if (d3d_alphadepth_ == null)
                    {
                        d3d_alphadepth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_alphadepth;
                    }
                }
                return d3d_alphadepth_;
            }
        }

        /// <summary>
        /// shadow_lod - see Gamestudio manual
        /// </summary>
        private static Var shadow_lod_ = null;
        public static Var shadow_lod
        {
            get
            {
                unsafe
                {
                    if (shadow_lod_ == null)
                    {
                        shadow_lod_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_lod;
                    }
                }
                return shadow_lod_;
            }
        }

        /// <summary>
        /// d3d_texsmaps - see Gamestudio manual
        /// </summary>
        private static Var d3d_texsmaps_ = null;
        public static Var d3d_texsmaps
        {
            get
            {
                unsafe
                {
                    if (d3d_texsmaps_ == null)
                    {
                        d3d_texsmaps_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texsmaps;
                    }
                }
                return d3d_texsmaps_;
            }
        }

        /// <summary>
        /// d3d_texbmaps - see Gamestudio manual
        /// </summary>
        private static Var d3d_texbmaps_ = null;
        public static Var d3d_texbmaps
        {
            get
            {
                unsafe
                {
                    if (d3d_texbmaps_ == null)
                    {
                        d3d_texbmaps_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texbmaps;
                    }
                }
                return d3d_texbmaps_;
            }
        }

        /// <summary>
        /// d3d_texskins - see Gamestudio manual
        /// </summary>
        private static Var d3d_texskins_ = null;
        public static Var d3d_texskins
        {
            get
            {
                unsafe
                {
                    if (d3d_texskins_ == null)
                    {
                        d3d_texskins_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texskins;
                    }
                }
                return d3d_texskins_;
            }
        }

        /// <summary>
        /// d3d_texsurfs - see Gamestudio manual
        /// </summary>
        private static Var d3d_texsurfs_ = null;
        public static Var d3d_texsurfs
        {
            get
            {
                unsafe
                {
                    if (d3d_texsurfs_ == null)
                    {
                        d3d_texsurfs_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texsurfs;
                    }
                }
                return d3d_texsurfs_;
            }
        }

        /// <summary>
        /// d3d_textotal - see Gamestudio manual
        /// </summary>
        private static Var d3d_textotal_ = null;
        public static Var d3d_textotal
        {
            get
            {
                unsafe
                {
                    if (d3d_textotal_ == null)
                    {
                        d3d_textotal_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_textotal;
                    }
                }
                return d3d_textotal_;
            }
        }

        /// <summary>
        /// d3d_texmemory - see Gamestudio manual
        /// </summary>
        private static Var d3d_texmemory_ = null;
        public static Var d3d_texmemory
        {
            get
            {
                unsafe
                {
                    if (d3d_texmemory_ == null)
                    {
                        d3d_texmemory_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texmemory;
                    }
                }
                return d3d_texmemory_;
            }
        }

        /// <summary>
        /// d3d_alpharef - see Gamestudio manual
        /// </summary>
        private static Var d3d_alpharef_ = null;
        public static Var d3d_alpharef
        {
            get
            {
                unsafe
                {
                    if (d3d_alpharef_ == null)
                    {
                        d3d_alpharef_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_alpharef;
                    }
                }
                return d3d_alpharef_;
            }
        }

        /// <summary>
        /// d3d_texfree - see Gamestudio manual
        /// </summary>
        private static Var d3d_texfree_ = null;
        public static Var d3d_texfree
        {
            get
            {
                unsafe
                {
                    if (d3d_texfree_ == null)
                    {
                        d3d_texfree_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texfree;
                    }
                }
                return d3d_texfree_;
            }
        }

        /// <summary>
        /// d3d_texdepth - see Gamestudio manual
        /// </summary>
        private static Var d3d_texdepth_ = null;
        public static Var d3d_texdepth
        {
            get
            {
                unsafe
                {
                    if (d3d_texdepth_ == null)
                    {
                        d3d_texdepth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texdepth;
                    }
                }
                return d3d_texdepth_;
            }
        }

        /// <summary>
        /// d3d_texmax - see Gamestudio manual
        /// </summary>
        private static Var d3d_texmax_ = null;
        public static Var d3d_texmax
        {
            get
            {
                unsafe
                {
                    if (d3d_texmax_ == null)
                    {
                        d3d_texmax_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texmax;
                    }
                }
                return d3d_texmax_;
            }
        }

        /// <summary>
        /// d3d_texlimit - see Gamestudio manual
        /// </summary>
        private static Var d3d_texlimit_ = null;
        public static Var d3d_texlimit
        {
            get
            {
                unsafe
                {
                    if (d3d_texlimit_ == null)
                    {
                        d3d_texlimit_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_texlimit;
                    }
                }
                return d3d_texlimit_;
            }
        }

        /// <summary>
        /// d3d_entsort - see Gamestudio manual
        /// </summary>
        private static Var d3d_entsort_ = null;
        public static Var d3d_entsort
        {
            get
            {
                unsafe
                {
                    if (d3d_entsort_ == null)
                    {
                        d3d_entsort_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_entsort;
                    }
                }
                return d3d_entsort_;
            }
        }

        /// <summary>
        /// d3d_near_sprites - see Gamestudio manual
        /// </summary>
        private static Var d3d_near_sprites_ = null;
        public static Var d3d_near_sprites
        {
            get
            {
                unsafe
                {
                    if (d3d_near_sprites_ == null)
                    {
                        d3d_near_sprites_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_near_sprites;
                    }
                }
                return d3d_near_sprites_;
            }
        }

        /// <summary>
        /// d3d_mipmapping - see Gamestudio manual
        /// </summary>
        private static Var d3d_mipmapping_ = null;
        public static Var d3d_mipmapping
        {
            get
            {
                unsafe
                {
                    if (d3d_mipmapping_ == null)
                    {
                        d3d_mipmapping_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_mipmapping;
                    }
                }
                return d3d_mipmapping_;
            }
        }

        /// <summary>
        /// d3d_near_models - see Gamestudio manual
        /// </summary>
        private static Var d3d_near_models_ = null;
        public static Var d3d_near_models
        {
            get
            {
                unsafe
                {
                    if (d3d_near_models_ == null)
                    {
                        d3d_near_models_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_near_models;
                    }
                }
                return d3d_near_models_;
            }
        }

        /// <summary>
        /// d3d_triplebuffer - see Gamestudio manual
        /// </summary>
        private static Var d3d_triplebuffer_ = null;
        public static Var d3d_triplebuffer
        {
            get
            {
                unsafe
                {
                    if (d3d_triplebuffer_ == null)
                    {
                        d3d_triplebuffer_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_triplebuffer;
                    }
                }
                return d3d_triplebuffer_;
            }
        }


        /// <summary>
        /// d3d_lodfactor - see Gamestudio manual
        /// </summary>
        private static Vector d3d_lodfactor_ = null;
        public static Vector d3d_lodfactor
        {
            get
            {
                unsafe
                {
                    if (d3d_lodfactor_ == null)
                    {
                        d3d_lodfactor_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_lodfactor;
                    }
                }
                return d3d_lodfactor_;
            }
        }


        /// <summary>
        /// d3d_pointlightfalloff - see Gamestudio manual
        /// </summary>
        private static Vector d3d_pointlightfalloff_ = null;
        public static Vector d3d_pointlightfalloff
        {
            get
            {
                unsafe
                {
                    if (d3d_pointlightfalloff_ == null)
                    {
                        d3d_pointlightfalloff_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_pointlightfalloff;
                    }
                }
                return d3d_pointlightfalloff_;
            }
        }


        /// <summary>
        /// d3d_spotlightfalloff - see Gamestudio manual
        /// </summary>
        private static Vector d3d_spotlightfalloff_ = null;
        public static Vector d3d_spotlightfalloff
        {
            get
            {
                unsafe
                {
                    if (d3d_spotlightfalloff_ == null)
                    {
                        d3d_spotlightfalloff_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_spotlightfalloff;
                    }
                }
                return d3d_spotlightfalloff_;
            }
        }


        /// <summary>
        /// d3d_spotlightcone - see Gamestudio manual
        /// </summary>
        private static Vector d3d_spotlightcone_ = null;
        public static Vector d3d_spotlightcone
        {
            get
            {
                unsafe
                {
                    if (d3d_spotlightcone_ == null)
                    {
                        d3d_spotlightcone_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_spotlightcone;
                    }
                }
                return d3d_spotlightcone_;
            }
        }

        /// <summary>
        /// tree_range - see Gamestudio manual
        /// </summary>
        private static Var tree_range_ = null;
        public static Var tree_range
        {
            get
            {
                unsafe
                {
                    if (tree_range_ == null)
                    {
                        tree_range_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tree_range;
                    }
                }
                return tree_range_;
            }
        }

        /// <summary>
        /// clip_factor - see Gamestudio manual
        /// </summary>
        private static Var clip_factor_ = null;
        public static Var clip_factor
        {
            get
            {
                unsafe
                {
                    if (clip_factor_ == null)
                    {
                        clip_factor_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).clip_factor;
                    }
                }
                return clip_factor_;
            }
        }

        /// <summary>
        /// clip_particles - see Gamestudio manual
        /// </summary>
        private static Var clip_particles_ = null;
        public static Var clip_particles
        {
            get
            {
                unsafe
                {
                    if (clip_particles_ == null)
                    {
                        clip_particles_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).clip_particles;
                    }
                }
                return clip_particles_;
            }
        }

        /// <summary>
        /// clip_size - see Gamestudio manual
        /// </summary>
        private static Var clip_size_ = null;
        public static Var clip_size
        {
            get
            {
                unsafe
                {
                    if (clip_size_ == null)
                    {
                        clip_size_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).clip_size;
                    }
                }
                return clip_size_;
            }
        }

        /// <summary>
        /// floor_range - see Gamestudio manual
        /// </summary>
        private static Var floor_range_ = null;
        public static Var floor_range
        {
            get
            {
                unsafe
                {
                    if (floor_range_ == null)
                    {
                        floor_range_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).floor_range;
                    }
                }
                return floor_range_;
            }
        }

        /// <summary>
        /// particle_mode - see Gamestudio manual
        /// </summary>
        private static Var particle_mode_ = null;
        public static Var particle_mode
        {
            get
            {
                unsafe
                {
                    if (particle_mode_ == null)
                    {
                        particle_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).particle_mode;
                    }
                }
                return particle_mode_;
            }
        }

        /// <summary>
        /// mip_shaded - see Gamestudio manual
        /// </summary>
        private static Var mip_shaded_ = null;
        public static Var mip_shaded
        {
            get
            {
                unsafe
                {
                    if (mip_shaded_ == null)
                    {
                        mip_shaded_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mip_shaded;
                    }
                }
                return mip_shaded_;
            }
        }

        /// <summary>
        /// mip_flat - see Gamestudio manual
        /// </summary>
        private static Var mip_flat_ = null;
        public static Var mip_flat
        {
            get
            {
                unsafe
                {
                    if (mip_flat_ == null)
                    {
                        mip_flat_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mip_flat;
                    }
                }
                return mip_flat_;
            }
        }

        /// <summary>
        /// mip_sprites - see Gamestudio manual
        /// </summary>
        private static Var mip_sprites_ = null;
        public static Var mip_sprites
        {
            get
            {
                unsafe
                {
                    if (mip_sprites_ == null)
                    {
                        mip_sprites_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mip_sprites;
                    }
                }
                return mip_sprites_;
            }
        }

        /// <summary>
        /// shadow_mode - see Gamestudio manual
        /// </summary>
        private static Var shadow_mode_ = null;
        public static Var shadow_mode
        {
            get
            {
                unsafe
                {
                    if (shadow_mode_ == null)
                    {
                        shadow_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_mode;
                    }
                }
                return shadow_mode_;
            }
        }

        /// <summary>
        /// trace_floor - see Gamestudio manual
        /// </summary>
        private static Var trace_floor_ = null;
        public static Var trace_floor
        {
            get
            {
                unsafe
                {
                    if (trace_floor_ == null)
                    {
                        trace_floor_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).trace_floor;
                    }
                }
                return trace_floor_;
            }
        }

        /// <summary>
        /// max_particles - see Gamestudio manual
        /// </summary>
        private static Var max_particles_ = null;
        public static Var max_particles
        {
            get
            {
                unsafe
                {
                    if (max_particles_ == null)
                    {
                        max_particles_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_particles;
                    }
                }
                return max_particles_;
            }
        }

        /// <summary>
        /// max_entities - see Gamestudio manual
        /// </summary>
        private static Var max_entities_ = null;
        public static Var max_entities
        {
            get
            {
                unsafe
                {
                    if (max_entities_ == null)
                    {
                        max_entities_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_entities;
                    }
                }
                return max_entities_;
            }
        }

        /// <summary>
        /// max_lights - see Gamestudio manual
        /// </summary>
        private static Var max_lights_ = null;
        public static Var max_lights
        {
            get
            {
                unsafe
                {
                    if (max_lights_ == null)
                    {
                        max_lights_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_lights;
                    }
                }
                return max_lights_;
            }
        }


        /// <summary>
        /// sky_color - see Gamestudio manual
        /// </summary>
        private static Color sky_color_ = null;
        public static Color sky_color
        {
            get
            {
                unsafe
                {
                    if (sky_color_ == null)
                    {
                        sky_color_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_color;
                    }
                }
                return sky_color_;
            }
        }

        /// <summary>
        /// max_bones - see Gamestudio manual
        /// </summary>
        private static Var max_bones_ = null;
        public static Var max_bones
        {
            get
            {
                unsafe
                {
                    if (max_bones_ == null)
                    {
                        max_bones_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_bones;
                    }
                }
                return max_bones_;
            }
        }

        /// <summary>
        /// sky_blend - see Gamestudio manual
        /// </summary>
        private static Var sky_blend_ = null;
        public static Var sky_blend
        {
            get
            {
                unsafe
                {
                    if (sky_blend_ == null)
                    {
                        sky_blend_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_blend;
                    }
                }
                return sky_blend_;
            }
        }


        /// <summary>
        /// sky_speed - see Gamestudio manual
        /// </summary>
        private static Vector sky_speed_ = null;
        public static Vector sky_speed
        {
            get
            {
                unsafe
                {
                    if (sky_speed_ == null)
                    {
                        sky_speed_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_speed;
                    }
                }
                return sky_speed_;
            }
        }


        /// <summary>
        /// cloud_speed - see Gamestudio manual
        /// </summary>
        private static Vector cloud_speed_ = null;
        public static Vector cloud_speed
        {
            get
            {
                unsafe
                {
                    if (cloud_speed_ == null)
                    {
                        cloud_speed_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).cloud_speed;
                    }
                }
                return cloud_speed_;
            }
        }

        /// <summary>
        /// d3d_skydepth - see Gamestudio manual
        /// </summary>
        private static Var d3d_skydepth_ = null;
        public static Var d3d_skydepth
        {
            get
            {
                unsafe
                {
                    if (d3d_skydepth_ == null)
                    {
                        d3d_skydepth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_skydepth;
                    }
                }
                return d3d_skydepth_;
            }
        }

        /// <summary>
        /// sky_curve - see Gamestudio manual
        /// </summary>
        private static Var sky_curve_ = null;
        public static Var sky_curve
        {
            get
            {
                unsafe
                {
                    if (sky_curve_ == null)
                    {
                        sky_curve_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_curve;
                    }
                }
                return sky_curve_;
            }
        }

        /// <summary>
        /// sky_clip - see Gamestudio manual
        /// </summary>
        private static Var sky_clip_ = null;
        public static Var sky_clip
        {
            get
            {
                unsafe
                {
                    if (sky_clip_ == null)
                    {
                        sky_clip_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_clip;
                    }
                }
                return sky_clip_;
            }
        }

        /// <summary>
        /// terrain_chunk - see Gamestudio manual
        /// </summary>
        private static Var terrain_chunk_ = null;
        public static Var terrain_chunk
        {
            get
            {
                unsafe
                {
                    if (terrain_chunk_ == null)
                    {
                        terrain_chunk_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).terrain_chunk;
                    }
                }
                return terrain_chunk_;
            }
        }

        /// <summary>
        /// terrain_lod - see Gamestudio manual
        /// </summary>
        private static Var terrain_lod_ = null;
        public static Var terrain_lod
        {
            get
            {
                unsafe
                {
                    if (terrain_lod_ == null)
                    {
                        terrain_lod_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).terrain_lod;
                    }
                }
                return terrain_lod_;
            }
        }

        /// <summary>
        /// num_lights - see Gamestudio manual
        /// </summary>
        private static Var num_lights_ = null;
        public static Var num_lights
        {
            get
            {
                unsafe
                {
                    if (num_lights_ == null)
                    {
                        num_lights_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_lights;
                    }
                }
                return num_lights_;
            }
        }

        /// <summary>
        /// num_sounds - see Gamestudio manual
        /// </summary>
        private static Var num_sounds_ = null;
        public static Var num_sounds
        {
            get
            {
                unsafe
                {
                    if (num_sounds_ == null)
                    {
                        num_sounds_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_sounds;
                    }
                }
                return num_sounds_;
            }
        }

        /// <summary>
        /// sun_light - see Gamestudio manual
        /// </summary>
        private static Var sun_light_ = null;
        public static Var sun_light
        {
            get
            {
                unsafe
                {
                    if (sun_light_ == null)
                    {
                        sun_light_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sun_light;
                    }
                }
                return sun_light_;
            }
        }


        /// <summary>
        /// sun_color - see Gamestudio manual
        /// </summary>
        private static Color sun_color_ = null;
        public static Color sun_color
        {
            get
            {
                unsafe
                {
                    if (sun_color_ == null)
                    {
                        sun_color_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sun_color;
                    }
                }
                return sun_color_;
            }
        }


        /// <summary>
        /// sun_angle - see Gamestudio manual
        /// </summary>
        private static Angle sun_angle_ = null;
        public static Angle sun_angle
        {
            get
            {
                unsafe
                {
                    if (sun_angle_ == null)
                    {
                        sun_angle_ = (Angle)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sun_angle;
                    }
                }
                return sun_angle_;
            }
        }


        /// <summary>
        /// sun_pos - see Gamestudio manual
        /// </summary>
        private static Vector sun_pos_ = null;
        public static Vector sun_pos
        {
            get
            {
                unsafe
                {
                    if (sun_pos_ == null)
                    {
                        sun_pos_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sun_pos;
                    }
                }
                return sun_pos_;
            }
        }

        /// <summary>
        /// preload_mode - see Gamestudio manual
        /// </summary>
        private static Var preload_mode_ = null;
        public static Var preload_mode
        {
            get
            {
                unsafe
                {
                    if (preload_mode_ == null)
                    {
                        preload_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).preload_mode;
                    }
                }
                return preload_mode_;
            }
        }

        /// <summary>
        /// fog_color - see Gamestudio manual
        /// </summary>
        private static Var fog_color_ = null;
        public static Var fog_color
        {
            get
            {
                unsafe
                {
                    if (fog_color_ == null)
                    {
                        fog_color_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).fog_color;
                    }
                }
                return fog_color_;
            }
        }


        /// <summary>
        /// d3d_fogcolor1 - see Gamestudio manual
        /// </summary>
        private static Color d3d_fogcolor1_ = null;
        public static Color d3d_fogcolor1
        {
            get
            {
                unsafe
                {
                    if (d3d_fogcolor1_ == null)
                    {
                        d3d_fogcolor1_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_fogcolor1;
                    }
                }
                return d3d_fogcolor1_;
            }
        }


        /// <summary>
        /// d3d_fogcolor2 - see Gamestudio manual
        /// </summary>
        private static Color d3d_fogcolor2_ = null;
        public static Color d3d_fogcolor2
        {
            get
            {
                unsafe
                {
                    if (d3d_fogcolor2_ == null)
                    {
                        d3d_fogcolor2_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_fogcolor2;
                    }
                }
                return d3d_fogcolor2_;
            }
        }


        /// <summary>
        /// d3d_fogcolor3 - see Gamestudio manual
        /// </summary>
        private static Color d3d_fogcolor3_ = null;
        public static Color d3d_fogcolor3
        {
            get
            {
                unsafe
                {
                    if (d3d_fogcolor3_ == null)
                    {
                        d3d_fogcolor3_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_fogcolor3;
                    }
                }
                return d3d_fogcolor3_;
            }
        }


        /// <summary>
        /// d3d_fogcolor4 - see Gamestudio manual
        /// </summary>
        private static Color d3d_fogcolor4_ = null;
        public static Color d3d_fogcolor4
        {
            get
            {
                unsafe
                {
                    if (d3d_fogcolor4_ == null)
                    {
                        d3d_fogcolor4_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).d3d_fogcolor4;
                    }
                }
                return d3d_fogcolor4_;
            }
        }

        /// <summary>
        /// turb_speed - see Gamestudio manual
        /// </summary>
        private static Var turb_speed_ = null;
        public static Var turb_speed
        {
            get
            {
                unsafe
                {
                    if (turb_speed_ == null)
                    {
                        turb_speed_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).turb_speed;
                    }
                }
                return turb_speed_;
            }
        }

        /// <summary>
        /// turb_range - see Gamestudio manual
        /// </summary>
        private static Var turb_range_ = null;
        public static Var turb_range
        {
            get
            {
                unsafe
                {
                    if (turb_range_ == null)
                    {
                        turb_range_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).turb_range;
                    }
                }
                return turb_range_;
            }
        }

        /// <summary>
        /// tex_cycles - see Gamestudio manual
        /// </summary>
        private static Var tex_cycles_ = null;
        public static Var tex_cycles
        {
            get
            {
                unsafe
                {
                    if (tex_cycles_ == null)
                    {
                        tex_cycles_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_cycles;
                    }
                }
                return tex_cycles_;
            }
        }

        /// <summary>
        /// detail_size - see Gamestudio manual
        /// </summary>
        private static Var detail_size_ = null;
        public static Var detail_size
        {
            get
            {
                unsafe
                {
                    if (detail_size_ == null)
                    {
                        detail_size_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).detail_size;
                    }
                }
                return detail_size_;
            }
        }

        /// <summary>
        /// pos_resolution - see Gamestudio manual
        /// </summary>
        private static Var pos_resolution_ = null;
        public static Var pos_resolution
        {
            get
            {
                unsafe
                {
                    if (pos_resolution_ == null)
                    {
                        pos_resolution_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pos_resolution;
                    }
                }
                return pos_resolution_;
            }
        }

        /// <summary>
        /// tex_share - see Gamestudio manual
        /// </summary>
        private static Var tex_share_ = null;
        public static Var tex_share
        {
            get
            {
                unsafe
                {
                    if (tex_share_ == null)
                    {
                        tex_share_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_share;
                    }
                }
                return tex_share_;
            }
        }

        /// <summary>
        /// map_subents - see Gamestudio manual
        /// </summary>
        private static Var map_subents_ = null;
        public static Var map_subents
        {
            get
            {
                unsafe
                {
                    if (map_subents_ == null)
                    {
                        map_subents_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).map_subents;
                    }
                }
                return map_subents_;
            }
        }

        /// <summary>
        /// num_particles - see Gamestudio manual
        /// </summary>
        private static Var num_particles_ = null;
        public static Var num_particles
        {
            get
            {
                unsafe
                {
                    if (num_particles_ == null)
                    {
                        num_particles_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_particles;
                    }
                }
                return num_particles_;
            }
        }

        /// <summary>
        /// num_entities - see Gamestudio manual
        /// </summary>
        private static Var num_entities_ = null;
        public static Var num_entities
        {
            get
            {
                unsafe
                {
                    if (num_entities_ == null)
                    {
                        num_entities_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_entities;
                    }
                }
                return num_entities_;
            }
        }

        /// <summary>
        /// num_visents - see Gamestudio manual
        /// </summary>
        private static Var num_visents_ = null;
        public static Var num_visents
        {
            get
            {
                unsafe
                {
                    if (num_visents_ == null)
                    {
                        num_visents_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_visents;
                    }
                }
                return num_visents_;
            }
        }

        /// <summary>
        /// num_vismappolys - see Gamestudio manual
        /// </summary>
        private static Var num_vismappolys_ = null;
        public static Var num_vismappolys
        {
            get
            {
                unsafe
                {
                    if (num_vismappolys_ == null)
                    {
                        num_vismappolys_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_vismappolys;
                    }
                }
                return num_vismappolys_;
            }
        }

        /// <summary>
        /// num_visentpolys - see Gamestudio manual
        /// </summary>
        private static Var num_visentpolys_ = null;
        public static Var num_visentpolys
        {
            get
            {
                unsafe
                {
                    if (num_visentpolys_ == null)
                    {
                        num_visentpolys_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_visentpolys;
                    }
                }
                return num_visentpolys_;
            }
        }

        /// <summary>
        /// num_vistriangles - see Gamestudio manual
        /// </summary>
        private static Var num_vistriangles_ = null;
        public static Var num_vistriangles
        {
            get
            {
                unsafe
                {
                    if (num_vistriangles_ == null)
                    {
                        num_vistriangles_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_vistriangles;
                    }
                }
                return num_vistriangles_;
            }
        }

        /// <summary>
        /// num_actions - see Gamestudio manual
        /// </summary>
        private static Var num_actions_ = null;
        public static Var num_actions
        {
            get
            {
                unsafe
                {
                    if (num_actions_ == null)
                    {
                        num_actions_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_actions;
                    }
                }
                return num_actions_;
            }
        }

        /// <summary>
        /// connection - see Gamestudio manual
        /// </summary>
        private static Var connection_ = null;
        public static Var connection
        {
            get
            {
                unsafe
                {
                    if (connection_ == null)
                    {
                        connection_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).connection;
                    }
                }
                return connection_;
            }
        }

        /// <summary>
        /// dplay_maxclients - see Gamestudio manual
        /// </summary>
        private static Var dplay_maxclients_ = null;
        public static Var dplay_maxclients
        {
            get
            {
                unsafe
                {
                    if (dplay_maxclients_ == null)
                    {
                        dplay_maxclients_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_maxclients;
                    }
                }
                return dplay_maxclients_;
            }
        }

        /// <summary>
        /// dplay_bandwidth - see Gamestudio manual
        /// </summary>
        private static Var dplay_bandwidth_ = null;
        public static Var dplay_bandwidth
        {
            get
            {
                unsafe
                {
                    if (dplay_bandwidth_ == null)
                    {
                        dplay_bandwidth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_bandwidth;
                    }
                }
                return dplay_bandwidth_;
            }
        }

        /// <summary>
        /// dplay_unreliable - see Gamestudio manual
        /// </summary>
        private static Var dplay_unreliable_ = null;
        public static Var dplay_unreliable
        {
            get
            {
                unsafe
                {
                    if (dplay_unreliable_ == null)
                    {
                        dplay_unreliable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_unreliable;
                    }
                }
                return dplay_unreliable_;
            }
        }

        /// <summary>
        /// dplay_smooth - see Gamestudio manual
        /// </summary>
        private static Var dplay_smooth_ = null;
        public static Var dplay_smooth
        {
            get
            {
                unsafe
                {
                    if (dplay_smooth_ == null)
                    {
                        dplay_smooth_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_smooth;
                    }
                }
                return dplay_smooth_;
            }
        }

        /// <summary>
        /// dplay_localfunction - see Gamestudio manual
        /// </summary>
        private static Var dplay_localfunction_ = null;
        public static Var dplay_localfunction
        {
            get
            {
                unsafe
                {
                    if (dplay_localfunction_ == null)
                    {
                        dplay_localfunction_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_localfunction;
                    }
                }
                return dplay_localfunction_;
            }
        }

        /// <summary>
        /// dplay_compression - see Gamestudio manual
        /// </summary>
        private static Var dplay_compression_ = null;
        public static Var dplay_compression
        {
            get
            {
                unsafe
                {
                    if (dplay_compression_ == null)
                    {
                        dplay_compression_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_compression;
                    }
                }
                return dplay_compression_;
            }
        }

        /// <summary>
        /// dplay_entupdate - see Gamestudio manual
        /// </summary>
        private static Var dplay_entupdate_ = null;
        public static Var dplay_entupdate
        {
            get
            {
                unsafe
                {
                    if (dplay_entupdate_ == null)
                    {
                        dplay_entupdate_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_entupdate;
                    }
                }
                return dplay_entupdate_;
            }
        }

        /// <summary>
        /// dplay_pingrate - see Gamestudio manual
        /// </summary>
        private static Var dplay_pingrate_ = null;
        public static Var dplay_pingrate
        {
            get
            {
                unsafe
                {
                    if (dplay_pingrate_ == null)
                    {
                        dplay_pingrate_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_pingrate;
                    }
                }
                return dplay_pingrate_;
            }
        }

        /// <summary>
        /// dplay_entrate - see Gamestudio manual
        /// </summary>
        private static Var dplay_entrate_ = null;
        public static Var dplay_entrate
        {
            get
            {
                unsafe
                {
                    if (dplay_entrate_ == null)
                    {
                        dplay_entrate_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_entrate;
                    }
                }
                return dplay_entrate_;
            }
        }

        /// <summary>
        /// dplay_packetsize - see Gamestudio manual
        /// </summary>
        private static Var dplay_packetsize_ = null;
        public static Var dplay_packetsize
        {
            get
            {
                unsafe
                {
                    if (dplay_packetsize_ == null)
                    {
                        dplay_packetsize_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_packetsize;
                    }
                }
                return dplay_packetsize_;
            }
        }

        /// <summary>
        /// dplay_timeout - see Gamestudio manual
        /// </summary>
        private static Var dplay_timeout_ = null;
        public static Var dplay_timeout
        {
            get
            {
                unsafe
                {
                    if (dplay_timeout_ == null)
                    {
                        dplay_timeout_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_timeout;
                    }
                }
                return dplay_timeout_;
            }
        }

        /// <summary>
        /// dplay_latency - see Gamestudio manual
        /// </summary>
        private static Var dplay_latency_ = null;
        public static Var dplay_latency
        {
            get
            {
                unsafe
                {
                    if (dplay_latency_ == null)
                    {
                        dplay_latency_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_latency;
                    }
                }
                return dplay_latency_;
            }
        }

        /// <summary>
        /// dplay_bps - see Gamestudio manual
        /// </summary>
        private static Var dplay_bps_ = null;
        public static Var dplay_bps
        {
            get
            {
                unsafe
                {
                    if (dplay_bps_ == null)
                    {
                        dplay_bps_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_bps;
                    }
                }
                return dplay_bps_;
            }
        }

        /// <summary>
        /// dplay_bpspeak - see Gamestudio manual
        /// </summary>
        private static Var dplay_bpspeak_ = null;
        public static Var dplay_bpspeak
        {
            get
            {
                unsafe
                {
                    if (dplay_bpspeak_ == null)
                    {
                        dplay_bpspeak_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_bpspeak;
                    }
                }
                return dplay_bpspeak_;
            }
        }

        /// <summary>
        /// dplay_bpsreliable - see Gamestudio manual
        /// </summary>
        private static Var dplay_bpsreliable_ = null;
        public static Var dplay_bpsreliable
        {
            get
            {
                unsafe
                {
                    if (dplay_bpsreliable_ == null)
                    {
                        dplay_bpsreliable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_bpsreliable;
                    }
                }
                return dplay_bpsreliable_;
            }
        }

        /// <summary>
        /// dplay_bpsunreliable - see Gamestudio manual
        /// </summary>
        private static Var dplay_bpsunreliable_ = null;
        public static Var dplay_bpsunreliable
        {
            get
            {
                unsafe
                {
                    if (dplay_bpsunreliable_ == null)
                    {
                        dplay_bpsunreliable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_bpsunreliable;
                    }
                }
                return dplay_bpsunreliable_;
            }
        }

        /// <summary>
        /// dplay_dropped - see Gamestudio manual
        /// </summary>
        private static Var dplay_dropped_ = null;
        public static Var dplay_dropped
        {
            get
            {
                unsafe
                {
                    if (dplay_dropped_ == null)
                    {
                        dplay_dropped_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_dropped;
                    }
                }
                return dplay_dropped_;
            }
        }

        /// <summary>
        /// recbuf_size - see Gamestudio manual
        /// </summary>
        private static Var recbuf_size_ = null;
        public static Var recbuf_size
        {
            get
            {
                unsafe
                {
                    if (recbuf_size_ == null)
                    {
                        recbuf_size_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).recbuf_size;
                    }
                }
                return recbuf_size_;
            }
        }

        /// <summary>
        /// dplay_diag - see Gamestudio manual
        /// </summary>
        private static Var dplay_diag_ = null;
        public static Var dplay_diag
        {
            get
            {
                unsafe
                {
                    if (dplay_diag_ == null)
                    {
                        dplay_diag_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_diag;
                    }
                }
                return dplay_diag_;
            }
        }

        /// <summary>
        /// num_clients - see Gamestudio manual
        /// </summary>
        private static Var num_clients_ = null;
        public static Var num_clients
        {
            get
            {
                unsafe
                {
                    if (num_clients_ == null)
                    {
                        num_clients_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_clients;
                    }
                }
                return num_clients_;
            }
        }

        /// <summary>
        /// dplay_encrypt - see Gamestudio manual
        /// </summary>
        private static Var dplay_encrypt_ = null;
        public static Var dplay_encrypt
        {
            get
            {
                unsafe
                {
                    if (dplay_encrypt_ == null)
                    {
                        dplay_encrypt_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_encrypt;
                    }
                }
                return dplay_encrypt_;
            }
        }

        /// <summary>
        /// dplay_port - see Gamestudio manual
        /// </summary>
        private static Var dplay_port_ = null;
        public static Var dplay_port
        {
            get
            {
                unsafe
                {
                    if (dplay_port_ == null)
                    {
                        dplay_port_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_port;
                    }
                }
                return dplay_port_;
            }
        }

        /// <summary>
        /// dplay_id - see Gamestudio manual
        /// </summary>
        private static Var dplay_id_ = null;
        public static Var dplay_id
        {
            get
            {
                unsafe
                {
                    if (dplay_id_ == null)
                    {
                        dplay_id_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_id;
                    }
                }
                return dplay_id_;
            }
        }

        /// <summary>
        /// dplay_status - see Gamestudio manual
        /// </summary>
        private static Var dplay_status_ = null;
        public static Var dplay_status
        {
            get
            {
                unsafe
                {
                    if (dplay_status_ == null)
                    {
                        dplay_status_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).dplay_status;
                    }
                }
                return dplay_status_;
            }
        }

        /// <summary>
        /// sound_vol - see Gamestudio manual
        /// </summary>
        private static Var sound_vol_ = null;
        public static Var sound_vol
        {
            get
            {
                unsafe
                {
                    if (sound_vol_ == null)
                    {
                        sound_vol_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sound_vol;
                    }
                }
                return sound_vol_;
            }
        }

        /// <summary>
        /// cdaudio_vol - see Gamestudio manual
        /// </summary>
        private static Var cdaudio_vol_ = null;
        public static Var cdaudio_vol
        {
            get
            {
                unsafe
                {
                    if (cdaudio_vol_ == null)
                    {
                        cdaudio_vol_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).cdaudio_vol;
                    }
                }
                return cdaudio_vol_;
            }
        }

        /// <summary>
        /// midi_vol - see Gamestudio manual
        /// </summary>
        private static Var midi_vol_ = null;
        public static Var midi_vol
        {
            get
            {
                unsafe
                {
                    if (midi_vol_ == null)
                    {
                        midi_vol_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).midi_vol;
                    }
                }
                return midi_vol_;
            }
        }

        /// <summary>
        /// media_handle - see Gamestudio manual
        /// </summary>
        private static Var media_handle_ = null;
        public static Var media_handle
        {
            get
            {
                unsafe
                {
                    if (media_handle_ == null)
                    {
                        media_handle_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).media_handle;
                    }
                }
                return media_handle_;
            }
        }

        /// <summary>
        /// media_layer - see Gamestudio manual
        /// </summary>
        private static Var media_layer_ = null;
        public static Var media_layer
        {
            get
            {
                unsafe
                {
                    if (media_layer_ == null)
                    {
                        media_layer_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).media_layer;
                    }
                }
                return media_layer_;
            }
        }

        /// <summary>
        /// num_mediastreams - see Gamestudio manual
        /// </summary>
        private static Var num_mediastreams_ = null;
        public static Var num_mediastreams
        {
            get
            {
                unsafe
                {
                    if (num_mediastreams_ == null)
                    {
                        num_mediastreams_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).num_mediastreams;
                    }
                }
                return num_mediastreams_;
            }
        }

        /// <summary>
        /// doppler_factor - see Gamestudio manual
        /// </summary>
        private static Var doppler_factor_ = null;
        public static Var doppler_factor
        {
            get
            {
                unsafe
                {
                    if (doppler_factor_ == null)
                    {
                        doppler_factor_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).doppler_factor;
                    }
                }
                return doppler_factor_;
            }
        }

        /// <summary>
        /// master_vol - see Gamestudio manual
        /// </summary>
        private static Var master_vol_ = null;
        public static Var master_vol
        {
            get
            {
                unsafe
                {
                    if (master_vol_ == null)
                    {
                        master_vol_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).master_vol;
                    }
                }
                return master_vol_;
            }
        }

        /// <summary>
        /// video_alpha - see Gamestudio manual
        /// </summary>
        private static Var video_alpha_ = null;
        public static Var video_alpha
        {
            get
            {
                unsafe
                {
                    if (video_alpha_ == null)
                    {
                        video_alpha_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_alpha;
                    }
                }
                return video_alpha_;
            }
        }


        /// <summary>
        /// hull_fatmin - see Gamestudio manual
        /// </summary>
        private static Vector hull_fatmin_ = null;
        public static Vector hull_fatmin
        {
            get
            {
                unsafe
                {
                    if (hull_fatmin_ == null)
                    {
                        hull_fatmin_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hull_fatmin;
                    }
                }
                return hull_fatmin_;
            }
        }


        /// <summary>
        /// hull_fatmax - see Gamestudio manual
        /// </summary>
        private static Vector hull_fatmax_ = null;
        public static Vector hull_fatmax
        {
            get
            {
                unsafe
                {
                    if (hull_fatmax_ == null)
                    {
                        hull_fatmax_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hull_fatmax;
                    }
                }
                return hull_fatmax_;
            }
        }


        /// <summary>
        /// hull_narrowmin - see Gamestudio manual
        /// </summary>
        private static Vector hull_narrowmin_ = null;
        public static Vector hull_narrowmin
        {
            get
            {
                unsafe
                {
                    if (hull_narrowmin_ == null)
                    {
                        hull_narrowmin_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hull_narrowmin;
                    }
                }
                return hull_narrowmin_;
            }
        }


        /// <summary>
        /// hull_narrowmax - see Gamestudio manual
        /// </summary>
        private static Vector hull_narrowmax_ = null;
        public static Vector hull_narrowmax
        {
            get
            {
                unsafe
                {
                    if (hull_narrowmax_ == null)
                    {
                        hull_narrowmax_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hull_narrowmax;
                    }
                }
                return hull_narrowmax_;
            }
        }

        /// <summary>
        /// max_ph_entities - see Gamestudio manual
        /// </summary>
        private static Var max_ph_entities_ = null;
        public static Var max_ph_entities
        {
            get
            {
                unsafe
                {
                    if (max_ph_entities_ == null)
                    {
                        max_ph_entities_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).max_ph_entities;
                    }
                }
                return max_ph_entities_;
            }
        }

        /// <summary>
        /// enable_polycollision - see Gamestudio manual
        /// </summary>
        private static Var enable_polycollision_ = null;
        public static Var enable_polycollision
        {
            get
            {
                unsafe
                {
                    if (enable_polycollision_ == null)
                    {
                        enable_polycollision_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).enable_polycollision;
                    }
                }
                return enable_polycollision_;
            }
        }

        /// <summary>
        /// trace_mode - see Gamestudio manual
        /// </summary>
        private static Var trace_mode_ = null;
        public static Var trace_mode
        {
            get
            {
                unsafe
                {
                    if (trace_mode_ == null)
                    {
                        trace_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).trace_mode;
                    }
                }
                return trace_mode_;
            }
        }

        /// <summary>
        /// move_mode - see Gamestudio manual
        /// </summary>
        private static Var move_mode_ = null;
        public static Var move_mode
        {
            get
            {
                unsafe
                {
                    if (move_mode_ == null)
                    {
                        move_mode_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).move_mode;
                    }
                }
                return move_mode_;
            }
        }

        /// <summary>
        /// move_friction - see Gamestudio manual
        /// </summary>
        private static Var move_friction_ = null;
        public static Var move_friction
        {
            get
            {
                unsafe
                {
                    if (move_friction_ == null)
                    {
                        move_friction_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).move_friction;
                    }
                }
                return move_friction_;
            }
        }

        /// <summary>
        /// move_restrict - see Gamestudio manual
        /// </summary>
        private static Var move_restrict_ = null;
        public static Var move_restrict
        {
            get
            {
                unsafe
                {
                    if (move_restrict_ == null)
                    {
                        move_restrict_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).move_restrict;
                    }
                }
                return move_restrict_;
            }
        }


        /// <summary>
        /// normal - see Gamestudio manual
        /// </summary>
        private static Vector normal_ = null;
        public static Vector normal
        {
            get
            {
                unsafe
                {
                    if (normal_ == null)
                    {
                        normal_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).normal;
                    }
                }
                return normal_;
            }
        }


        /// <summary>
        /// bounce - see Gamestudio manual
        /// </summary>
        private static Vector bounce_ = null;
        public static Vector bounce
        {
            get
            {
                unsafe
                {
                    if (bounce_ == null)
                    {
                        bounce_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).bounce;
                    }
                }
                return bounce_;
            }
        }


        /// <summary>
        /// target - see Gamestudio manual
        /// </summary>
        private static Vector target_ = null;
        public static Vector target
        {
            get
            {
                unsafe
                {
                    if (target_ == null)
                    {
                        target_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).target;
                    }
                }
                return target_;
            }
        }


        /// <summary>
        /// vglide - see Gamestudio manual
        /// </summary>
        private static Vector vglide_ = null;
        public static Vector vglide
        {
            get
            {
                unsafe
                {
                    if (vglide_ == null)
                    {
                        vglide_ = (Vector)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).vglide;
                    }
                }
                return vglide_;
            }
        }

        /// <summary>
        /// on_passable - see Gamestudio manual
        /// </summary>
        private static Var on_passable_ = null;
        public static Var on_passable
        {
            get
            {
                unsafe
                {
                    if (on_passable_ == null)
                    {
                        on_passable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).on_passable;
                    }
                }
                return on_passable_;
            }
        }

        /// <summary>
        /// in_passable - see Gamestudio manual
        /// </summary>
        private static Var in_passable_ = null;
        public static Var in_passable
        {
            get
            {
                unsafe
                {
                    if (in_passable_ == null)
                    {
                        in_passable_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).in_passable;
                    }
                }
                return in_passable_;
            }
        }

        /// <summary>
        /// in_solid - see Gamestudio manual
        /// </summary>
        private static Var in_solid_ = null;
        public static Var in_solid
        {
            get
            {
                unsafe
                {
                    if (in_solid_ == null)
                    {
                        in_solid_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).in_solid;
                    }
                }
                return in_solid_;
            }
        }

        /// <summary>
        /// tex_light - see Gamestudio manual
        /// </summary>
        private static Var tex_light_ = null;
        public static Var tex_light
        {
            get
            {
                unsafe
                {
                    if (tex_light_ == null)
                    {
                        tex_light_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_light;
                    }
                }
                return tex_light_;
            }
        }


        /// <summary>
        /// tex_color - see Gamestudio manual
        /// </summary>
        private static Color tex_color_ = null;
        public static Color tex_color
        {
            get
            {
                unsafe
                {
                    if (tex_color_ == null)
                    {
                        tex_color_ = (Color)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_color;
                    }
                }
                return tex_color_;
            }
        }

        /// <summary>
        /// tex_fog - see Gamestudio manual
        /// </summary>
        private static Var tex_fog_ = null;
        public static Var tex_fog
        {
            get
            {
                unsafe
                {
                    if (tex_fog_ == null)
                    {
                        tex_fog_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_fog;
                    }
                }
                return tex_fog_;
            }
        }

        /// <summary>
        /// tex_flag1 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag1_ = null;
        public static Var tex_flag1
        {
            get
            {
                unsafe
                {
                    if (tex_flag1_ == null)
                    {
                        tex_flag1_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag1;
                    }
                }
                return tex_flag1_;
            }
        }

        /// <summary>
        /// tex_flag2 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag2_ = null;
        public static Var tex_flag2
        {
            get
            {
                unsafe
                {
                    if (tex_flag2_ == null)
                    {
                        tex_flag2_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag2;
                    }
                }
                return tex_flag2_;
            }
        }

        /// <summary>
        /// tex_flag3 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag3_ = null;
        public static Var tex_flag3
        {
            get
            {
                unsafe
                {
                    if (tex_flag3_ == null)
                    {
                        tex_flag3_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag3;
                    }
                }
                return tex_flag3_;
            }
        }

        /// <summary>
        /// tex_flag4 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag4_ = null;
        public static Var tex_flag4
        {
            get
            {
                unsafe
                {
                    if (tex_flag4_ == null)
                    {
                        tex_flag4_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag4;
                    }
                }
                return tex_flag4_;
            }
        }

        /// <summary>
        /// tex_flag5 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag5_ = null;
        public static Var tex_flag5
        {
            get
            {
                unsafe
                {
                    if (tex_flag5_ == null)
                    {
                        tex_flag5_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag5;
                    }
                }
                return tex_flag5_;
            }
        }

        /// <summary>
        /// tex_flag6 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag6_ = null;
        public static Var tex_flag6
        {
            get
            {
                unsafe
                {
                    if (tex_flag6_ == null)
                    {
                        tex_flag6_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag6;
                    }
                }
                return tex_flag6_;
            }
        }

        /// <summary>
        /// tex_flag7 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag7_ = null;
        public static Var tex_flag7
        {
            get
            {
                unsafe
                {
                    if (tex_flag7_ == null)
                    {
                        tex_flag7_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag7;
                    }
                }
                return tex_flag7_;
            }
        }

        /// <summary>
        /// tex_flag8 - see Gamestudio manual
        /// </summary>
        private static Var tex_flag8_ = null;
        public static Var tex_flag8
        {
            get
            {
                unsafe
                {
                    if (tex_flag8_ == null)
                    {
                        tex_flag8_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).tex_flag8;
                    }
                }
                return tex_flag8_;
            }
        }

        /// <summary>
        /// hitvertex - see Gamestudio manual
        /// </summary>
        private static Var hitvertex_ = null;
        public static Var hitvertex
        {
            get
            {
                unsafe
                {
                    if (hitvertex_ == null)
                    {
                        hitvertex_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hitvertex;
                    }
                }
                return hitvertex_;
            }
        }

        /// <summary>
        /// terrain_cell_size - see Gamestudio manual
        /// </summary>
        private static Var terrain_cell_size_ = null;
        public static Var terrain_cell_size
        {
            get
            {
                unsafe
                {
                    if (terrain_cell_size_ == null)
                    {
                        terrain_cell_size_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).terrain_cell_size;
                    }
                }
                return terrain_cell_size_;
            }
        }

        /// <summary>
        /// trace_hit - see Gamestudio manual
        /// </summary>
        private static Var trace_hit_ = null;
        public static Var trace_hit
        {
            get
            {
                unsafe
                {
                    if (trace_hit_ == null)
                    {
                        trace_hit_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).trace_hit;
                    }
                }
                return trace_hit_;
            }
        }

        /// <summary>
        /// ph_num_bodies - see Gamestudio manual
        /// </summary>
        private static Var ph_num_bodies_ = null;
        public static Var ph_num_bodies
        {
            get
            {
                unsafe
                {
                    if (ph_num_bodies_ == null)
                    {
                        ph_num_bodies_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_num_bodies;
                    }
                }
                return ph_num_bodies_;
            }
        }

        /// <summary>
        /// ph_num_contacts - see Gamestudio manual
        /// </summary>
        private static Var ph_num_contacts_ = null;
        public static Var ph_num_contacts
        {
            get
            {
                unsafe
                {
                    if (ph_num_contacts_ == null)
                    {
                        ph_num_contacts_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_num_contacts;
                    }
                }
                return ph_num_contacts_;
            }
        }

        /// <summary>
        /// ph_iterations - see Gamestudio manual
        /// </summary>
        private static Var ph_iterations_ = null;
        public static Var ph_iterations
        {
            get
            {
                unsafe
                {
                    if (ph_iterations_ == null)
                    {
                        ph_iterations_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_iterations;
                    }
                }
                return ph_iterations_;
            }
        }

        /// <summary>
        /// ph_fps_max_lock - see Gamestudio manual
        /// </summary>
        private static Var ph_fps_max_lock_ = null;
        public static Var ph_fps_max_lock
        {
            get
            {
                unsafe
                {
                    if (ph_fps_max_lock_ == null)
                    {
                        ph_fps_max_lock_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_fps_max_lock;
                    }
                }
                return ph_fps_max_lock_;
            }
        }

        /// <summary>
        /// move_min_z - see Gamestudio manual
        /// </summary>
        private static Var move_min_z_ = null;
        public static Var move_min_z
        {
            get
            {
                unsafe
                {
                    if (move_min_z_ == null)
                    {
                        move_min_z_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).move_min_z;
                    }
                }
                return move_min_z_;
            }
        }

        /// <summary>
        /// disable_z_glide - see Gamestudio manual
        /// </summary>
        private static Var disable_z_glide_ = null;
        public static Var disable_z_glide
        {
            get
            {
                unsafe
                {
                    if (disable_z_glide_ == null)
                    {
                        disable_z_glide_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).disable_z_glide;
                    }
                }
                return disable_z_glide_;
            }
        }

        /// <summary>
        /// ph_max_contacts - see Gamestudio manual
        /// </summary>
        private static Var ph_max_contacts_ = null;
        public static Var ph_max_contacts
        {
            get
            {
                unsafe
                {
                    if (ph_max_contacts_ == null)
                    {
                        ph_max_contacts_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_max_contacts;
                    }
                }
                return ph_max_contacts_;
            }
        }

        /// <summary>
        /// ph_check_distance - see Gamestudio manual
        /// </summary>
        private static Var ph_check_distance_ = null;
        public static Var ph_check_distance
        {
            get
            {
                unsafe
                {
                    if (ph_check_distance_ == null)
                    {
                        ph_check_distance_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_check_distance;
                    }
                }
                return ph_check_distance_;
            }
        }

        /// <summary>
        /// ph_num_collisions - see Gamestudio manual
        /// </summary>
        private static Var ph_num_collisions_ = null;
        public static Var ph_num_collisions
        {
            get
            {
                unsafe
                {
                    if (ph_num_collisions_ == null)
                    {
                        ph_num_collisions_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).ph_num_collisions;
                    }
                }
                return ph_num_collisions_;
            }
        }

        /// <summary>
        /// move_pushback - see Gamestudio manual
        /// </summary>
        private static Var move_pushback_ = null;
        public static Var move_pushback
        {
            get
            {
                unsafe
                {
                    if (move_pushback_ == null)
                    {
                        move_pushback_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).move_pushback;
                    }
                }
                return move_pushback_;
            }
        }

        /// <summary>
        /// shadow_meshsize - see Gamestudio manual
        /// </summary>
        private static Var shadow_meshsize_ = null;
        public static Var shadow_meshsize
        {
            get
            {
                unsafe
                {
                    if (shadow_meshsize_ == null)
                    {
                        shadow_meshsize_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).shadow_meshsize;
                    }
                }
                return shadow_meshsize_;
            }
        }

        /// <summary>
        /// last_skill - see Gamestudio manual
        /// </summary>
        private static Var last_skill_ = null;
        public static Var last_skill
        {
            get
            {
                unsafe
                {
                    if (last_skill_ == null)
                    {
                        last_skill_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).last_skill;
                    }
                }
                return last_skill_;
            }
        }

        /// <summary>
        /// key_bksp - see Gamestudio manual
        /// </summary>
        private static Var key_bksp_ = null;
        public static Var key_bksp
        {
            get
            {
                unsafe
                {
                    if (key_bksp_ == null)
                    {
                        key_bksp_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_bksp;
                    }
                }
                return key_bksp_;
            }
        }

        /// <summary>
        /// key_enter - see Gamestudio manual
        /// </summary>
        private static Var key_enter_ = null;
        public static Var key_enter
        {
            get
            {
                unsafe
                {
                    if (key_enter_ == null)
                    {
                        key_enter_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_enter;
                    }
                }
                return key_enter_;
            }
        }

        /// <summary>
        /// key_esc - see Gamestudio manual
        /// </summary>
        private static Var key_esc_ = null;
        public static Var key_esc
        {
            get
            {
                unsafe
                {
                    if (key_esc_ == null)
                    {
                        key_esc_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_esc;
                    }
                }
                return key_esc_;
            }
        }

        /// <summary>
        /// key_alt - see Gamestudio manual
        /// </summary>
        private static Var key_alt_ = null;
        public static Var key_alt
        {
            get
            {
                unsafe
                {
                    if (key_alt_ == null)
                    {
                        key_alt_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_alt;
                    }
                }
                return key_alt_;
            }
        }

        /// <summary>
        /// key_ctrl - see Gamestudio manual
        /// </summary>
        private static Var key_ctrl_ = null;
        public static Var key_ctrl
        {
            get
            {
                unsafe
                {
                    if (key_ctrl_ == null)
                    {
                        key_ctrl_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_ctrl;
                    }
                }
                return key_ctrl_;
            }
        }

        /// <summary>
        /// key_shiftl - see Gamestudio manual
        /// </summary>
        private static Var key_shiftl_ = null;
        public static Var key_shiftl
        {
            get
            {
                unsafe
                {
                    if (key_shiftl_ == null)
                    {
                        key_shiftl_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_shiftl;
                    }
                }
                return key_shiftl_;
            }
        }

        /// <summary>
        /// key_shiftr - see Gamestudio manual
        /// </summary>
        private static Var key_shiftr_ = null;
        public static Var key_shiftr
        {
            get
            {
                unsafe
                {
                    if (key_shiftr_ == null)
                    {
                        key_shiftr_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_shiftr;
                    }
                }
                return key_shiftr_;
            }
        }

        /// <summary>
        /// key_space - see Gamestudio manual
        /// </summary>
        private static Var key_space_ = null;
        public static Var key_space
        {
            get
            {
                unsafe
                {
                    if (key_space_ == null)
                    {
                        key_space_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_space;
                    }
                }
                return key_space_;
            }
        }

        /// <summary>
        /// key_tab - see Gamestudio manual
        /// </summary>
        private static Var key_tab_ = null;
        public static Var key_tab
        {
            get
            {
                unsafe
                {
                    if (key_tab_ == null)
                    {
                        key_tab_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_tab;
                    }
                }
                return key_tab_;
            }
        }

        /// <summary>
        /// key_f1 - see Gamestudio manual
        /// </summary>
        private static Var key_f1_ = null;
        public static Var key_f1
        {
            get
            {
                unsafe
                {
                    if (key_f1_ == null)
                    {
                        key_f1_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f1;
                    }
                }
                return key_f1_;
            }
        }

        /// <summary>
        /// key_f2 - see Gamestudio manual
        /// </summary>
        private static Var key_f2_ = null;
        public static Var key_f2
        {
            get
            {
                unsafe
                {
                    if (key_f2_ == null)
                    {
                        key_f2_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f2;
                    }
                }
                return key_f2_;
            }
        }

        /// <summary>
        /// key_f3 - see Gamestudio manual
        /// </summary>
        private static Var key_f3_ = null;
        public static Var key_f3
        {
            get
            {
                unsafe
                {
                    if (key_f3_ == null)
                    {
                        key_f3_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f3;
                    }
                }
                return key_f3_;
            }
        }

        /// <summary>
        /// key_f4 - see Gamestudio manual
        /// </summary>
        private static Var key_f4_ = null;
        public static Var key_f4
        {
            get
            {
                unsafe
                {
                    if (key_f4_ == null)
                    {
                        key_f4_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f4;
                    }
                }
                return key_f4_;
            }
        }

        /// <summary>
        /// key_f5 - see Gamestudio manual
        /// </summary>
        private static Var key_f5_ = null;
        public static Var key_f5
        {
            get
            {
                unsafe
                {
                    if (key_f5_ == null)
                    {
                        key_f5_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f5;
                    }
                }
                return key_f5_;
            }
        }

        /// <summary>
        /// key_f6 - see Gamestudio manual
        /// </summary>
        private static Var key_f6_ = null;
        public static Var key_f6
        {
            get
            {
                unsafe
                {
                    if (key_f6_ == null)
                    {
                        key_f6_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f6;
                    }
                }
                return key_f6_;
            }
        }

        /// <summary>
        /// key_f7 - see Gamestudio manual
        /// </summary>
        private static Var key_f7_ = null;
        public static Var key_f7
        {
            get
            {
                unsafe
                {
                    if (key_f7_ == null)
                    {
                        key_f7_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f7;
                    }
                }
                return key_f7_;
            }
        }

        /// <summary>
        /// key_f8 - see Gamestudio manual
        /// </summary>
        private static Var key_f8_ = null;
        public static Var key_f8
        {
            get
            {
                unsafe
                {
                    if (key_f8_ == null)
                    {
                        key_f8_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f8;
                    }
                }
                return key_f8_;
            }
        }

        /// <summary>
        /// key_f9 - see Gamestudio manual
        /// </summary>
        private static Var key_f9_ = null;
        public static Var key_f9
        {
            get
            {
                unsafe
                {
                    if (key_f9_ == null)
                    {
                        key_f9_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f9;
                    }
                }
                return key_f9_;
            }
        }

        /// <summary>
        /// key_f10 - see Gamestudio manual
        /// </summary>
        private static Var key_f10_ = null;
        public static Var key_f10
        {
            get
            {
                unsafe
                {
                    if (key_f10_ == null)
                    {
                        key_f10_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f10;
                    }
                }
                return key_f10_;
            }
        }

        /// <summary>
        /// key_f11 - see Gamestudio manual
        /// </summary>
        private static Var key_f11_ = null;
        public static Var key_f11
        {
            get
            {
                unsafe
                {
                    if (key_f11_ == null)
                    {
                        key_f11_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f11;
                    }
                }
                return key_f11_;
            }
        }

        /// <summary>
        /// key_f12 - see Gamestudio manual
        /// </summary>
        private static Var key_f12_ = null;
        public static Var key_f12
        {
            get
            {
                unsafe
                {
                    if (key_f12_ == null)
                    {
                        key_f12_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f12;
                    }
                }
                return key_f12_;
            }
        }

        /// <summary>
        /// key_a - see Gamestudio manual
        /// </summary>
        private static Var key_a_ = null;
        public static Var key_a
        {
            get
            {
                unsafe
                {
                    if (key_a_ == null)
                    {
                        key_a_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_a;
                    }
                }
                return key_a_;
            }
        }

        /// <summary>
        /// key_b - see Gamestudio manual
        /// </summary>
        private static Var key_b_ = null;
        public static Var key_b
        {
            get
            {
                unsafe
                {
                    if (key_b_ == null)
                    {
                        key_b_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_b;
                    }
                }
                return key_b_;
            }
        }

        /// <summary>
        /// key_c - see Gamestudio manual
        /// </summary>
        private static Var key_c_ = null;
        public static Var key_c
        {
            get
            {
                unsafe
                {
                    if (key_c_ == null)
                    {
                        key_c_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_c;
                    }
                }
                return key_c_;
            }
        }

        /// <summary>
        /// key_d - see Gamestudio manual
        /// </summary>
        private static Var key_d_ = null;
        public static Var key_d
        {
            get
            {
                unsafe
                {
                    if (key_d_ == null)
                    {
                        key_d_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_d;
                    }
                }
                return key_d_;
            }
        }

        /// <summary>
        /// key_e - see Gamestudio manual
        /// </summary>
        private static Var key_e_ = null;
        public static Var key_e
        {
            get
            {
                unsafe
                {
                    if (key_e_ == null)
                    {
                        key_e_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_e;
                    }
                }
                return key_e_;
            }
        }

        /// <summary>
        /// key_f - see Gamestudio manual
        /// </summary>
        private static Var key_f_ = null;
        public static Var key_f
        {
            get
            {
                unsafe
                {
                    if (key_f_ == null)
                    {
                        key_f_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_f;
                    }
                }
                return key_f_;
            }
        }

        /// <summary>
        /// key_g - see Gamestudio manual
        /// </summary>
        private static Var key_g_ = null;
        public static Var key_g
        {
            get
            {
                unsafe
                {
                    if (key_g_ == null)
                    {
                        key_g_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_g;
                    }
                }
                return key_g_;
            }
        }

        /// <summary>
        /// key_h - see Gamestudio manual
        /// </summary>
        private static Var key_h_ = null;
        public static Var key_h
        {
            get
            {
                unsafe
                {
                    if (key_h_ == null)
                    {
                        key_h_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_h;
                    }
                }
                return key_h_;
            }
        }

        /// <summary>
        /// key_i - see Gamestudio manual
        /// </summary>
        private static Var key_i_ = null;
        public static Var key_i
        {
            get
            {
                unsafe
                {
                    if (key_i_ == null)
                    {
                        key_i_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_i;
                    }
                }
                return key_i_;
            }
        }

        /// <summary>
        /// key_j - see Gamestudio manual
        /// </summary>
        private static Var key_j_ = null;
        public static Var key_j
        {
            get
            {
                unsafe
                {
                    if (key_j_ == null)
                    {
                        key_j_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_j;
                    }
                }
                return key_j_;
            }
        }

        /// <summary>
        /// key_k - see Gamestudio manual
        /// </summary>
        private static Var key_k_ = null;
        public static Var key_k
        {
            get
            {
                unsafe
                {
                    if (key_k_ == null)
                    {
                        key_k_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_k;
                    }
                }
                return key_k_;
            }
        }

        /// <summary>
        /// key_l - see Gamestudio manual
        /// </summary>
        private static Var key_l_ = null;
        public static Var key_l
        {
            get
            {
                unsafe
                {
                    if (key_l_ == null)
                    {
                        key_l_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_l;
                    }
                }
                return key_l_;
            }
        }

        /// <summary>
        /// key_m - see Gamestudio manual
        /// </summary>
        private static Var key_m_ = null;
        public static Var key_m
        {
            get
            {
                unsafe
                {
                    if (key_m_ == null)
                    {
                        key_m_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_m;
                    }
                }
                return key_m_;
            }
        }

        /// <summary>
        /// key_n - see Gamestudio manual
        /// </summary>
        private static Var key_n_ = null;
        public static Var key_n
        {
            get
            {
                unsafe
                {
                    if (key_n_ == null)
                    {
                        key_n_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_n;
                    }
                }
                return key_n_;
            }
        }

        /// <summary>
        /// key_o - see Gamestudio manual
        /// </summary>
        private static Var key_o_ = null;
        public static Var key_o
        {
            get
            {
                unsafe
                {
                    if (key_o_ == null)
                    {
                        key_o_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_o;
                    }
                }
                return key_o_;
            }
        }

        /// <summary>
        /// key_p - see Gamestudio manual
        /// </summary>
        private static Var key_p_ = null;
        public static Var key_p
        {
            get
            {
                unsafe
                {
                    if (key_p_ == null)
                    {
                        key_p_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_p;
                    }
                }
                return key_p_;
            }
        }

        /// <summary>
        /// key_q - see Gamestudio manual
        /// </summary>
        private static Var key_q_ = null;
        public static Var key_q
        {
            get
            {
                unsafe
                {
                    if (key_q_ == null)
                    {
                        key_q_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_q;
                    }
                }
                return key_q_;
            }
        }

        /// <summary>
        /// key_r - see Gamestudio manual
        /// </summary>
        private static Var key_r_ = null;
        public static Var key_r
        {
            get
            {
                unsafe
                {
                    if (key_r_ == null)
                    {
                        key_r_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_r;
                    }
                }
                return key_r_;
            }
        }

        /// <summary>
        /// key_s - see Gamestudio manual
        /// </summary>
        private static Var key_s_ = null;
        public static Var key_s
        {
            get
            {
                unsafe
                {
                    if (key_s_ == null)
                    {
                        key_s_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_s;
                    }
                }
                return key_s_;
            }
        }

        /// <summary>
        /// key_t - see Gamestudio manual
        /// </summary>
        private static Var key_t_ = null;
        public static Var key_t
        {
            get
            {
                unsafe
                {
                    if (key_t_ == null)
                    {
                        key_t_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_t;
                    }
                }
                return key_t_;
            }
        }

        /// <summary>
        /// key_u - see Gamestudio manual
        /// </summary>
        private static Var key_u_ = null;
        public static Var key_u
        {
            get
            {
                unsafe
                {
                    if (key_u_ == null)
                    {
                        key_u_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_u;
                    }
                }
                return key_u_;
            }
        }

        /// <summary>
        /// key_v - see Gamestudio manual
        /// </summary>
        private static Var key_v_ = null;
        public static Var key_v
        {
            get
            {
                unsafe
                {
                    if (key_v_ == null)
                    {
                        key_v_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_v;
                    }
                }
                return key_v_;
            }
        }

        /// <summary>
        /// key_w - see Gamestudio manual
        /// </summary>
        private static Var key_w_ = null;
        public static Var key_w
        {
            get
            {
                unsafe
                {
                    if (key_w_ == null)
                    {
                        key_w_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_w;
                    }
                }
                return key_w_;
            }
        }

        /// <summary>
        /// key_x - see Gamestudio manual
        /// </summary>
        private static Var key_x_ = null;
        public static Var key_x
        {
            get
            {
                unsafe
                {
                    if (key_x_ == null)
                    {
                        key_x_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_x;
                    }
                }
                return key_x_;
            }
        }

        /// <summary>
        /// key_y - see Gamestudio manual
        /// </summary>
        private static Var key_y_ = null;
        public static Var key_y
        {
            get
            {
                unsafe
                {
                    if (key_y_ == null)
                    {
                        key_y_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_y;
                    }
                }
                return key_y_;
            }
        }

        /// <summary>
        /// key_z - see Gamestudio manual
        /// </summary>
        private static Var key_z_ = null;
        public static Var key_z
        {
            get
            {
                unsafe
                {
                    if (key_z_ == null)
                    {
                        key_z_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_z;
                    }
                }
                return key_z_;
            }
        }

        /// <summary>
        /// key_cuu - see Gamestudio manual
        /// </summary>
        private static Var key_cuu_ = null;
        public static Var key_cuu
        {
            get
            {
                unsafe
                {
                    if (key_cuu_ == null)
                    {
                        key_cuu_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_cuu;
                    }
                }
                return key_cuu_;
            }
        }

        /// <summary>
        /// key_cud - see Gamestudio manual
        /// </summary>
        private static Var key_cud_ = null;
        public static Var key_cud
        {
            get
            {
                unsafe
                {
                    if (key_cud_ == null)
                    {
                        key_cud_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_cud;
                    }
                }
                return key_cud_;
            }
        }

        /// <summary>
        /// key_cur - see Gamestudio manual
        /// </summary>
        private static Var key_cur_ = null;
        public static Var key_cur
        {
            get
            {
                unsafe
                {
                    if (key_cur_ == null)
                    {
                        key_cur_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_cur;
                    }
                }
                return key_cur_;
            }
        }

        /// <summary>
        /// key_cul - see Gamestudio manual
        /// </summary>
        private static Var key_cul_ = null;
        public static Var key_cul
        {
            get
            {
                unsafe
                {
                    if (key_cul_ == null)
                    {
                        key_cul_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_cul;
                    }
                }
                return key_cul_;
            }
        }

        /// <summary>
        /// key_pgup - see Gamestudio manual
        /// </summary>
        private static Var key_pgup_ = null;
        public static Var key_pgup
        {
            get
            {
                unsafe
                {
                    if (key_pgup_ == null)
                    {
                        key_pgup_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_pgup;
                    }
                }
                return key_pgup_;
            }
        }

        /// <summary>
        /// key_pgdn - see Gamestudio manual
        /// </summary>
        private static Var key_pgdn_ = null;
        public static Var key_pgdn
        {
            get
            {
                unsafe
                {
                    if (key_pgdn_ == null)
                    {
                        key_pgdn_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_pgdn;
                    }
                }
                return key_pgdn_;
            }
        }

        /// <summary>
        /// key_home - see Gamestudio manual
        /// </summary>
        private static Var key_home_ = null;
        public static Var key_home
        {
            get
            {
                unsafe
                {
                    if (key_home_ == null)
                    {
                        key_home_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_home;
                    }
                }
                return key_home_;
            }
        }

        /// <summary>
        /// key_end - see Gamestudio manual
        /// </summary>
        private static Var key_end_ = null;
        public static Var key_end
        {
            get
            {
                unsafe
                {
                    if (key_end_ == null)
                    {
                        key_end_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_end;
                    }
                }
                return key_end_;
            }
        }

        /// <summary>
        /// key_ins - see Gamestudio manual
        /// </summary>
        private static Var key_ins_ = null;
        public static Var key_ins
        {
            get
            {
                unsafe
                {
                    if (key_ins_ == null)
                    {
                        key_ins_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_ins;
                    }
                }
                return key_ins_;
            }
        }

        /// <summary>
        /// key_del - see Gamestudio manual
        /// </summary>
        private static Var key_del_ = null;
        public static Var key_del
        {
            get
            {
                unsafe
                {
                    if (key_del_ == null)
                    {
                        key_del_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_del;
                    }
                }
                return key_del_;
            }
        }

        /// <summary>
        /// key_car - see Gamestudio manual
        /// </summary>
        private static Var key_car_ = null;
        public static Var key_car
        {
            get
            {
                unsafe
                {
                    if (key_car_ == null)
                    {
                        key_car_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_car;
                    }
                }
                return key_car_;
            }
        }

        /// <summary>
        /// key_cal - see Gamestudio manual
        /// </summary>
        private static Var key_cal_ = null;
        public static Var key_cal
        {
            get
            {
                unsafe
                {
                    if (key_cal_ == null)
                    {
                        key_cal_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_cal;
                    }
                }
                return key_cal_;
            }
        }

        /// <summary>
        /// key_slash - see Gamestudio manual
        /// </summary>
        private static Var key_slash_ = null;
        public static Var key_slash
        {
            get
            {
                unsafe
                {
                    if (key_slash_ == null)
                    {
                        key_slash_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_slash;
                    }
                }
                return key_slash_;
            }
        }

        /// <summary>
        /// key_equals - see Gamestudio manual
        /// </summary>
        private static Var key_equals_ = null;
        public static Var key_equals
        {
            get
            {
                unsafe
                {
                    if (key_equals_ == null)
                    {
                        key_equals_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_equals;
                    }
                }
                return key_equals_;
            }
        }

        /// <summary>
        /// key_period - see Gamestudio manual
        /// </summary>
        private static Var key_period_ = null;
        public static Var key_period
        {
            get
            {
                unsafe
                {
                    if (key_period_ == null)
                    {
                        key_period_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_period;
                    }
                }
                return key_period_;
            }
        }

        /// <summary>
        /// key_comma - see Gamestudio manual
        /// </summary>
        private static Var key_comma_ = null;
        public static Var key_comma
        {
            get
            {
                unsafe
                {
                    if (key_comma_ == null)
                    {
                        key_comma_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_comma;
                    }
                }
                return key_comma_;
            }
        }

        /// <summary>
        /// key_brackl - see Gamestudio manual
        /// </summary>
        private static Var key_brackl_ = null;
        public static Var key_brackl
        {
            get
            {
                unsafe
                {
                    if (key_brackl_ == null)
                    {
                        key_brackl_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_brackl;
                    }
                }
                return key_brackl_;
            }
        }

        /// <summary>
        /// key_brackr - see Gamestudio manual
        /// </summary>
        private static Var key_brackr_ = null;
        public static Var key_brackr
        {
            get
            {
                unsafe
                {
                    if (key_brackr_ == null)
                    {
                        key_brackr_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_brackr;
                    }
                }
                return key_brackr_;
            }
        }

        /// <summary>
        /// key_semic - see Gamestudio manual
        /// </summary>
        private static Var key_semic_ = null;
        public static Var key_semic
        {
            get
            {
                unsafe
                {
                    if (key_semic_ == null)
                    {
                        key_semic_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_semic;
                    }
                }
                return key_semic_;
            }
        }

        /// <summary>
        /// key_bksl - see Gamestudio manual
        /// </summary>
        private static Var key_bksl_ = null;
        public static Var key_bksl
        {
            get
            {
                unsafe
                {
                    if (key_bksl_ == null)
                    {
                        key_bksl_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_bksl;
                    }
                }
                return key_bksl_;
            }
        }

        /// <summary>
        /// key_apos - see Gamestudio manual
        /// </summary>
        private static Var key_apos_ = null;
        public static Var key_apos
        {
            get
            {
                unsafe
                {
                    if (key_apos_ == null)
                    {
                        key_apos_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_apos;
                    }
                }
                return key_apos_;
            }
        }

        /// <summary>
        /// key_minusc - see Gamestudio manual
        /// </summary>
        private static Var key_minusc_ = null;
        public static Var key_minusc
        {
            get
            {
                unsafe
                {
                    if (key_minusc_ == null)
                    {
                        key_minusc_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_minusc;
                    }
                }
                return key_minusc_;
            }
        }

        /// <summary>
        /// key_grave - see Gamestudio manual
        /// </summary>
        private static Var key_grave_ = null;
        public static Var key_grave
        {
            get
            {
                unsafe
                {
                    if (key_grave_ == null)
                    {
                        key_grave_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_grave;
                    }
                }
                return key_grave_;
            }
        }

        /// <summary>
        /// key_caps - see Gamestudio manual
        /// </summary>
        private static Var key_caps_ = null;
        public static Var key_caps
        {
            get
            {
                unsafe
                {
                    if (key_caps_ == null)
                    {
                        key_caps_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_caps;
                    }
                }
                return key_caps_;
            }
        }

        /// <summary>
        /// key_scrlk - see Gamestudio manual
        /// </summary>
        private static Var key_scrlk_ = null;
        public static Var key_scrlk
        {
            get
            {
                unsafe
                {
                    if (key_scrlk_ == null)
                    {
                        key_scrlk_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_scrlk;
                    }
                }
                return key_scrlk_;
            }
        }

        /// <summary>
        /// key_plus - see Gamestudio manual
        /// </summary>
        private static Var key_plus_ = null;
        public static Var key_plus
        {
            get
            {
                unsafe
                {
                    if (key_plus_ == null)
                    {
                        key_plus_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_plus;
                    }
                }
                return key_plus_;
            }
        }

        /// <summary>
        /// key_sz - see Gamestudio manual
        /// </summary>
        private static Var key_sz_ = null;
        public static Var key_sz
        {
            get
            {
                unsafe
                {
                    if (key_sz_ == null)
                    {
                        key_sz_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_sz;
                    }
                }
                return key_sz_;
            }
        }

        /// <summary>
        /// key_ae - see Gamestudio manual
        /// </summary>
        private static Var key_ae_ = null;
        public static Var key_ae
        {
            get
            {
                unsafe
                {
                    if (key_ae_ == null)
                    {
                        key_ae_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_ae;
                    }
                }
                return key_ae_;
            }
        }

        /// <summary>
        /// key_ue - see Gamestudio manual
        /// </summary>
        private static Var key_ue_ = null;
        public static Var key_ue
        {
            get
            {
                unsafe
                {
                    if (key_ue_ == null)
                    {
                        key_ue_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_ue;
                    }
                }
                return key_ue_;
            }
        }

        /// <summary>
        /// key_oe - see Gamestudio manual
        /// </summary>
        private static Var key_oe_ = null;
        public static Var key_oe
        {
            get
            {
                unsafe
                {
                    if (key_oe_ == null)
                    {
                        key_oe_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_oe;
                    }
                }
                return key_oe_;
            }
        }

        /// <summary>
        /// key_1 - see Gamestudio manual
        /// </summary>
        private static Var key_1_ = null;
        public static Var key_1
        {
            get
            {
                unsafe
                {
                    if (key_1_ == null)
                    {
                        key_1_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_1;
                    }
                }
                return key_1_;
            }
        }

        /// <summary>
        /// key_2 - see Gamestudio manual
        /// </summary>
        private static Var key_2_ = null;
        public static Var key_2
        {
            get
            {
                unsafe
                {
                    if (key_2_ == null)
                    {
                        key_2_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_2;
                    }
                }
                return key_2_;
            }
        }

        /// <summary>
        /// key_3 - see Gamestudio manual
        /// </summary>
        private static Var key_3_ = null;
        public static Var key_3
        {
            get
            {
                unsafe
                {
                    if (key_3_ == null)
                    {
                        key_3_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_3;
                    }
                }
                return key_3_;
            }
        }

        /// <summary>
        /// key_4 - see Gamestudio manual
        /// </summary>
        private static Var key_4_ = null;
        public static Var key_4
        {
            get
            {
                unsafe
                {
                    if (key_4_ == null)
                    {
                        key_4_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_4;
                    }
                }
                return key_4_;
            }
        }

        /// <summary>
        /// key_5 - see Gamestudio manual
        /// </summary>
        private static Var key_5_ = null;
        public static Var key_5
        {
            get
            {
                unsafe
                {
                    if (key_5_ == null)
                    {
                        key_5_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_5;
                    }
                }
                return key_5_;
            }
        }

        /// <summary>
        /// key_6 - see Gamestudio manual
        /// </summary>
        private static Var key_6_ = null;
        public static Var key_6
        {
            get
            {
                unsafe
                {
                    if (key_6_ == null)
                    {
                        key_6_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_6;
                    }
                }
                return key_6_;
            }
        }

        /// <summary>
        /// key_7 - see Gamestudio manual
        /// </summary>
        private static Var key_7_ = null;
        public static Var key_7
        {
            get
            {
                unsafe
                {
                    if (key_7_ == null)
                    {
                        key_7_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_7;
                    }
                }
                return key_7_;
            }
        }

        /// <summary>
        /// key_8 - see Gamestudio manual
        /// </summary>
        private static Var key_8_ = null;
        public static Var key_8
        {
            get
            {
                unsafe
                {
                    if (key_8_ == null)
                    {
                        key_8_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_8;
                    }
                }
                return key_8_;
            }
        }

        /// <summary>
        /// key_9 - see Gamestudio manual
        /// </summary>
        private static Var key_9_ = null;
        public static Var key_9
        {
            get
            {
                unsafe
                {
                    if (key_9_ == null)
                    {
                        key_9_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_9;
                    }
                }
                return key_9_;
            }
        }

        /// <summary>
        /// key_0 - see Gamestudio manual
        /// </summary>
        private static Var key_0_ = null;
        public static Var key_0
        {
            get
            {
                unsafe
                {
                    if (key_0_ == null)
                    {
                        key_0_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_0;
                    }
                }
                return key_0_;
            }
        }

        /// <summary>
        /// key_pause - see Gamestudio manual
        /// </summary>
        private static Var key_pause_ = null;
        public static Var key_pause
        {
            get
            {
                unsafe
                {
                    if (key_pause_ == null)
                    {
                        key_pause_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).key_pause;
                    }
                }
                return key_pause_;
            }
        }

        /// <summary>
        /// mouse_left - see Gamestudio manual
        /// </summary>
        private static Var mouse_left_ = null;
        public static Var mouse_left
        {
            get
            {
                unsafe
                {
                    if (mouse_left_ == null)
                    {
                        mouse_left_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_left;
                    }
                }
                return mouse_left_;
            }
        }

        /// <summary>
        /// mouse_right - see Gamestudio manual
        /// </summary>
        private static Var mouse_right_ = null;
        public static Var mouse_right
        {
            get
            {
                unsafe
                {
                    if (mouse_right_ == null)
                    {
                        mouse_right_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_right;
                    }
                }
                return mouse_right_;
            }
        }

        /// <summary>
        /// mouse_middle - see Gamestudio manual
        /// </summary>
        private static Var mouse_middle_ = null;
        public static Var mouse_middle
        {
            get
            {
                unsafe
                {
                    if (mouse_middle_ == null)
                    {
                        mouse_middle_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_middle;
                    }
                }
                return mouse_middle_;
            }
        }

        /// <summary>
        /// joy_1 - see Gamestudio manual
        /// </summary>
        private static Var joy_1_ = null;
        public static Var joy_1
        {
            get
            {
                unsafe
                {
                    if (joy_1_ == null)
                    {
                        joy_1_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_1;
                    }
                }
                return joy_1_;
            }
        }

        /// <summary>
        /// joy_2 - see Gamestudio manual
        /// </summary>
        private static Var joy_2_ = null;
        public static Var joy_2
        {
            get
            {
                unsafe
                {
                    if (joy_2_ == null)
                    {
                        joy_2_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_2;
                    }
                }
                return joy_2_;
            }
        }

        /// <summary>
        /// joy_3 - see Gamestudio manual
        /// </summary>
        private static Var joy_3_ = null;
        public static Var joy_3
        {
            get
            {
                unsafe
                {
                    if (joy_3_ == null)
                    {
                        joy_3_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_3;
                    }
                }
                return joy_3_;
            }
        }

        /// <summary>
        /// joy_4 - see Gamestudio manual
        /// </summary>
        private static Var joy_4_ = null;
        public static Var joy_4
        {
            get
            {
                unsafe
                {
                    if (joy_4_ == null)
                    {
                        joy_4_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_4;
                    }
                }
                return joy_4_;
            }
        }

        /// <summary>
        /// joy_5 - see Gamestudio manual
        /// </summary>
        private static Var joy_5_ = null;
        public static Var joy_5
        {
            get
            {
                unsafe
                {
                    if (joy_5_ == null)
                    {
                        joy_5_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_5;
                    }
                }
                return joy_5_;
            }
        }

        /// <summary>
        /// joy_6 - see Gamestudio manual
        /// </summary>
        private static Var joy_6_ = null;
        public static Var joy_6
        {
            get
            {
                unsafe
                {
                    if (joy_6_ == null)
                    {
                        joy_6_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_6;
                    }
                }
                return joy_6_;
            }
        }

        /// <summary>
        /// joy_7 - see Gamestudio manual
        /// </summary>
        private static Var joy_7_ = null;
        public static Var joy_7
        {
            get
            {
                unsafe
                {
                    if (joy_7_ == null)
                    {
                        joy_7_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_7;
                    }
                }
                return joy_7_;
            }
        }

        /// <summary>
        /// joy_8 - see Gamestudio manual
        /// </summary>
        private static Var joy_8_ = null;
        public static Var joy_8
        {
            get
            {
                unsafe
                {
                    if (joy_8_ == null)
                    {
                        joy_8_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_8;
                    }
                }
                return joy_8_;
            }
        }

        /// <summary>
        /// joy_9 - see Gamestudio manual
        /// </summary>
        private static Var joy_9_ = null;
        public static Var joy_9
        {
            get
            {
                unsafe
                {
                    if (joy_9_ == null)
                    {
                        joy_9_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_9;
                    }
                }
                return joy_9_;
            }
        }

        /// <summary>
        /// joy_10 - see Gamestudio manual
        /// </summary>
        private static Var joy_10_ = null;
        public static Var joy_10
        {
            get
            {
                unsafe
                {
                    if (joy_10_ == null)
                    {
                        joy_10_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_10;
                    }
                }
                return joy_10_;
            }
        }

        /// <summary>
        /// joy_11 - see Gamestudio manual
        /// </summary>
        private static Var joy_11_ = null;
        public static Var joy_11
        {
            get
            {
                unsafe
                {
                    if (joy_11_ == null)
                    {
                        joy_11_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_11;
                    }
                }
                return joy_11_;
            }
        }

        /// <summary>
        /// joy_12 - see Gamestudio manual
        /// </summary>
        private static Var joy_12_ = null;
        public static Var joy_12
        {
            get
            {
                unsafe
                {
                    if (joy_12_ == null)
                    {
                        joy_12_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy_12;
                    }
                }
                return joy_12_;
            }
        }

        /// <summary>
        /// joy2_1 - see Gamestudio manual
        /// </summary>
        private static Var joy2_1_ = null;
        public static Var joy2_1
        {
            get
            {
                unsafe
                {
                    if (joy2_1_ == null)
                    {
                        joy2_1_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_1;
                    }
                }
                return joy2_1_;
            }
        }

        /// <summary>
        /// joy2_2 - see Gamestudio manual
        /// </summary>
        private static Var joy2_2_ = null;
        public static Var joy2_2
        {
            get
            {
                unsafe
                {
                    if (joy2_2_ == null)
                    {
                        joy2_2_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_2;
                    }
                }
                return joy2_2_;
            }
        }

        /// <summary>
        /// joy2_3 - see Gamestudio manual
        /// </summary>
        private static Var joy2_3_ = null;
        public static Var joy2_3
        {
            get
            {
                unsafe
                {
                    if (joy2_3_ == null)
                    {
                        joy2_3_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_3;
                    }
                }
                return joy2_3_;
            }
        }

        /// <summary>
        /// joy2_4 - see Gamestudio manual
        /// </summary>
        private static Var joy2_4_ = null;
        public static Var joy2_4
        {
            get
            {
                unsafe
                {
                    if (joy2_4_ == null)
                    {
                        joy2_4_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_4;
                    }
                }
                return joy2_4_;
            }
        }

        /// <summary>
        /// joy2_5 - see Gamestudio manual
        /// </summary>
        private static Var joy2_5_ = null;
        public static Var joy2_5
        {
            get
            {
                unsafe
                {
                    if (joy2_5_ == null)
                    {
                        joy2_5_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_5;
                    }
                }
                return joy2_5_;
            }
        }

        /// <summary>
        /// joy2_6 - see Gamestudio manual
        /// </summary>
        private static Var joy2_6_ = null;
        public static Var joy2_6
        {
            get
            {
                unsafe
                {
                    if (joy2_6_ == null)
                    {
                        joy2_6_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_6;
                    }
                }
                return joy2_6_;
            }
        }

        /// <summary>
        /// joy2_7 - see Gamestudio manual
        /// </summary>
        private static Var joy2_7_ = null;
        public static Var joy2_7
        {
            get
            {
                unsafe
                {
                    if (joy2_7_ == null)
                    {
                        joy2_7_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_7;
                    }
                }
                return joy2_7_;
            }
        }

        /// <summary>
        /// joy2_8 - see Gamestudio manual
        /// </summary>
        private static Var joy2_8_ = null;
        public static Var joy2_8
        {
            get
            {
                unsafe
                {
                    if (joy2_8_ == null)
                    {
                        joy2_8_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_8;
                    }
                }
                return joy2_8_;
            }
        }

        /// <summary>
        /// joy2_9 - see Gamestudio manual
        /// </summary>
        private static Var joy2_9_ = null;
        public static Var joy2_9
        {
            get
            {
                unsafe
                {
                    if (joy2_9_ == null)
                    {
                        joy2_9_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_9;
                    }
                }
                return joy2_9_;
            }
        }

        /// <summary>
        /// joy2_10 - see Gamestudio manual
        /// </summary>
        private static Var joy2_10_ = null;
        public static Var joy2_10
        {
            get
            {
                unsafe
                {
                    if (joy2_10_ == null)
                    {
                        joy2_10_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_10;
                    }
                }
                return joy2_10_;
            }
        }

        /// <summary>
        /// joy2_11 - see Gamestudio manual
        /// </summary>
        private static Var joy2_11_ = null;
        public static Var joy2_11
        {
            get
            {
                unsafe
                {
                    if (joy2_11_ == null)
                    {
                        joy2_11_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_11;
                    }
                }
                return joy2_11_;
            }
        }

        /// <summary>
        /// joy2_12 - see Gamestudio manual
        /// </summary>
        private static Var joy2_12_ = null;
        public static Var joy2_12
        {
            get
            {
                unsafe
                {
                    if (joy2_12_ == null)
                    {
                        joy2_12_ = (Var)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).joy2_12;
                    }
                }
                return joy2_12_;
            }
        }


        /// <summary>
        /// on_bksp - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_bkspKeepReference;
        public static EventVoid on_bksp
        {
            set
            {
                unsafe
                {
                    on_bkspKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_bksp).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_bkspKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_enter - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_enterKeepReference;
        public static EventVoid on_enter
        {
            set
            {
                unsafe
                {
                    on_enterKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_enter).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_enterKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_esc - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_escKeepReference;
        public static EventVoid on_esc
        {
            set
            {
                unsafe
                {
                    on_escKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_esc).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_escKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_alt - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_altKeepReference;
        public static EventVoid on_alt
        {
            set
            {
                unsafe
                {
                    on_altKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_alt).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_altKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_ctrl - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_ctrlKeepReference;
        public static EventVoid on_ctrl
        {
            set
            {
                unsafe
                {
                    on_ctrlKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_ctrl).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_ctrlKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_shiftl - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_shiftlKeepReference;
        public static EventVoid on_shiftl
        {
            set
            {
                unsafe
                {
                    on_shiftlKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_shiftl).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_shiftlKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_shiftr - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_shiftrKeepReference;
        public static EventVoid on_shiftr
        {
            set
            {
                unsafe
                {
                    on_shiftrKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_shiftr).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_shiftrKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_space - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_spaceKeepReference;
        public static EventVoid on_space
        {
            set
            {
                unsafe
                {
                    on_spaceKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_space).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_spaceKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_tab - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_tabKeepReference;
        public static EventVoid on_tab
        {
            set
            {
                unsafe
                {
                    on_tabKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_tab).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_tabKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f1 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f1KeepReference;
        public static EventVoid on_f1
        {
            set
            {
                unsafe
                {
                    on_f1KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f1).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f1KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f2 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f2KeepReference;
        public static EventVoid on_f2
        {
            set
            {
                unsafe
                {
                    on_f2KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f2).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f2KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f3 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f3KeepReference;
        public static EventVoid on_f3
        {
            set
            {
                unsafe
                {
                    on_f3KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f3).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f3KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f4 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f4KeepReference;
        public static EventVoid on_f4
        {
            set
            {
                unsafe
                {
                    on_f4KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f4).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f4KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f5 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f5KeepReference;
        public static EventVoid on_f5
        {
            set
            {
                unsafe
                {
                    on_f5KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f5).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f5KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f6 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f6KeepReference;
        public static EventVoid on_f6
        {
            set
            {
                unsafe
                {
                    on_f6KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f6).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f6KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f7 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f7KeepReference;
        public static EventVoid on_f7
        {
            set
            {
                unsafe
                {
                    on_f7KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f7).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f7KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f8 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f8KeepReference;
        public static EventVoid on_f8
        {
            set
            {
                unsafe
                {
                    on_f8KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f8).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f8KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f9 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f9KeepReference;
        public static EventVoid on_f9
        {
            set
            {
                unsafe
                {
                    on_f9KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f9).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f9KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f10 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f10KeepReference;
        public static EventVoid on_f10
        {
            set
            {
                unsafe
                {
                    on_f10KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f10).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f10KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f11 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f11KeepReference;
        public static EventVoid on_f11
        {
            set
            {
                unsafe
                {
                    on_f11KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f11).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f11KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f12 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_f12KeepReference;
        public static EventVoid on_f12
        {
            set
            {
                unsafe
                {
                    on_f12KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f12).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_f12KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_a - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_aKeepReference;
        public static EventVoid on_a
        {
            set
            {
                unsafe
                {
                    on_aKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_a).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_aKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_b - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_bKeepReference;
        public static EventVoid on_b
        {
            set
            {
                unsafe
                {
                    on_bKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_b).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_bKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_c - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_cKeepReference;
        public static EventVoid on_c
        {
            set
            {
                unsafe
                {
                    on_cKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_c).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_cKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_d - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_dKeepReference;
        public static EventVoid on_d
        {
            set
            {
                unsafe
                {
                    on_dKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_d).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_dKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_e - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_eKeepReference;
        public static EventVoid on_e
        {
            set
            {
                unsafe
                {
                    on_eKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_e).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_eKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_f - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_fKeepReference;
        public static EventVoid on_f
        {
            set
            {
                unsafe
                {
                    on_fKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_f).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_fKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_g - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_gKeepReference;
        public static EventVoid on_g
        {
            set
            {
                unsafe
                {
                    on_gKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_g).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_gKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_h - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_hKeepReference;
        public static EventVoid on_h
        {
            set
            {
                unsafe
                {
                    on_hKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_h).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_hKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_i - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_iKeepReference;
        public static EventVoid on_i
        {
            set
            {
                unsafe
                {
                    on_iKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_i).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_iKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_j - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_jKeepReference;
        public static EventVoid on_j
        {
            set
            {
                unsafe
                {
                    on_jKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_j).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_jKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_k - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_kKeepReference;
        public static EventVoid on_k
        {
            set
            {
                unsafe
                {
                    on_kKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_k).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_kKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_l - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_lKeepReference;
        public static EventVoid on_l
        {
            set
            {
                unsafe
                {
                    on_lKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_l).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_lKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_m - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_mKeepReference;
        public static EventVoid on_m
        {
            set
            {
                unsafe
                {
                    on_mKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_m).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_mKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_n - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_nKeepReference;
        public static EventVoid on_n
        {
            set
            {
                unsafe
                {
                    on_nKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_n).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_nKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_o - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_oKeepReference;
        public static EventVoid on_o
        {
            set
            {
                unsafe
                {
                    on_oKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_o).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_oKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_p - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_pKeepReference;
        public static EventVoid on_p
        {
            set
            {
                unsafe
                {
                    on_pKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_p).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_pKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_q - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_qKeepReference;
        public static EventVoid on_q
        {
            set
            {
                unsafe
                {
                    on_qKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_q).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_qKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_r - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_rKeepReference;
        public static EventVoid on_r
        {
            set
            {
                unsafe
                {
                    on_rKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_r).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_rKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_s - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_sKeepReference;
        public static EventVoid on_s
        {
            set
            {
                unsafe
                {
                    on_sKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_s).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_sKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_t - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_tKeepReference;
        public static EventVoid on_t
        {
            set
            {
                unsafe
                {
                    on_tKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_t).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_tKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_u - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_uKeepReference;
        public static EventVoid on_u
        {
            set
            {
                unsafe
                {
                    on_uKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_u).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_uKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_v - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_vKeepReference;
        public static EventVoid on_v
        {
            set
            {
                unsafe
                {
                    on_vKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_v).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_vKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_w - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_wKeepReference;
        public static EventVoid on_w
        {
            set
            {
                unsafe
                {
                    on_wKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_w).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_wKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_x - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_xKeepReference;
        public static EventVoid on_x
        {
            set
            {
                unsafe
                {
                    on_xKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_x).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_xKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_y - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_yKeepReference;
        public static EventVoid on_y
        {
            set
            {
                unsafe
                {
                    on_yKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_y).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_yKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_z - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_zKeepReference;
        public static EventVoid on_z
        {
            set
            {
                unsafe
                {
                    on_zKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_z).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_zKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_cuu - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_cuuKeepReference;
        public static EventVoid on_cuu
        {
            set
            {
                unsafe
                {
                    on_cuuKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_cuu).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_cuuKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_cud - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_cudKeepReference;
        public static EventVoid on_cud
        {
            set
            {
                unsafe
                {
                    on_cudKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_cud).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_cudKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_cur - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_curKeepReference;
        public static EventVoid on_cur
        {
            set
            {
                unsafe
                {
                    on_curKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_cur).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_curKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_cul - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_culKeepReference;
        public static EventVoid on_cul
        {
            set
            {
                unsafe
                {
                    on_culKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_cul).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_culKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_pgup - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_pgupKeepReference;
        public static EventVoid on_pgup
        {
            set
            {
                unsafe
                {
                    on_pgupKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_pgup).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_pgupKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_pgdn - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_pgdnKeepReference;
        public static EventVoid on_pgdn
        {
            set
            {
                unsafe
                {
                    on_pgdnKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_pgdn).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_pgdnKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_home - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_homeKeepReference;
        public static EventVoid on_home
        {
            set
            {
                unsafe
                {
                    on_homeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_home).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_homeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_end - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_endKeepReference;
        public static EventVoid on_end
        {
            set
            {
                unsafe
                {
                    on_endKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_end).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_endKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_ins - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_insKeepReference;
        public static EventVoid on_ins
        {
            set
            {
                unsafe
                {
                    on_insKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_ins).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_insKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_del - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_delKeepReference;
        public static EventVoid on_del
        {
            set
            {
                unsafe
                {
                    on_delKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_del).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_delKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_car - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_carKeepReference;
        public static EventVoid on_car
        {
            set
            {
                unsafe
                {
                    on_carKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_car).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_carKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_cal - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_calKeepReference;
        public static EventVoid on_cal
        {
            set
            {
                unsafe
                {
                    on_calKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_cal).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_calKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_slash - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_slashKeepReference;
        public static EventVoid on_slash
        {
            set
            {
                unsafe
                {
                    on_slashKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_slash).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_slashKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_equals - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_equalsKeepReference;
        public static EventVoid on_equals
        {
            set
            {
                unsafe
                {
                    on_equalsKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_equals).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_equalsKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_period - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_periodKeepReference;
        public static EventVoid on_period
        {
            set
            {
                unsafe
                {
                    on_periodKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_period).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_periodKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_comma - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_commaKeepReference;
        public static EventVoid on_comma
        {
            set
            {
                unsafe
                {
                    on_commaKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_comma).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_commaKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_brackl - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_bracklKeepReference;
        public static EventVoid on_brackl
        {
            set
            {
                unsafe
                {
                    on_bracklKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_brackl).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_bracklKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_brackr - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_brackrKeepReference;
        public static EventVoid on_brackr
        {
            set
            {
                unsafe
                {
                    on_brackrKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_brackr).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_brackrKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_semic - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_semicKeepReference;
        public static EventVoid on_semic
        {
            set
            {
                unsafe
                {
                    on_semicKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_semic).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_semicKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_bksl - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_bkslKeepReference;
        public static EventVoid on_bksl
        {
            set
            {
                unsafe
                {
                    on_bkslKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_bksl).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_bkslKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_apos - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_aposKeepReference;
        public static EventVoid on_apos
        {
            set
            {
                unsafe
                {
                    on_aposKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_apos).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_aposKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_minusc - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_minuscKeepReference;
        public static EventVoid on_minusc
        {
            set
            {
                unsafe
                {
                    on_minuscKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_minusc).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_minuscKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_grave - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_graveKeepReference;
        public static EventVoid on_grave
        {
            set
            {
                unsafe
                {
                    on_graveKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_grave).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_graveKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_caps - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_capsKeepReference;
        public static EventVoid on_caps
        {
            set
            {
                unsafe
                {
                    on_capsKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_caps).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_capsKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_scrlk - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_scrlkKeepReference;
        public static EventVoid on_scrlk
        {
            set
            {
                unsafe
                {
                    on_scrlkKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_scrlk).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_scrlkKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_plus - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_plusKeepReference;
        public static EventVoid on_plus
        {
            set
            {
                unsafe
                {
                    on_plusKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_plus).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_plusKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_sz - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_szKeepReference;
        public static EventVoid on_sz
        {
            set
            {
                unsafe
                {
                    on_szKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_sz).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_szKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_ae - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_aeKeepReference;
        public static EventVoid on_ae
        {
            set
            {
                unsafe
                {
                    on_aeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_ae).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_aeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_ue - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_ueKeepReference;
        public static EventVoid on_ue
        {
            set
            {
                unsafe
                {
                    on_ueKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_ue).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_ueKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_oe - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_oeKeepReference;
        public static EventVoid on_oe
        {
            set
            {
                unsafe
                {
                    on_oeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_oe).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_oeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_1 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_1KeepReference;
        public static EventVoid on_1
        {
            set
            {
                unsafe
                {
                    on_1KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_1).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_1KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_2 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_2KeepReference;
        public static EventVoid on_2
        {
            set
            {
                unsafe
                {
                    on_2KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_2).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_2KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_3 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_3KeepReference;
        public static EventVoid on_3
        {
            set
            {
                unsafe
                {
                    on_3KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_3).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_3KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_4 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_4KeepReference;
        public static EventVoid on_4
        {
            set
            {
                unsafe
                {
                    on_4KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_4).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_4KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_5 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_5KeepReference;
        public static EventVoid on_5
        {
            set
            {
                unsafe
                {
                    on_5KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_5).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_5KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_6 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_6KeepReference;
        public static EventVoid on_6
        {
            set
            {
                unsafe
                {
                    on_6KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_6).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_6KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_7 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_7KeepReference;
        public static EventVoid on_7
        {
            set
            {
                unsafe
                {
                    on_7KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_7).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_7KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_8 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_8KeepReference;
        public static EventVoid on_8
        {
            set
            {
                unsafe
                {
                    on_8KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_8).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_8KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_9 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_9KeepReference;
        public static EventVoid on_9
        {
            set
            {
                unsafe
                {
                    on_9KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_9).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_9KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_0 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_0KeepReference;
        public static EventVoid on_0
        {
            set
            {
                unsafe
                {
                    on_0KeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_0).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_0KeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_pause - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_pauseKeepReference;
        public static EventVoid on_pause
        {
            set
            {
                unsafe
                {
                    on_pauseKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_pause).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_pauseKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_mouse_left - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_mouse_leftKeepReference;
        public static EventVar on_mouse_left
        {
            set
            {
                unsafe
                {
                    on_mouse_leftKeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_mouse_left).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_mouse_leftKeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_mouse_right - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_mouse_rightKeepReference;
        public static EventVar on_mouse_right
        {
            set
            {
                unsafe
                {
                    on_mouse_rightKeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_mouse_right).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_mouse_rightKeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_mouse_middle - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_mouse_middleKeepReference;
        public static EventVar on_mouse_middle
        {
            set
            {
                unsafe
                {
                    on_mouse_middleKeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_mouse_middle).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_mouse_middleKeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy1 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy1KeepReference;
        public static EventVar on_joy1
        {
            set
            {
                unsafe
                {
                    on_joy1KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy1).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy1KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2KeepReference;
        public static EventVar on_joy2
        {
            set
            {
                unsafe
                {
                    on_joy2KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy3 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy3KeepReference;
        public static EventVar on_joy3
        {
            set
            {
                unsafe
                {
                    on_joy3KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy3).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy3KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy4 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy4KeepReference;
        public static EventVar on_joy4
        {
            set
            {
                unsafe
                {
                    on_joy4KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy4).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy4KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy5 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy5KeepReference;
        public static EventVar on_joy5
        {
            set
            {
                unsafe
                {
                    on_joy5KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy5).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy5KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy6 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy6KeepReference;
        public static EventVar on_joy6
        {
            set
            {
                unsafe
                {
                    on_joy6KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy6).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy6KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy7 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy7KeepReference;
        public static EventVar on_joy7
        {
            set
            {
                unsafe
                {
                    on_joy7KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy7).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy7KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy8 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy8KeepReference;
        public static EventVar on_joy8
        {
            set
            {
                unsafe
                {
                    on_joy8KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy8).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy8KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy9 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy9KeepReference;
        public static EventVar on_joy9
        {
            set
            {
                unsafe
                {
                    on_joy9KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy9).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy9KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy10 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy10KeepReference;
        public static EventVar on_joy10
        {
            set
            {
                unsafe
                {
                    on_joy10KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy10).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy10KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy11 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy11KeepReference;
        public static EventVar on_joy11
        {
            set
            {
                unsafe
                {
                    on_joy11KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy11).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy11KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy12 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy12KeepReference;
        public static EventVar on_joy12
        {
            set
            {
                unsafe
                {
                    on_joy12KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy12).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy12KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_1 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_1KeepReference;
        public static EventVar on_joy2_1
        {
            set
            {
                unsafe
                {
                    on_joy2_1KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_1).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_1KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_2 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_2KeepReference;
        public static EventVar on_joy2_2
        {
            set
            {
                unsafe
                {
                    on_joy2_2KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_2).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_2KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_3 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_3KeepReference;
        public static EventVar on_joy2_3
        {
            set
            {
                unsafe
                {
                    on_joy2_3KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_3).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_3KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_4 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_4KeepReference;
        public static EventVar on_joy2_4
        {
            set
            {
                unsafe
                {
                    on_joy2_4KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_4).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_4KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_5 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_5KeepReference;
        public static EventVar on_joy2_5
        {
            set
            {
                unsafe
                {
                    on_joy2_5KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_5).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_5KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_6 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_6KeepReference;
        public static EventVar on_joy2_6
        {
            set
            {
                unsafe
                {
                    on_joy2_6KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_6).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_6KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_7 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_7KeepReference;
        public static EventVar on_joy2_7
        {
            set
            {
                unsafe
                {
                    on_joy2_7KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_7).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_7KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_8 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_8KeepReference;
        public static EventVar on_joy2_8
        {
            set
            {
                unsafe
                {
                    on_joy2_8KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_8).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_8KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_9 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_9KeepReference;
        public static EventVar on_joy2_9
        {
            set
            {
                unsafe
                {
                    on_joy2_9KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_9).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_9KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_10 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_10KeepReference;
        public static EventVar on_joy2_10
        {
            set
            {
                unsafe
                {
                    on_joy2_10KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_10).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_10KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_11 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_11KeepReference;
        public static EventVar on_joy2_11
        {
            set
            {
                unsafe
                {
                    on_joy2_11KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_11).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_11KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_joy2_12 - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_joy2_12KeepReference;
        public static EventVar on_joy2_12
        {
            set
            {
                unsafe
                {
                    on_joy2_12KeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_joy2_12).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_joy2_12KeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_anykey - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_anykeyKeepReference;
        public static EventVar on_anykey
        {
            set
            {
                unsafe
                {
                    on_anykeyKeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_anykey).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_anykeyKeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_click - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_clickKeepReference;
        public static EventVoid on_click
        {
            set
            {
                unsafe
                {
                    on_clickKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_click).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_clickKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_mouse_stop - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_mouse_stopKeepReference;
        public static EventVoid on_mouse_stop
        {
            set
            {
                unsafe
                {
                    on_mouse_stopKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_mouse_stop).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_mouse_stopKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_close - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_closeKeepReference;
        public static EventVoid on_close
        {
            set
            {
                unsafe
                {
                    on_closeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_close).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_closeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_load - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_loadKeepReference;
        public static EventVoid on_load
        {
            set
            {
                unsafe
                {
                    on_loadKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_load).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_loadKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_level - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVarReference on_levelKeepReference;
        public static EventVar on_level
        {
            set
            {
                unsafe
                {
                    on_levelKeepReference = new Scheduler.EventVarReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_level).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVar)on_levelKeepReference.NativeEventVarFunc);
                }
            }
        }


        /// <summary>
        /// on_server - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventOnServerReference on_serverKeepReference;
        public static EventOnServer on_server
        {
            set
            {
                unsafe
                {
                    on_serverKeepReference = new Scheduler.EventOnServerReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_server).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventOnServer)on_serverKeepReference.NativeEventOnServerFunc);
                }
            }
        }


        /// <summary>
        /// on_client - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventIntPtrReference on_clientKeepReference;
        public static EventIntPtr on_client
        {
            set
            {
                unsafe
                {
                    on_clientKeepReference = new Scheduler.EventIntPtrReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_client).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventIntPtr)on_clientKeepReference.NativeEventIntPtrFunc);
                }
            }
        }


        /// <summary>
        /// on_d3d_lost - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_d3d_lostKeepReference;
        public static EventVoid on_d3d_lost
        {
            set
            {
                unsafe
                {
                    on_d3d_lostKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_d3d_lost).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_d3d_lostKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_d3d_reset - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_d3d_resetKeepReference;
        public static EventVoid on_d3d_reset
        {
            set
            {
                unsafe
                {
                    on_d3d_resetKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_d3d_reset).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_d3d_resetKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// render_sky - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference render_skyKeepReference;
        public static EventVoid render_sky
        {
            set
            {
                unsafe
                {
                    render_skyKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).render_sky).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)render_skyKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// render_world - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference render_worldKeepReference;
        public static EventVoid render_world
        {
            set
            {
                unsafe
                {
                    render_worldKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).render_world).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)render_worldKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// render_entities - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference render_entitiesKeepReference;
        public static EventVoid render_entities
        {
            set
            {
                unsafe
                {
                    render_entitiesKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).render_entities).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)render_entitiesKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// render_solid - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference render_solidKeepReference;
        public static EventVoid render_solid
        {
            set
            {
                unsafe
                {
                    render_solidKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).render_solid).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)render_solidKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_exit - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_exitKeepReference;
        public static EventVoid on_exit
        {
            set
            {
                unsafe
                {
                    on_exitKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_exit).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_exitKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_frame - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_frameKeepReference;
        public static EventVoid on_frame
        {
            set
            {
                unsafe
                {
                    on_frameKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_frame).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_frameKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_message - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventOnMessageReference on_messageKeepReference;
        public static EventOnMessage on_message
        {
            get
            {
                unsafe
                {
                    return (EventOnMessage)Marshal.GetDelegateForFunctionPointer((IntPtr)(void*)(*(*((NativeENGINE_VARS*)EngineVarPtr)).on_message).mPtr, typeof(EventOnMessage));
                }
            }
            set
            {
                unsafe
                {
                    on_messageKeepReference = new Scheduler.EventOnMessageReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_message).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventOnMessage)on_messageKeepReference.NativeEventOnMessageFunc);
                }
            }
        }


        /// <summary>
        /// on_maximize - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_maximizeKeepReference;
        public static EventVoid on_maximize
        {
            set
            {
                unsafe
                {
                    on_maximizeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_maximize).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_maximizeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_minimize - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_minimizeKeepReference;
        public static EventVoid on_minimize
        {
            set
            {
                unsafe
                {
                    on_minimizeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_minimize).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_minimizeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// on_resize - see Gamestudio manual 
        /// </summary>
        private static Scheduler.EventVoidReference on_resizeKeepReference;
        public static EventVoid on_resize
        {
            set
            {
                unsafe
                {
                    on_resizeKeepReference = new Scheduler.EventVoidReference(value);
                    (*(*((NativeENGINE_VARS*)EngineVarPtr)).on_resize).mPtr = (byte*)(void*)Marshal.GetFunctionPointerForDelegate((NativeEventVoid)on_resizeKeepReference.NativeEventVoidFunc);
                }
            }
        }


        /// <summary>
        /// camera - see Gamestudio manual
        /// </summary>
        public static VIEW camera
        {
            get
            {
                unsafe
                {
                    return (VIEW)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).camera;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).camera = (NativeVIEW*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// light_view - see Gamestudio manual
        /// </summary>
        public static VIEW light_view
        {
            get
            {
                unsafe
                {
                    return (VIEW)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).light_view;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).light_view = (NativeVIEW*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_view - see Gamestudio manual
        /// </summary>
        public static VIEW render_view
        {
            get
            {
                unsafe
                {
                    return (VIEW)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_view;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_view = (NativeVIEW*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// watched - see Gamestudio manual
        /// </summary>
        public static ENTITY watched
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).watched;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).watched = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// me - see Gamestudio manual
        /// </summary>
        public static ENTITY me
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).me;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).me = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// you - see Gamestudio manual
        /// </summary>
        public static ENTITY you
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).you;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).you = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// sky_cube_level - see Gamestudio manual
        /// </summary>
        public static ENTITY sky_cube_level
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_cube_level;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).sky_cube_level = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// sky_dome_level - see Gamestudio manual
        /// </summary>
        public static ENTITY sky_dome_level
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).sky_dome_level;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).sky_dome_level = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mouse_ent - see Gamestudio manual
        /// </summary>
        public static ENTITY mouse_ent
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_ent;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mouse_ent = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mouse_map - see Gamestudio manual
        /// </summary>
        public static BMAP mouse_map
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_map;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mouse_map = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_map_1 - see Gamestudio manual
        /// </summary>
        public static BMAP render_map_1
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_map_1;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_map_1 = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_map_2 - see Gamestudio manual
        /// </summary>
        public static BMAP render_map_2
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_map_2;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_map_2 = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_map_3 - see Gamestudio manual
        /// </summary>
        public static BMAP render_map_3
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_map_3;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_map_3 = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_map_4 - see Gamestudio manual
        /// </summary>
        public static BMAP render_map_4
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_map_4;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_map_4 = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_mesh - see Gamestudio manual
        /// </summary>
        public static IntPtr render_mesh
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_mesh;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_mesh = (void*)value;
                }
            }
        }


        /// <summary>
        /// mtl - see Gamestudio manual
        /// </summary>
        public static MATERIAL mtl
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mtl;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mtl = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_flat - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_flat
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_flat;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_flat = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_shaded - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_shaded
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_shaded;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_shaded = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_model - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_model
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_model;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_model = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_terrain - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_terrain
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_terrain;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_terrain = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_sprite - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_sprite
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_sprite;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_sprite = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_particle - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_particle
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_particle;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_particle = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_metal - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_metal
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_metal;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_metal = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_sky - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_sky
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_sky;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_sky = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_shadow - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_shadow
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_shadow;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_shadow = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mat_unlit - see Gamestudio manual
        /// </summary>
        public static MATERIAL mat_unlit
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mat_unlit;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mat_unlit = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// debug_str - see Gamestudio manual
        /// </summary>
        public static String debug_str
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).debug_str).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).debug_str = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// watch_str - see Gamestudio manual
        /// </summary>
        public static String watch_str
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).watch_str).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).watch_str = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// delimit_str - see Gamestudio manual
        /// </summary>
        public static String delimit_str
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).delimit_str).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).delimit_str = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// tex_name - see Gamestudio manual
        /// </summary>
        public static String tex_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).tex_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).tex_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// app_name - see Gamestudio manual
        /// </summary>
        public static String app_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).app_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).app_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// level_name - see Gamestudio manual
        /// </summary>
        public static String level_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).level_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).level_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// player_name - see Gamestudio manual
        /// </summary>
        public static String player_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).player_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).player_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// session_name - see Gamestudio manual
        /// </summary>
        public static String session_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).session_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).session_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// server_name - see Gamestudio manual
        /// </summary>
        public static String server_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).server_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).server_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// server_ip - see Gamestudio manual
        /// </summary>
        public static String server_ip
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).server_ip).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).server_ip = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// work_dir - see Gamestudio manual
        /// </summary>
        public static String work_dir
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).work_dir).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).work_dir = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// save_dir - see Gamestudio manual
        /// </summary>
        public static String save_dir
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).save_dir).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).save_dir = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// exe_dir - see Gamestudio manual
        /// </summary>
        public static String exe_dir
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).exe_dir).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).exe_dir = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// player - see Gamestudio manual
        /// </summary>
        public static ENTITY player
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).player;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).player = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// user_name - see Gamestudio manual
        /// </summary>
        public static String user_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).user_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).user_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// passable_ent - see Gamestudio manual
        /// </summary>
        public static ENTITY passable_ent
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).passable_ent;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).passable_ent = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// path_name - see Gamestudio manual
        /// </summary>
        public static String path_name
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).path_name).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).path_name = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// command_str - see Gamestudio manual
        /// </summary>
        public static String command_str
        {
            get
            {
                unsafe
                {
                    return Marshal.PtrToStringAnsi((IntPtr)(*(*((NativeENGINE_VARS*)EngineVarPtr)).command_str).chars);
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).command_str = (NativeSTRING*)(IntPtr)EngFun.str_create(value);
                }
            }
        }


        /// <summary>
        /// level_ent - see Gamestudio manual
        /// </summary>
        public static ENTITY level_ent
        {
            get
            {
                unsafe
                {
                    return (ENTITY)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).level_ent;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).level_ent = (NativeENTITY*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// mouse_panel - see Gamestudio manual
        /// </summary>
        public static PANEL mouse_panel
        {
            get
            {
                unsafe
                {
                    return (PANEL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).mouse_panel;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).mouse_panel = (NativePANEL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_d3dmaterial - see Gamestudio manual
        /// </summary>
        public static IntPtr render_d3dmaterial
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_d3dmaterial;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_d3dmaterial = (void*)value;
                }
            }
        }


        /// <summary>
        /// render_d3dxeffect - see Gamestudio manual
        /// </summary>
        public static IntPtr render_d3dxeffect
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_d3dxeffect;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_d3dxeffect = (void*)value;
                }
            }
        }


        /// <summary>
        /// render_material - see Gamestudio manual
        /// </summary>
        public static MATERIAL render_material
        {
            get
            {
                unsafe
                {
                    return (MATERIAL)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_material;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_material = (NativeMATERIAL*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_target - see Gamestudio manual
        /// </summary>
        public static BMAP render_target
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_target;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_target = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_stencil - see Gamestudio manual
        /// </summary>
        public static BMAP render_stencil
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_stencil;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_stencil = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// render_zbuffer - see Gamestudio manual
        /// </summary>
        public static IntPtr render_zbuffer
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).render_zbuffer;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).render_zbuffer = (void*)value;
                }
            }
        }


        /// <summary>
        /// video_overlay - see Gamestudio manual
        /// </summary>
        public static BMAP video_overlay
        {
            get
            {
                unsafe
                {
                    return (BMAP)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).video_overlay;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).video_overlay = (NativeBMAP*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// hit - see Gamestudio manual
        /// </summary>
        public static CONTACT hit
        {
            get
            {
                unsafe
                {
                    return (CONTACT)(IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).hit;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).hit = (NativeCONTACT*)(IntPtr)value;
                }
            }
        }


        /// <summary>
        /// matTexture - see Gamestudio manual
        /// </summary>
        public static float[][] matTexture
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matTexture + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matTexture + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matEffect - see Gamestudio manual
        /// </summary>
        public static float[][] matEffect
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matEffect + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matEffect + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matView - see Gamestudio manual
        /// </summary>
        public static float[][] matView
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matView + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matView + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matViewInv - see Gamestudio manual
        /// </summary>
        public static float[][] matViewInv
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matViewInv + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matViewInv + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matProj - see Gamestudio manual
        /// </summary>
        public static float[][] matProj
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matProj + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matProj + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matWorld - see Gamestudio manual
        /// </summary>
        public static float[][] matWorld
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matWorld + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matWorld + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// matViewProj - see Gamestudio manual
        /// </summary>
        public static float[][] matViewProj
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).matViewProj + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).matViewProj + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// pdi - see Gamestudio manual
        /// </summary>
        public static IntPtr pdi
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdi;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdi = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdimouse - see Gamestudio manual
        /// </summary>
        public static IntPtr pdimouse
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdimouse;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdimouse = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdikbd - see Gamestudio manual
        /// </summary>
        public static IntPtr pdikbd
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdikbd;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdikbd = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdijoy - see Gamestudio manual
        /// </summary>
        public static IntPtr pdijoy
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdijoy;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdijoy = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdplayclient - see Gamestudio manual
        /// </summary>
        public static IntPtr pdplayclient
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdplayclient;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdplayclient = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdplayserver - see Gamestudio manual
        /// </summary>
        public static IntPtr pdplayserver
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdplayserver;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdplayserver = (void*)value;
                }
            }
        }


        /// <summary>
        /// pds - see Gamestudio manual
        /// </summary>
        public static IntPtr pds
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pds;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pds = (void*)value;
                }
            }
        }


        /// <summary>
        /// pdsb - see Gamestudio manual
        /// </summary>
        public static IntPtr pdsb
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdsb;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdsb = (void*)value;
                }
            }
        }


        /// <summary>
        /// pd3d - see Gamestudio manual
        /// </summary>
        public static IntPtr pd3d
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pd3d;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pd3d = (void*)value;
                }
            }
        }


        /// <summary>
        /// pd3ddev - see Gamestudio manual
        /// </summary>
        public static IntPtr pd3ddev
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pd3ddev;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pd3ddev = (void*)value;
                }
            }
        }


        /// <summary>
        /// hWnd - see Gamestudio manual
        /// </summary>
        public static IntPtr hWnd
        {
            get
            {
                unsafe
                {
                    return (*((NativeENGINE_VARS*)EngineVarPtr)).hWnd;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).hWnd = value;
                }
            }
        }


        /// <summary>
        /// pd3dcaps - see Gamestudio manual
        /// </summary>
        public static IntPtr pd3dcaps
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pd3dcaps;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pd3dcaps = (void*)value;
                }
            }
        }


        /// <summary>
        /// hInstance - see Gamestudio manual
        /// </summary>
        public static int hInstance
        {
            get
            {
                unsafe
                {
                    return (*((NativeENGINE_VARS*)EngineVarPtr)).hInstance;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).hInstance = value;
                }
            }
        }


        /// <summary>
        /// hWndTarget - see Gamestudio manual
        /// </summary>
        public static IntPtr hWndTarget
        {
            get
            {
                unsafe
                {
                    return (*((NativeENGINE_VARS*)EngineVarPtr)).hWndTarget;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).hWndTarget = value;
                }
            }
        }


        /// <summary>
        /// pRectTarget - see Gamestudio manual
        /// </summary>
        public static IntPtr pRectTarget
        {
            get
            {
                unsafe
                {
                    return (*((NativeENGINE_VARS*)EngineVarPtr)).pRectTarget;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pRectTarget = value;
                }
            }
        }


        /// <summary>
        /// pPaths - see Gamestudio manual
        /// </summary>
        public static String[] pPaths
        {
            get
            {
                unsafe
                {
                    char** pString = (char**)(*((NativeENGINE_VARS*)EngineVarPtr)).pPaths;

                    String[] returnTemp = new String[32];   //up to 32 Strings
                    char* returnCharArray = *(pString);
                    int i = 0;
                    for (; returnCharArray != null; i++)
                    {
                        returnTemp[i] = Marshal.PtrToStringAnsi((IntPtr)returnCharArray);
                        returnCharArray = *(pString + i + 1);
                    }
                    String[] returnString = new String[i];
                    for (int j = 0; j < i; j++)
                    {
                        returnString[j] = returnTemp[j];
                    }

                    return returnString;
                }
            }
            set
            {
                unsafe
                {
                    int size = value.Length;

                    char** pChar = (char**)(*((NativeENGINE_VARS*)EngineVarPtr)).pPaths;
                    char* tempCharArray;
                    int i = 0;
                    for (; i < size; i++)
                    {
                        tempCharArray = *(pChar + i);
                        tempCharArray = (char*)(void*)Marshal.StringToHGlobalAnsi(value[i]);
                    }
                    tempCharArray = *(pChar + i);
                    tempCharArray = (char*)(void*)Marshal.StringToHGlobalAnsi(null);    //null terminate this char array
                }
            }
        }

        /// <summary>
        /// pVars - see Gamestudio manual
        /// </summary>
        public static IntPtr pVars
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pVars;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pVars = (void*)value;
                }
            }
        }


        /// <summary>
        /// hWndParent - see Gamestudio manual
        /// </summary>
        public static IntPtr hWndParent
        {
            get
            {
                unsafe
                {
                    return (*((NativeENGINE_VARS*)EngineVarPtr)).hWndParent;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).hWndParent = value;
                }
            }
        }


        /// <summary>
        /// pdsbs - see Gamestudio manual
        /// </summary>
        public static IntPtr pdsbs
        {
            get
            {
                unsafe
                {
                    return (IntPtr)(*((NativeENGINE_VARS*)EngineVarPtr)).pdsbs;
                }
            }
            set
            {
                unsafe
                {
                    (*((NativeENGINE_VARS*)EngineVarPtr)).pdsbs = (void*)value;
                }
            }
        }


        /// <summary>
        /// mat_effect1 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect1
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect1 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect1 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect2 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect2
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect2 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect2 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect3 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect3
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect3 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect3 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect4 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect4
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect4 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect4 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect5 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect5
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect5 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect5 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect6 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect6
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect6 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect6 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect7 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect7
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect7 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect7 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }


        /// <summary>
        /// mat_effect8 - see Gamestudio manual
        /// </summary>
        public static float[][] mat_effect8
        {
            get
            {
                unsafe
                {
                    float[][] returnMatrix = new float[4][];    //create a row
                    for (int i = 0; i < 4; i++)
                    {
                        returnMatrix[i] = new float[4];         //create the columns for the row
                        for (int j = 0; j < 4; j++)
                        {
                            returnMatrix[i][j] = *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect8 + i * 4 + j);
                        }
                    }
                    return returnMatrix;
                }
            }
            set
            {
                unsafe
                {
                    for (int i = 0; i < 4; i++)
                    {
                        for (int j = 0; j < 4; j++)
                        {
                            *((*((NativeENGINE_VARS*)EngineVarPtr)).mat_effect8 + i * 4 + j) = value[i][j];
                        }
                    }
                }
            }
        }

        /// <summary>
        /// EVENT types
        /// </summary>
        public enum EVENT_DEFINITIONS : int
        {
            EVENT_BLOCK = 1,
            EVENT_ENTITY = 2,
            EVENT_STUCK = 3,
            EVENT_PUSH = 4,
            EVENT_IMPACT = 5,
            EVENT_FRICTION = 6,
            EVENT_DETECT = 7,
            EVENT_SCAN = 8,
            EVENT_SHOOT = 9,
            EVENT_TRIGGER = 10,
            EVENT_SONAR = 11,
            EVENT_FRAME = 12,
            EVENT_RECEIVE = 13,
            EVENT_CLICKUP = 14,
            EVENT_BUTTONUP = 15,
            EVENT_TOUCH = 16,
            EVENT_RELEASE = 17,
            EVENT_CLICK = 18,
            EVENT_RIGHTCLICK = 19,
            EVENT_DISCONNECT = 20,
            EVENT_JOIN = 32,
            EVENT_LEAVE = 33,
            EVENT_STRING = 34,
            EVENT_DATA = 36,
            EVENT_VAR = 37
        }

    }
}